"use strict";/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var K=["require","exports","vs/editor/common/core/range","vs/editor/common/core/position","vs/base/common/strings","vs/base/common/platform","vs/base/common/errors","vs/base/common/lifecycle","vs/base/common/event","vs/editor/common/diff/algorithms/diffAlgorithm","vs/base/common/assert","vs/base/common/objects","vs/base/common/uri","vs/base/common/functional","vs/base/common/iterator","vs/base/common/linkedList","vs/base/common/stopwatch","vs/base/common/cancellation","vs/base/common/diff/diff","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/diff/linesDiffComputer","vs/editor/common/diff/smartLinesDiffComputer","vs/base/common/codicons","vs/base/common/diff/diffChange","vs/base/common/arrays","vs/base/common/keyCodes","vs/base/common/lazy","vs/base/common/process","vs/base/common/path","vs/base/common/cache","vs/base/common/hash","vs/base/common/types","vs/editor/common/core/selection","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/diff/algorithms/joinSequenceDiffs","vs/editor/common/diff/algorithms/myersDiffAlgorithm","vs/editor/common/diff/algorithms/utils","vs/editor/common/diff/algorithms/dynamicProgrammingDiffing","vs/editor/common/diff/standardLinesDiffComputer","vs/editor/common/diff/linesDiffComputers","vs/editor/common/languages/linkComputer","vs/editor/common/languages/supports/inplaceReplaceSupport","vs/editor/common/model","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/textModelSearch","vs/editor/common/services/unicodeTextModelHighlighter","vs/editor/common/standalone/standaloneEnums","vs/editor/common/tokenizationRegistry","vs/editor/common/languages","vs/editor/common/services/editorBaseApi","vs/css","vs/base/common/worker/simpleWorker","vs/editor/common/services/editorSimpleWorker"],x=function(B){for(var n=[],E=0,t=B.length;E<t;E++)n[E]=K[B[E]];return n},Ue=this,Oe=typeof global=="object"?global:{},le;(function(B){B.global=Ue;var n=function(){function E(){this._detected=!1,this._isWindows=!1,this._isNode=!1,this._isElectronRenderer=!1,this._isWebWorker=!1,this._isElectronNodeIntegrationWebWorker=!1}return Object.defineProperty(E.prototype,"isWindows",{get:function(){return this._detect(),this._isWindows},enumerable:!1,configurable:!0}),Object.defineProperty(E.prototype,"isNode",{get:function(){return this._detect(),this._isNode},enumerable:!1,configurable:!0}),Object.defineProperty(E.prototype,"isElectronRenderer",{get:function(){return this._detect(),this._isElectronRenderer},enumerable:!1,configurable:!0}),Object.defineProperty(E.prototype,"isWebWorker",{get:function(){return this._detect(),this._isWebWorker},enumerable:!1,configurable:!0}),Object.defineProperty(E.prototype,"isElectronNodeIntegrationWebWorker",{get:function(){return this._detect(),this._isElectronNodeIntegrationWebWorker},enumerable:!1,configurable:!0}),E.prototype._detect=function(){this._detected||(this._detected=!0,this._isWindows=E._isWindows(),this._isNode=typeof module<"u"&&!!module.exports,this._isElectronRenderer=typeof process<"u"&&typeof process.versions<"u"&&typeof process.versions.electron<"u"&&process.type==="renderer",this._isWebWorker=typeof B.global.importScripts=="function",this._isElectronNodeIntegrationWebWorker=this._isWebWorker&&typeof process<"u"&&typeof process.versions<"u"&&typeof process.versions.electron<"u"&&process.type==="worker")},E._isWindows=function(){return typeof navigator<"u"&&navigator.userAgent&&navigator.userAgent.indexOf("Windows")>=0?!0:typeof process<"u"?process.platform==="win32":!1},E}();B.Environment=n})(le||(le={}));var le;(function(B){var n=function(){function D(c,_,h){this.type=c,this.detail=_,this.timestamp=h}return D}();B.LoaderEvent=n;var E=function(){function D(c){this._events=[new n(1,"",c)]}return D.prototype.record=function(c,_){this._events.push(new n(c,_,B.Utilities.getHighPerformanceTimestamp()))},D.prototype.getEvents=function(){return this._events},D}();B.LoaderEventRecorder=E;var t=function(){function D(){}return D.prototype.record=function(c,_){},D.prototype.getEvents=function(){return[]},D.INSTANCE=new D,D}();B.NullLoaderEventRecorder=t})(le||(le={}));var le;(function(B){var n=function(){function E(){}return E.fileUriToFilePath=function(t,D){if(D=decodeURI(D).replace(/%23/g,"#"),t){if(/^file:\/\/\//.test(D))return D.substr(8);if(/^file:\/\//.test(D))return D.substr(5)}else if(/^file:\/\//.test(D))return D.substr(7);return D},E.startsWith=function(t,D){return t.length>=D.length&&t.substr(0,D.length)===D},E.endsWith=function(t,D){return t.length>=D.length&&t.substr(t.length-D.length)===D},E.containsQueryString=function(t){return/^[^\#]*\?/gi.test(t)},E.isAbsolutePath=function(t){return/^((http:\/\/)|(https:\/\/)|(file:\/\/)|(\/))/.test(t)},E.forEachProperty=function(t,D){if(t){var c=void 0;for(c in t)t.hasOwnProperty(c)&&D(c,t[c])}},E.isEmpty=function(t){var D=!0;return E.forEachProperty(t,function(){D=!1}),D},E.recursiveClone=function(t){if(!t||typeof t!="object"||t instanceof RegExp||!Array.isArray(t)&&Object.getPrototypeOf(t)!==Object.prototype)return t;var D=Array.isArray(t)?[]:{};return E.forEachProperty(t,function(c,_){_&&typeof _=="object"?D[c]=E.recursiveClone(_):D[c]=_}),D},E.generateAnonymousModule=function(){return"===anonymous"+E.NEXT_ANONYMOUS_ID+++"==="},E.isAnonymousModule=function(t){return E.startsWith(t,"===anonymous")},E.getHighPerformanceTimestamp=function(){return this.PERFORMANCE_NOW_PROBED||(this.PERFORMANCE_NOW_PROBED=!0,this.HAS_PERFORMANCE_NOW=B.global.performance&&typeof B.global.performance.now=="function"),this.HAS_PERFORMANCE_NOW?B.global.performance.now():Date.now()},E.NEXT_ANONYMOUS_ID=1,E.PERFORMANCE_NOW_PROBED=!1,E.HAS_PERFORMANCE_NOW=!1,E}();B.Utilities=n})(le||(le={}));var le;(function(B){function n(D){if(D instanceof Error)return D;var c=new Error(D.message||String(D)||"Unknown Error");return D.stack&&(c.stack=D.stack),c}B.ensureError=n;var E=function(){function D(){}return D.validateConfigurationOptions=function(c){function _(l){if(l.phase==="loading"){console.error('Loading "'+l.moduleId+'" failed'),console.error(l),console.error("Here are the modules that depend on it:"),console.error(l.neededBy);return}if(l.phase==="factory"){console.error('The factory function of "'+l.moduleId+'" has thrown an exception'),console.error(l),console.error("Here are the modules that depend on it:"),console.error(l.neededBy);return}}if(c=c||{},typeof c.baseUrl!="string"&&(c.baseUrl=""),typeof c.isBuild!="boolean"&&(c.isBuild=!1),typeof c.paths!="object"&&(c.paths={}),typeof c.config!="object"&&(c.config={}),typeof c.catchError>"u"&&(c.catchError=!1),typeof c.recordStats>"u"&&(c.recordStats=!1),typeof c.urlArgs!="string"&&(c.urlArgs=""),typeof c.onError!="function"&&(c.onError=_),Array.isArray(c.ignoreDuplicateModules)||(c.ignoreDuplicateModules=[]),c.baseUrl.length>0&&(B.Utilities.endsWith(c.baseUrl,"/")||(c.baseUrl+="/")),typeof c.cspNonce!="string"&&(c.cspNonce=""),typeof c.preferScriptTags>"u"&&(c.preferScriptTags=!1),c.nodeCachedData&&typeof c.nodeCachedData=="object"&&(typeof c.nodeCachedData.seed!="string"&&(c.nodeCachedData.seed="seed"),(typeof c.nodeCachedData.writeDelay!="number"||c.nodeCachedData.writeDelay<0)&&(c.nodeCachedData.writeDelay=1e3*7),!c.nodeCachedData.path||typeof c.nodeCachedData.path!="string")){var h=n(new Error("INVALID cached data configuration, 'path' MUST be set"));h.phase="configuration",c.onError(h),c.nodeCachedData=void 0}return c},D.mergeConfigurationOptions=function(c,_){c===void 0&&(c=null),_===void 0&&(_=null);var h=B.Utilities.recursiveClone(_||{});return B.Utilities.forEachProperty(c,function(l,f){l==="ignoreDuplicateModules"&&typeof h.ignoreDuplicateModules<"u"?h.ignoreDuplicateModules=h.ignoreDuplicateModules.concat(f):l==="paths"&&typeof h.paths<"u"?B.Utilities.forEachProperty(f,function(A,R){return h.paths[A]=R}):l==="config"&&typeof h.config<"u"?B.Utilities.forEachProperty(f,function(A,R){return h.config[A]=R}):h[l]=B.Utilities.recursiveClone(f)}),D.validateConfigurationOptions(h)},D}();B.ConfigurationOptionsUtil=E;var t=function(){function D(c,_){if(this._env=c,this.options=E.mergeConfigurationOptions(_),this._createIgnoreDuplicateModulesMap(),this._createSortedPathsRules(),this.options.baseUrl===""&&this.options.nodeRequire&&this.options.nodeRequire.main&&this.options.nodeRequire.main.filename&&this._env.isNode){var h=this.options.nodeRequire.main.filename,l=Math.max(h.lastIndexOf("/"),h.lastIndexOf("\\"));this.options.baseUrl=h.substring(0,l+1)}}return D.prototype._createIgnoreDuplicateModulesMap=function(){this.ignoreDuplicateModulesMap={};for(var c=0;c<this.options.ignoreDuplicateModules.length;c++)this.ignoreDuplicateModulesMap[this.options.ignoreDuplicateModules[c]]=!0},D.prototype._createSortedPathsRules=function(){var c=this;this.sortedPathsRules=[],B.Utilities.forEachProperty(this.options.paths,function(_,h){Array.isArray(h)?c.sortedPathsRules.push({from:_,to:h}):c.sortedPathsRules.push({from:_,to:[h]})}),this.sortedPathsRules.sort(function(_,h){return h.from.length-_.from.length})},D.prototype.cloneAndMerge=function(c){return new D(this._env,E.mergeConfigurationOptions(c,this.options))},D.prototype.getOptionsLiteral=function(){return this.options},D.prototype._applyPaths=function(c){for(var _,h=0,l=this.sortedPathsRules.length;h<l;h++)if(_=this.sortedPathsRules[h],B.Utilities.startsWith(c,_.from)){for(var f=[],A=0,R=_.to.length;A<R;A++)f.push(_.to[A]+c.substr(_.from.length));return f}return[c]},D.prototype._addUrlArgsToUrl=function(c){return B.Utilities.containsQueryString(c)?c+"&"+this.options.urlArgs:c+"?"+this.options.urlArgs},D.prototype._addUrlArgsIfNecessaryToUrl=function(c){return this.options.urlArgs?this._addUrlArgsToUrl(c):c},D.prototype._addUrlArgsIfNecessaryToUrls=function(c){if(this.options.urlArgs)for(var _=0,h=c.length;_<h;_++)c[_]=this._addUrlArgsToUrl(c[_]);return c},D.prototype.moduleIdToPaths=function(c){if(this._env.isNode){var _=this.options.amdModulesPattern instanceof RegExp&&!this.options.amdModulesPattern.test(c);if(_)return this.isBuild()?["empty:"]:["node|"+c]}var h=c,l;if(!B.Utilities.endsWith(h,".js")&&!B.Utilities.isAbsolutePath(h)){l=this._applyPaths(h);for(var f=0,A=l.length;f<A;f++)this.isBuild()&&l[f]==="empty:"||(B.Utilities.isAbsolutePath(l[f])||(l[f]=this.options.baseUrl+l[f]),!B.Utilities.endsWith(l[f],".js")&&!B.Utilities.containsQueryString(l[f])&&(l[f]=l[f]+".js"))}else!B.Utilities.endsWith(h,".js")&&!B.Utilities.containsQueryString(h)&&(h=h+".js"),l=[h];return this._addUrlArgsIfNecessaryToUrls(l)},D.prototype.requireToUrl=function(c){var _=c;return B.Utilities.isAbsolutePath(_)||(_=this._applyPaths(_)[0],B.Utilities.isAbsolutePath(_)||(_=this.options.baseUrl+_)),this._addUrlArgsIfNecessaryToUrl(_)},D.prototype.isBuild=function(){return this.options.isBuild},D.prototype.shouldInvokeFactory=function(c){return!!(!this.options.isBuild||B.Utilities.isAnonymousModule(c)||this.options.buildForceInvokeFactory&&this.options.buildForceInvokeFactory[c])},D.prototype.isDuplicateMessageIgnoredFor=function(c){return this.ignoreDuplicateModulesMap.hasOwnProperty(c)},D.prototype.getConfigForModule=function(c){if(this.options.config)return this.options.config[c]},D.prototype.shouldCatchError=function(){return this.options.catchError},D.prototype.shouldRecordStats=function(){return this.options.recordStats},D.prototype.onError=function(c){this.options.onError(c)},D}();B.Configuration=t})(le||(le={}));var le;(function(B){var n=function(){function l(f){this._env=f,this._scriptLoader=null,this._callbackMap={}}return l.prototype.load=function(f,A,R,p){var m=this;if(!this._scriptLoader)if(this._env.isWebWorker)this._scriptLoader=new D;else if(this._env.isElectronRenderer){var e=f.getConfig().getOptionsLiteral().preferScriptTags;e?this._scriptLoader=new E:this._scriptLoader=new c(this._env)}else this._env.isNode?this._scriptLoader=new c(this._env):this._scriptLoader=new E;var C={callback:R,errorback:p};if(this._callbackMap.hasOwnProperty(A)){this._callbackMap[A].push(C);return}this._callbackMap[A]=[C],this._scriptLoader.load(f,A,function(){return m.triggerCallback(A)},function(F){return m.triggerErrorback(A,F)})},l.prototype.triggerCallback=function(f){var A=this._callbackMap[f];delete this._callbackMap[f];for(var R=0;R<A.length;R++)A[R].callback()},l.prototype.triggerErrorback=function(f,A){var R=this._callbackMap[f];delete this._callbackMap[f];for(var p=0;p<R.length;p++)R[p].errorback(A)},l}(),E=function(){function l(){}return l.prototype.attachListeners=function(f,A,R){var p=function(){f.removeEventListener("load",m),f.removeEventListener("error",e)},m=function(C){p(),A()},e=function(C){p(),R(C)};f.addEventListener("load",m),f.addEventListener("error",e)},l.prototype.load=function(f,A,R,p){if(/^node\|/.test(A)){var m=f.getConfig().getOptionsLiteral(),e=_(f.getRecorder(),m.nodeRequire||B.global.nodeRequire),C=A.split("|"),F=null;try{F=e(C[1])}catch(a){p(a);return}f.enqueueDefineAnonymousModule([],function(){return F}),R()}else{var y=document.createElement("script");y.setAttribute("async","async"),y.setAttribute("type","text/javascript"),this.attachListeners(y,R,p);var L=f.getConfig().getOptionsLiteral().trustedTypesPolicy;L&&(A=L.createScriptURL(A)),y.setAttribute("src",A);var s=f.getConfig().getOptionsLiteral().cspNonce;s&&y.setAttribute("nonce",s),document.getElementsByTagName("head")[0].appendChild(y)}},l}();function t(l){var f=l.getConfig().getOptionsLiteral().trustedTypesPolicy;try{var A=f?self.eval(f.createScript("","true")):new Function("true");return A.call(self),!0}catch{return!1}}var D=function(){function l(){this._cachedCanUseEval=null}return l.prototype._canUseEval=function(f){return this._cachedCanUseEval===null&&(this._cachedCanUseEval=t(f)),this._cachedCanUseEval},l.prototype.load=function(f,A,R,p){if(/^node\|/.test(A)){var m=f.getConfig().getOptionsLiteral(),e=_(f.getRecorder(),m.nodeRequire||B.global.nodeRequire),C=A.split("|"),F=null;try{F=e(C[1])}catch(s){p(s);return}f.enqueueDefineAnonymousModule([],function(){return F}),R()}else{var y=f.getConfig().getOptionsLiteral().trustedTypesPolicy,L=/^((http:)|(https:)|(file:))/.test(A)&&A.substring(0,self.origin.length)!==self.origin;if(!L&&this._canUseEval(f)){fetch(A).then(function(s){if(s.status!==200)throw new Error(s.statusText);return s.text()}).then(function(s){s=s+`
//# sourceURL=`+A;var a=y?self.eval(y.createScript("",s)):new Function(s);a.call(self),R()}).then(void 0,p);return}try{y&&(A=y.createScriptURL(A)),importScripts(A),R()}catch(s){p(s)}}},l}(),c=function(){function l(f){this._env=f,this._didInitialize=!1,this._didPatchNodeRequire=!1}return l.prototype._init=function(f){this._didInitialize||(this._didInitialize=!0,this._fs=f("fs"),this._vm=f("vm"),this._path=f("path"),this._crypto=f("crypto"))},l.prototype._initNodeRequire=function(f,A){var R=A.getConfig().getOptionsLiteral().nodeCachedData;if(!R||this._didPatchNodeRequire)return;this._didPatchNodeRequire=!0;var p=this,m=f("module");function e(C){var F=C.constructor,y=function(s){try{return C.require(s)}finally{}};return y.resolve=function(s,a){return F._resolveFilename(s,C,!1,a)},y.resolve.paths=function(s){return F._resolveLookupPaths(s,C)},y.main=process.mainModule,y.extensions=F._extensions,y.cache=F._cache,y}m.prototype._compile=function(C,F){var y=m.wrap(C.replace(/^#!.*/,"")),L=A.getRecorder(),s=p._getCachedDataPath(R,F),a={filename:F},i;try{var o=p._fs.readFileSync(s);i=o.slice(0,16),a.cachedData=o.slice(16),L.record(60,s)}catch{L.record(61,s)}var u=new p._vm.Script(y,a),d=u.runInThisContext(a),g=p._path.dirname(F),N=e(this),b=[this.exports,N,this,F,g,process,Oe,Buffer],w=d.apply(this.exports,b);return p._handleCachedData(u,y,s,!a.cachedData,A),p._verifyCachedData(u,y,s,i,A),w}},l.prototype.load=function(f,A,R,p){var m=this,e=f.getConfig().getOptionsLiteral(),C=_(f.getRecorder(),e.nodeRequire||B.global.nodeRequire),F=e.nodeInstrumenter||function(d){return d};this._init(C),this._initNodeRequire(C,f);var y=f.getRecorder();if(/^node\|/.test(A)){var L=A.split("|"),s=null;try{s=C(L[1])}catch(d){p(d);return}f.enqueueDefineAnonymousModule([],function(){return s}),R()}else{A=B.Utilities.fileUriToFilePath(this._env.isWindows,A);var a=this._path.normalize(A),i=this._getElectronRendererScriptPathOrUri(a),o=Boolean(e.nodeCachedData),u=o?this._getCachedDataPath(e.nodeCachedData,A):void 0;this._readSourceAndCachedData(a,u,y,function(d,g,N,b){if(d){p(d);return}var w;g.charCodeAt(0)===l._BOM?w=l._PREFIX+g.substring(1)+l._SUFFIX:w=l._PREFIX+g+l._SUFFIX,w=F(w,a);var v={filename:i,cachedData:N},M=m._createAndEvalScript(f,w,v,R,p);m._handleCachedData(M,w,u,o&&!N,f),m._verifyCachedData(M,w,u,b,f)})}},l.prototype._createAndEvalScript=function(f,A,R,p,m){var e=f.getRecorder();e.record(31,R.filename);var C=new this._vm.Script(A,R),F=C.runInThisContext(R),y=f.getGlobalAMDDefineFunc(),L=!1,s=function(){return L=!0,y.apply(null,arguments)};return s.amd=y.amd,F.call(B.global,f.getGlobalAMDRequireFunc(),s,R.filename,this._path.dirname(R.filename)),e.record(32,R.filename),L?p():m(new Error("Didn't receive define call in "+R.filename+"!")),C},l.prototype._getElectronRendererScriptPathOrUri=function(f){if(!this._env.isElectronRenderer)return f;var A=f.match(/^([a-z])\:(.*)/i);return A?"file:///"+(A[1].toUpperCase()+":"+A[2]).replace(/\\/g,"/"):"file://"+f},l.prototype._getCachedDataPath=function(f,A){var R=this._crypto.createHash("md5").update(A,"utf8").update(f.seed,"utf8").update(process.arch,"").digest("hex"),p=this._path.basename(A).replace(/\.js$/,"");return this._path.join(f.path,p+"-"+R+".code")},l.prototype._handleCachedData=function(f,A,R,p,m){var e=this;f.cachedDataRejected?this._fs.unlink(R,function(C){m.getRecorder().record(62,R),e._createAndWriteCachedData(f,A,R,m),C&&m.getConfig().onError(C)}):p&&this._createAndWriteCachedData(f,A,R,m)},l.prototype._createAndWriteCachedData=function(f,A,R,p){var m=this,e=Math.ceil(p.getConfig().getOptionsLiteral().nodeCachedData.writeDelay*(1+Math.random())),C=-1,F=0,y=void 0,L=function(){setTimeout(function(){y||(y=m._crypto.createHash("md5").update(A,"utf8").digest());var s=f.createCachedData();if(!(s.length===0||s.length===C||F>=5)){if(s.length<C){L();return}C=s.length,m._fs.writeFile(R,Buffer.concat([y,s]),function(a){a&&p.getConfig().onError(a),p.getRecorder().record(63,R),L()})}},e*Math.pow(4,F++))};L()},l.prototype._readSourceAndCachedData=function(f,A,R,p){if(!A)this._fs.readFile(f,{encoding:"utf8"},p);else{var m=void 0,e=void 0,C=void 0,F=2,y=function(L){L?p(L):--F===0&&p(void 0,m,e,C)};this._fs.readFile(f,{encoding:"utf8"},function(L,s){m=s,y(L)}),this._fs.readFile(A,function(L,s){!L&&s&&s.length>0?(C=s.slice(0,16),e=s.slice(16),R.record(60,A)):R.record(61,A),y()})}},l.prototype._verifyCachedData=function(f,A,R,p,m){var e=this;!p||f.cachedDataRejected||setTimeout(function(){var C=e._crypto.createHash("md5").update(A,"utf8").digest();p.equals(C)||(m.getConfig().onError(new Error("FAILED TO VERIFY CACHED DATA, deleting stale '"+R+"' now, but a RESTART IS REQUIRED")),e._fs.unlink(R,function(F){F&&m.getConfig().onError(F)}))},Math.ceil(5e3*(1+Math.random())))},l._BOM=65279,l._PREFIX="(function (require, define, __filename, __dirname) { ",l._SUFFIX=`
});`,l}();function _(l,f){if(f.__$__isRecorded)return f;var A=function(p){l.record(33,p);try{return f(p)}finally{l.record(34,p)}};return A.__$__isRecorded=!0,A}B.ensureRecordedNodeRequire=_;function h(l){return new n(l)}B.createScriptLoader=h})(le||(le={}));var le;(function(B){var n=function(){function h(l){var f=l.lastIndexOf("/");f!==-1?this.fromModulePath=l.substr(0,f+1):this.fromModulePath=""}return h._normalizeModuleId=function(l){var f=l,A;for(A=/\/\.\//;A.test(f);)f=f.replace(A,"/");for(f=f.replace(/^\.\//g,""),A=/\/(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//;A.test(f);)f=f.replace(A,"/");return f=f.replace(/^(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//,""),f},h.prototype.resolveModule=function(l){var f=l;return B.Utilities.isAbsolutePath(f)||(B.Utilities.startsWith(f,"./")||B.Utilities.startsWith(f,"../"))&&(f=h._normalizeModuleId(this.fromModulePath+f)),f},h.ROOT=new h(""),h}();B.ModuleIdResolver=n;var E=function(){function h(l,f,A,R,p,m){this.id=l,this.strId=f,this.dependencies=A,this._callback=R,this._errorback=p,this.moduleIdResolver=m,this.exports={},this.error=null,this.exportsPassedIn=!1,this.unresolvedDependenciesCount=this.dependencies.length,this._isComplete=!1}return h._safeInvokeFunction=function(l,f){try{return{returnedValue:l.apply(B.global,f),producedError:null}}catch(A){return{returnedValue:null,producedError:A}}},h._invokeFactory=function(l,f,A,R){return l.shouldInvokeFactory(f)?l.shouldCatchError()?this._safeInvokeFunction(A,R):{returnedValue:A.apply(B.global,R),producedError:null}:{returnedValue:null,producedError:null}},h.prototype.complete=function(l,f,A,R){this._isComplete=!0;var p=null;if(this._callback)if(typeof this._callback=="function"){l.record(21,this.strId);var m=h._invokeFactory(f,this.strId,this._callback,A);p=m.producedError,l.record(22,this.strId),!p&&typeof m.returnedValue<"u"&&(!this.exportsPassedIn||B.Utilities.isEmpty(this.exports))&&(this.exports=m.returnedValue)}else this.exports=this._callback;if(p){var e=B.ensureError(p);e.phase="factory",e.moduleId=this.strId,e.neededBy=R(this.id),this.error=e,f.onError(e)}this.dependencies=null,this._callback=null,this._errorback=null,this.moduleIdResolver=null},h.prototype.onDependencyError=function(l){return this._isComplete=!0,this.error=l,this._errorback?(this._errorback(l),!0):!1},h.prototype.isComplete=function(){return this._isComplete},h}();B.Module=E;var t=function(){function h(){this._nextId=0,this._strModuleIdToIntModuleId=new Map,this._intModuleIdToStrModuleId=[],this.getModuleId("exports"),this.getModuleId("module"),this.getModuleId("require")}return h.prototype.getMaxModuleId=function(){return this._nextId},h.prototype.getModuleId=function(l){var f=this._strModuleIdToIntModuleId.get(l);return typeof f>"u"&&(f=this._nextId++,this._strModuleIdToIntModuleId.set(l,f),this._intModuleIdToStrModuleId[f]=l),f},h.prototype.getStrModuleId=function(l){return this._intModuleIdToStrModuleId[l]},h}(),D=function(){function h(l){this.id=l}return h.EXPORTS=new h(0),h.MODULE=new h(1),h.REQUIRE=new h(2),h}();B.RegularDependency=D;var c=function(){function h(l,f,A){this.id=l,this.pluginId=f,this.pluginParam=A}return h}();B.PluginDependency=c;var _=function(){function h(l,f,A,R,p){p===void 0&&(p=0),this._env=l,this._scriptLoader=f,this._loaderAvailableTimestamp=p,this._defineFunc=A,this._requireFunc=R,this._moduleIdProvider=new t,this._config=new B.Configuration(this._env),this._hasDependencyCycle=!1,this._modules2=[],this._knownModules2=[],this._inverseDependencies2=[],this._inversePluginDependencies2=new Map,this._currentAnonymousDefineCall=null,this._recorder=null,this._buildInfoPath=[],this._buildInfoDefineStack=[],this._buildInfoDependencies=[]}return h.prototype.reset=function(){return new h(this._env,this._scriptLoader,this._defineFunc,this._requireFunc,this._loaderAvailableTimestamp)},h.prototype.getGlobalAMDDefineFunc=function(){return this._defineFunc},h.prototype.getGlobalAMDRequireFunc=function(){return this._requireFunc},h._findRelevantLocationInStack=function(l,f){for(var A=function(a){return a.replace(/\\/g,"/")},R=A(l),p=f.split(/\n/),m=0;m<p.length;m++){var e=p[m].match(/(.*):(\d+):(\d+)\)?$/);if(e){var C=e[1],F=e[2],y=e[3],L=Math.max(C.lastIndexOf(" ")+1,C.lastIndexOf("(")+1);if(C=C.substr(L),C=A(C),C===R){var s={line:parseInt(F,10),col:parseInt(y,10)};return s.line===1&&(s.col-=53),s}}}throw new Error("Could not correlate define call site for needle "+l)},h.prototype.getBuildInfo=function(){if(!this._config.isBuild())return null;for(var l=[],f=0,A=0,R=this._modules2.length;A<R;A++){var p=this._modules2[A];if(!!p){var m=this._buildInfoPath[p.id]||null,e=this._buildInfoDefineStack[p.id]||null,C=this._buildInfoDependencies[p.id];l[f++]={id:p.strId,path:m,defineLocation:m&&e?h._findRelevantLocationInStack(m,e):null,dependencies:C,shim:null,exports:p.exports}}}return l},h.prototype.getRecorder=function(){return this._recorder||(this._config.shouldRecordStats()?this._recorder=new B.LoaderEventRecorder(this._loaderAvailableTimestamp):this._recorder=B.NullLoaderEventRecorder.INSTANCE),this._recorder},h.prototype.getLoaderEvents=function(){return this.getRecorder().getEvents()},h.prototype.enqueueDefineAnonymousModule=function(l,f){if(this._currentAnonymousDefineCall!==null)throw new Error("Can only have one anonymous define call per script file");var A=null;this._config.isBuild()&&(A=new Error("StackLocation").stack||null),this._currentAnonymousDefineCall={stack:A,dependencies:l,callback:f}},h.prototype.defineModule=function(l,f,A,R,p,m){var e=this;m===void 0&&(m=new n(l));var C=this._moduleIdProvider.getModuleId(l);if(this._modules2[C]){this._config.isDuplicateMessageIgnoredFor(l)||console.warn("Duplicate definition of module '"+l+"'");return}var F=new E(C,l,this._normalizeDependencies(f,m),A,R,m);this._modules2[C]=F,this._config.isBuild()&&(this._buildInfoDefineStack[C]=p,this._buildInfoDependencies[C]=(F.dependencies||[]).map(function(y){return e._moduleIdProvider.getStrModuleId(y.id)})),this._resolve(F)},h.prototype._normalizeDependency=function(l,f){if(l==="exports")return D.EXPORTS;if(l==="module")return D.MODULE;if(l==="require")return D.REQUIRE;var A=l.indexOf("!");if(A>=0){var R=f.resolveModule(l.substr(0,A)),p=f.resolveModule(l.substr(A+1)),m=this._moduleIdProvider.getModuleId(R+"!"+p),e=this._moduleIdProvider.getModuleId(R);return new c(m,e,p)}return new D(this._moduleIdProvider.getModuleId(f.resolveModule(l)))},h.prototype._normalizeDependencies=function(l,f){for(var A=[],R=0,p=0,m=l.length;p<m;p++)A[R++]=this._normalizeDependency(l[p],f);return A},h.prototype._relativeRequire=function(l,f,A,R){if(typeof f=="string")return this.synchronousRequire(f,l);this.defineModule(B.Utilities.generateAnonymousModule(),f,A,R,null,l)},h.prototype.synchronousRequire=function(l,f){f===void 0&&(f=new n(l));var A=this._normalizeDependency(l,f),R=this._modules2[A.id];if(!R)throw new Error("Check dependency list! Synchronous require cannot resolve module '"+l+"'. This is the first mention of this module!");if(!R.isComplete())throw new Error("Check dependency list! Synchronous require cannot resolve module '"+l+"'. This module has not been resolved completely yet.");if(R.error)throw R.error;return R.exports},h.prototype.configure=function(l,f){var A=this._config.shouldRecordStats();f?this._config=new B.Configuration(this._env,l):this._config=this._config.cloneAndMerge(l),this._config.shouldRecordStats()&&!A&&(this._recorder=null)},h.prototype.getConfig=function(){return this._config},h.prototype._onLoad=function(l){if(this._currentAnonymousDefineCall!==null){var f=this._currentAnonymousDefineCall;this._currentAnonymousDefineCall=null,this.defineModule(this._moduleIdProvider.getStrModuleId(l),f.dependencies,f.callback,null,f.stack)}},h.prototype._createLoadError=function(l,f){var A=this,R=this._moduleIdProvider.getStrModuleId(l),p=(this._inverseDependencies2[l]||[]).map(function(e){return A._moduleIdProvider.getStrModuleId(e)}),m=B.ensureError(f);return m.phase="loading",m.moduleId=R,m.neededBy=p,m},h.prototype._onLoadError=function(l,f){var A=this._createLoadError(l,f);this._modules2[l]||(this._modules2[l]=new E(l,this._moduleIdProvider.getStrModuleId(l),[],function(){},null,null));for(var R=[],p=0,m=this._moduleIdProvider.getMaxModuleId();p<m;p++)R[p]=!1;var e=!1,C=[];for(C.push(l),R[l]=!0;C.length>0;){var F=C.shift(),y=this._modules2[F];y&&(e=y.onDependencyError(A)||e);var L=this._inverseDependencies2[F];if(L)for(var p=0,m=L.length;p<m;p++){var s=L[p];R[s]||(C.push(s),R[s]=!0)}}e||this._config.onError(A)},h.prototype._hasDependencyPath=function(l,f){var A=this._modules2[l];if(!A)return!1;for(var R=[],p=0,m=this._moduleIdProvider.getMaxModuleId();p<m;p++)R[p]=!1;var e=[];for(e.push(A),R[l]=!0;e.length>0;){var C=e.shift(),F=C.dependencies;if(F)for(var p=0,m=F.length;p<m;p++){var y=F[p];if(y.id===f)return!0;var L=this._modules2[y.id];L&&!R[y.id]&&(R[y.id]=!0,e.push(L))}}return!1},h.prototype._findCyclePath=function(l,f,A){if(l===f||A===50)return[l];var R=this._modules2[l];if(!R)return null;var p=R.dependencies;if(p)for(var m=0,e=p.length;m<e;m++){var C=this._findCyclePath(p[m].id,f,A+1);if(C!==null)return C.push(l),C}return null},h.prototype._createRequire=function(l){var f=this,A=function(R,p,m){return f._relativeRequire(l,R,p,m)};return A.toUrl=function(R){return f._config.requireToUrl(l.resolveModule(R))},A.getStats=function(){return f.getLoaderEvents()},A.hasDependencyCycle=function(){return f._hasDependencyCycle},A.config=function(R,p){p===void 0&&(p=!1),f.configure(R,p)},A.__$__nodeRequire=B.global.nodeRequire,A},h.prototype._loadModule=function(l){var f=this;if(!(this._modules2[l]||this._knownModules2[l])){this._knownModules2[l]=!0;var A=this._moduleIdProvider.getStrModuleId(l),R=this._config.moduleIdToPaths(A),p=/^@[^\/]+\/[^\/]+$/;this._env.isNode&&(A.indexOf("/")===-1||p.test(A))&&R.push("node|"+A);var m=-1,e=function(C){if(m++,m>=R.length)f._onLoadError(l,C);else{var F=R[m],y=f.getRecorder();if(f._config.isBuild()&&F==="empty:"){f._buildInfoPath[l]=F,f.defineModule(f._moduleIdProvider.getStrModuleId(l),[],null,null,null),f._onLoad(l);return}y.record(10,F),f._scriptLoader.load(f,F,function(){f._config.isBuild()&&(f._buildInfoPath[l]=F),y.record(11,F),f._onLoad(l)},function(L){y.record(12,F),e(L)})}};e(null)}},h.prototype._loadPluginDependency=function(l,f){var A=this;if(!(this._modules2[f.id]||this._knownModules2[f.id])){this._knownModules2[f.id]=!0;var R=function(p){A.defineModule(A._moduleIdProvider.getStrModuleId(f.id),[],p,null,null)};R.error=function(p){A._config.onError(A._createLoadError(f.id,p))},l.load(f.pluginParam,this._createRequire(n.ROOT),R,this._config.getOptionsLiteral())}},h.prototype._resolve=function(l){var f=this,A=l.dependencies;if(A)for(var R=0,p=A.length;R<p;R++){var m=A[R];if(m===D.EXPORTS){l.exportsPassedIn=!0,l.unresolvedDependenciesCount--;continue}if(m===D.MODULE){l.unresolvedDependenciesCount--;continue}if(m===D.REQUIRE){l.unresolvedDependenciesCount--;continue}var e=this._modules2[m.id];if(e&&e.isComplete()){if(e.error){l.onDependencyError(e.error);return}l.unresolvedDependenciesCount--;continue}if(this._hasDependencyPath(m.id,l.id)){this._hasDependencyCycle=!0,console.warn("There is a dependency cycle between '"+this._moduleIdProvider.getStrModuleId(m.id)+"' and '"+this._moduleIdProvider.getStrModuleId(l.id)+"'. The cyclic path follows:");var C=this._findCyclePath(m.id,l.id,0)||[];C.reverse(),C.push(m.id),console.warn(C.map(function(L){return f._moduleIdProvider.getStrModuleId(L)}).join(` => 
`)),l.unresolvedDependenciesCount--;continue}if(this._inverseDependencies2[m.id]=this._inverseDependencies2[m.id]||[],this._inverseDependencies2[m.id].push(l.id),m instanceof c){var F=this._modules2[m.pluginId];if(F&&F.isComplete()){this._loadPluginDependency(F.exports,m);continue}var y=this._inversePluginDependencies2.get(m.pluginId);y||(y=[],this._inversePluginDependencies2.set(m.pluginId,y)),y.push(m),this._loadModule(m.pluginId);continue}this._loadModule(m.id)}l.unresolvedDependenciesCount===0&&this._onModuleComplete(l)},h.prototype._onModuleComplete=function(l){var f=this,A=this.getRecorder();if(!l.isComplete()){var R=l.dependencies,p=[];if(R)for(var m=0,e=R.length;m<e;m++){var C=R[m];if(C===D.EXPORTS){p[m]=l.exports;continue}if(C===D.MODULE){p[m]={id:l.strId,config:function(){return f._config.getConfigForModule(l.strId)}};continue}if(C===D.REQUIRE){p[m]=this._createRequire(l.moduleIdResolver);continue}var F=this._modules2[C.id];if(F){p[m]=F.exports;continue}p[m]=null}var y=function(o){return(f._inverseDependencies2[o]||[]).map(function(u){return f._moduleIdProvider.getStrModuleId(u)})};l.complete(A,this._config,p,y);var L=this._inverseDependencies2[l.id];if(this._inverseDependencies2[l.id]=null,L)for(var m=0,e=L.length;m<e;m++){var s=L[m],a=this._modules2[s];a.unresolvedDependenciesCount--,a.unresolvedDependenciesCount===0&&this._onModuleComplete(a)}var i=this._inversePluginDependencies2.get(l.id);if(i){this._inversePluginDependencies2.delete(l.id);for(var m=0,e=i.length;m<e;m++)this._loadPluginDependency(l.exports,i[m])}}},h}();B.ModuleManager=_})(le||(le={}));var Z,le;(function(B){var n=new B.Environment,E=null,t=function(h,l,f){typeof h!="string"&&(f=l,l=h,h=null),(typeof l!="object"||!Array.isArray(l))&&(f=l,l=null),l||(l=["require","exports","module"]),h?E.defineModule(h,l,f,null,null):E.enqueueDefineAnonymousModule(l,f)};t.amd={jQuery:!0};var D=function(h,l){l===void 0&&(l=!1),E.configure(h,l)},c=function(){if(arguments.length===1){if(arguments[0]instanceof Object&&!Array.isArray(arguments[0])){D(arguments[0]);return}if(typeof arguments[0]=="string")return E.synchronousRequire(arguments[0])}if((arguments.length===2||arguments.length===3)&&Array.isArray(arguments[0])){E.defineModule(B.Utilities.generateAnonymousModule(),arguments[0],arguments[1],arguments[2],null);return}throw new Error("Unrecognized require call")};c.config=D,c.getConfig=function(){return E.getConfig().getOptionsLiteral()},c.reset=function(){E=E.reset()},c.getBuildInfo=function(){return E.getBuildInfo()},c.getStats=function(){return E.getLoaderEvents()},c.define=t;function _(){if(typeof B.global.require<"u"||typeof require<"u"){var h=B.global.require||require;if(typeof h=="function"&&typeof h.resolve=="function"){var l=B.ensureRecordedNodeRequire(E.getRecorder(),h);B.global.nodeRequire=l,c.nodeRequire=l,c.__$__nodeRequire=l}}n.isNode&&!n.isElectronRenderer&&!n.isElectronNodeIntegrationWebWorker?module.exports=c:(n.isElectronRenderer||(B.global.define=t),B.global.require=c)}B.init=_,(typeof B.global.define!="function"||!B.global.define.amd)&&(E=new B.ModuleManager(n,B.createScriptLoader(n),t,c,B.Utilities.getHighPerformanceTimestamp()),typeof B.global.require<"u"&&typeof B.global.require!="function"&&c.config(B.global.require),Z=function(){return t.apply(null,arguments)},Z.amd=t.amd,typeof doNotInitLoader>"u"&&_())})(le||(le={})),Z(K[53],x([0,1]),function(B,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.load=void 0;function E(h,l,f,A){if(A=A||{},(A["vs/css"]||{}).disabled){f({});return}const p=l.toUrl(h+".css");t(h,p,()=>{f({})},m=>{typeof f.error=="function"&&f.error("Could not find "+p+".")})}n.load=E;function t(h,l,f,A){if(D(h,l)){f();return}c(h,l,f,A)}function D(h,l){const f=document.getElementsByTagName("link");for(let A=0,R=f.length;A<R;A++){const p=f[A].getAttribute("data-name"),m=f[A].getAttribute("href");if(p===h||m===l)return!0}return!1}function c(h,l,f,A){const R=document.createElement("link");R.setAttribute("rel","stylesheet"),R.setAttribute("type","text/css"),R.setAttribute("data-name",h),_(h,R,f,A),R.setAttribute("href",l),(document.head||document.getElementsByTagName("head")[0]).appendChild(R)}function _(h,l,f,A){const R=()=>{l.removeEventListener("load",p),l.removeEventListener("error",m)},p=e=>{R(),f()},m=e=>{R(),A(e)};l.addEventListener("load",p),l.addEventListener("error",m)}}),Z("vs/nls",["require","exports"],function(B,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.load=n.create=n.setPseudoTranslation=n.getConfiguredDefaultLocale=n.localize=void 0;let E=typeof document<"u"&&document.location&&document.location.hash.indexOf("pseudo=true")>=0;const t="i-default";function D(e,C){let F;return C.length===0?F=e:F=e.replace(/\{(\d+)\}/g,(y,L)=>{const s=L[0],a=C[s];let i=y;return typeof a=="string"?i=a:(typeof a=="number"||typeof a=="boolean"||a===void 0||a===null)&&(i=String(a)),i}),E&&(F="\uFF3B"+F.replace(/[aouei]/g,"$&$&")+"\uFF3D"),F}function c(e,C){let F=e[C];return F||(F=e["*"],F)?F:null}function _(e){return e.charAt(e.length-1)==="/"?e:e+"/"}async function h(e,C,F){const y=_(e)+_(C)+"vscode/"+_(F),L=await fetch(y);if(L.ok)return await L.json();throw new Error(`${L.status} - ${L.statusText}`)}function l(e){return function(C,F){const y=Array.prototype.slice.call(arguments,2);return D(e[C],y)}}function f(e,C,...F){return D(C,F)}n.localize=f;function A(e){}n.getConfiguredDefaultLocale=A;function R(e){E=e}n.setPseudoTranslation=R;function p(e,C){return{localize:l(C[e]),getConfiguredDefaultLocale:C.getConfiguredDefaultLocale??(F=>{})}}n.create=p;function m(e,C,F,y){const L=y["vs/nls"]??{};if(!e||e.length===0)return F({localize:f,getConfiguredDefaultLocale:()=>L.availableLanguages?.["*"]});const s=L.availableLanguages?c(L.availableLanguages,e):null,a=s===null||s===t;let i=".nls";a||(i=i+"."+s);const o=u=>{Array.isArray(u)?u.localize=l(u):u.localize=l(u[e]),u.getConfiguredDefaultLocale=()=>L.availableLanguages?.["*"],F(u)};typeof L.loadBundle=="function"?L.loadBundle(e,s,(u,d)=>{u?C([e+".nls"],o):o(d)}):L.translationServiceUrl&&!a?(async()=>{try{const u=await h(L.translationServiceUrl,s,e);return o(u)}catch(u){if(!s.includes("-"))return console.error(u),C([e+".nls"],o);try{const d=s.split("-")[0],g=await h(L.translationServiceUrl,d,e);return L.availableLanguages??={},L.availableLanguages["*"]=d,o(g)}catch(d){return console.error(d),C([e+".nls"],o)}}})():C([e+i],o,u=>{if(i===".nls"){console.error("Failed trying to load default language strings",u);return}console.error(`Failed to load message bundle for language ${s}. Falling back to the default language:`,u),C([e+".nls"],o)})}n.load=m}),function(){const B=self.MonacoEnvironment,n=B&&B.baseUrl?B.baseUrl:"../../../",E=typeof self.trustedTypes?.createPolicy=="function"?self.trustedTypes?.createPolicy("amdLoader",{createScriptURL:f=>f,createScript:(f,...A)=>{const R=A.slice(0,-1).join(","),p=A.pop().toString();return`(function anonymous(${R}) { ${p}
})`}}):void 0;function t(){try{return(E?self.eval(E.createScript("","true")):new Function("true")).call(self),!0}catch{return!1}}function D(){return new Promise((f,A)=>{if(typeof self.define=="function"&&self.define.amd)return f();const R=n+"vs/loader.js";if(!(/^((http:)|(https:)|(file:))/.test(R)&&R.substring(0,self.origin.length)!==self.origin)&&t()){fetch(R).then(m=>{if(m.status!==200)throw new Error(m.statusText);return m.text()}).then(m=>{m=`${m}
//# sourceURL=${R}`,(E?self.eval(E.createScript("",m)):new Function(m)).call(self),f()}).then(void 0,A);return}E?importScripts(E.createScriptURL(R)):importScripts(R),f()})}function c(){require.config({baseUrl:n,catchError:!0,trustedTypesPolicy:E,amdModulesPattern:/^vs\//})}function _(f){D().then(()=>{c(),require([f],function(A){setTimeout(function(){const R=A.create((p,m)=>{self.postMessage(p,m)},null);for(self.onmessage=p=>R.onmessage(p.data,p.ports);l.length>0;)self.onmessage(l.shift())},0)})})}typeof self.define=="function"&&self.define.amd&&c();let h=!0;const l=[];self.onmessage=f=>{if(!h){l.push(f);return}h=!1,_(f.data)}}(),Z(K[24],x([0,1]),function(B,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.CSSIcon=n.Codicon=n.getCodiconAriaLabel=void 0;function E(c){return c?c.replace(/\$\((.*?)\)/g,(_,h)=>` ${h} `).trim():""}n.getCodiconAriaLabel=E;class t{constructor(_,h,l){this.id=_,this.definition=h,this.description=l,t.a.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return t.a}}n.Codicon=t,t.a=[],t.add=new t("add",{fontCharacter:"\\ea60"}),t.plus=new t("plus",t.add.definition),t.gistNew=new t("gist-new",t.add.definition),t.repoCreate=new t("repo-create",t.add.definition),t.lightbulb=new t("lightbulb",{fontCharacter:"\\ea61"}),t.lightBulb=new t("light-bulb",{fontCharacter:"\\ea61"}),t.repo=new t("repo",{fontCharacter:"\\ea62"}),t.repoDelete=new t("repo-delete",{fontCharacter:"\\ea62"}),t.gistFork=new t("gist-fork",{fontCharacter:"\\ea63"}),t.repoForked=new t("repo-forked",{fontCharacter:"\\ea63"}),t.gitPullRequest=new t("git-pull-request",{fontCharacter:"\\ea64"}),t.gitPullRequestAbandoned=new t("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),t.recordKeys=new t("record-keys",{fontCharacter:"\\ea65"}),t.keyboard=new t("keyboard",{fontCharacter:"\\ea65"}),t.tag=new t("tag",{fontCharacter:"\\ea66"}),t.tagAdd=new t("tag-add",{fontCharacter:"\\ea66"}),t.tagRemove=new t("tag-remove",{fontCharacter:"\\ea66"}),t.person=new t("person",{fontCharacter:"\\ea67"}),t.personFollow=new t("person-follow",{fontCharacter:"\\ea67"}),t.personOutline=new t("person-outline",{fontCharacter:"\\ea67"}),t.personFilled=new t("person-filled",{fontCharacter:"\\ea67"}),t.gitBranch=new t("git-branch",{fontCharacter:"\\ea68"}),t.gitBranchCreate=new t("git-branch-create",{fontCharacter:"\\ea68"}),t.gitBranchDelete=new t("git-branch-delete",{fontCharacter:"\\ea68"}),t.sourceControl=new t("source-control",{fontCharacter:"\\ea68"}),t.mirror=new t("mirror",{fontCharacter:"\\ea69"}),t.mirrorPublic=new t("mirror-public",{fontCharacter:"\\ea69"}),t.star=new t("star",{fontCharacter:"\\ea6a"}),t.starAdd=new t("star-add",{fontCharacter:"\\ea6a"}),t.starDelete=new t("star-delete",{fontCharacter:"\\ea6a"}),t.starEmpty=new t("star-empty",{fontCharacter:"\\ea6a"}),t.comment=new t("comment",{fontCharacter:"\\ea6b"}),t.commentAdd=new t("comment-add",{fontCharacter:"\\ea6b"}),t.alert=new t("alert",{fontCharacter:"\\ea6c"}),t.warning=new t("warning",{fontCharacter:"\\ea6c"}),t.search=new t("search",{fontCharacter:"\\ea6d"}),t.searchSave=new t("search-save",{fontCharacter:"\\ea6d"}),t.logOut=new t("log-out",{fontCharacter:"\\ea6e"}),t.signOut=new t("sign-out",{fontCharacter:"\\ea6e"}),t.logIn=new t("log-in",{fontCharacter:"\\ea6f"}),t.signIn=new t("sign-in",{fontCharacter:"\\ea6f"}),t.eye=new t("eye",{fontCharacter:"\\ea70"}),t.eyeUnwatch=new t("eye-unwatch",{fontCharacter:"\\ea70"}),t.eyeWatch=new t("eye-watch",{fontCharacter:"\\ea70"}),t.circleFilled=new t("circle-filled",{fontCharacter:"\\ea71"}),t.primitiveDot=new t("primitive-dot",t.circleFilled.definition),t.closeDirty=new t("close-dirty",t.circleFilled.definition),t.debugBreakpoint=new t("debug-breakpoint",t.circleFilled.definition),t.debugBreakpointDisabled=new t("debug-breakpoint-disabled",t.circleFilled.definition),t.debugHint=new t("debug-hint",t.circleFilled.definition),t.primitiveSquare=new t("primitive-square",{fontCharacter:"\\ea72"}),t.edit=new t("edit",{fontCharacter:"\\ea73"}),t.pencil=new t("pencil",{fontCharacter:"\\ea73"}),t.info=new t("info",{fontCharacter:"\\ea74"}),t.issueOpened=new t("issue-opened",{fontCharacter:"\\ea74"}),t.gistPrivate=new t("gist-private",{fontCharacter:"\\ea75"}),t.gitForkPrivate=new t("git-fork-private",{fontCharacter:"\\ea75"}),t.lock=new t("lock",{fontCharacter:"\\ea75"}),t.mirrorPrivate=new t("mirror-private",{fontCharacter:"\\ea75"}),t.close=new t("close",{fontCharacter:"\\ea76"}),t.removeClose=new t("remove-close",{fontCharacter:"\\ea76"}),t.x=new t("x",{fontCharacter:"\\ea76"}),t.repoSync=new t("repo-sync",{fontCharacter:"\\ea77"}),t.sync=new t("sync",{fontCharacter:"\\ea77"}),t.clone=new t("clone",{fontCharacter:"\\ea78"}),t.desktopDownload=new t("desktop-download",{fontCharacter:"\\ea78"}),t.beaker=new t("beaker",{fontCharacter:"\\ea79"}),t.microscope=new t("microscope",{fontCharacter:"\\ea79"}),t.vm=new t("vm",{fontCharacter:"\\ea7a"}),t.deviceDesktop=new t("device-desktop",{fontCharacter:"\\ea7a"}),t.file=new t("file",{fontCharacter:"\\ea7b"}),t.fileText=new t("file-text",{fontCharacter:"\\ea7b"}),t.more=new t("more",{fontCharacter:"\\ea7c"}),t.ellipsis=new t("ellipsis",{fontCharacter:"\\ea7c"}),t.kebabHorizontal=new t("kebab-horizontal",{fontCharacter:"\\ea7c"}),t.mailReply=new t("mail-reply",{fontCharacter:"\\ea7d"}),t.reply=new t("reply",{fontCharacter:"\\ea7d"}),t.organization=new t("organization",{fontCharacter:"\\ea7e"}),t.organizationFilled=new t("organization-filled",{fontCharacter:"\\ea7e"}),t.organizationOutline=new t("organization-outline",{fontCharacter:"\\ea7e"}),t.newFile=new t("new-file",{fontCharacter:"\\ea7f"}),t.fileAdd=new t("file-add",{fontCharacter:"\\ea7f"}),t.newFolder=new t("new-folder",{fontCharacter:"\\ea80"}),t.fileDirectoryCreate=new t("file-directory-create",{fontCharacter:"\\ea80"}),t.trash=new t("trash",{fontCharacter:"\\ea81"}),t.trashcan=new t("trashcan",{fontCharacter:"\\ea81"}),t.history=new t("history",{fontCharacter:"\\ea82"}),t.clock=new t("clock",{fontCharacter:"\\ea82"}),t.folder=new t("folder",{fontCharacter:"\\ea83"}),t.fileDirectory=new t("file-directory",{fontCharacter:"\\ea83"}),t.symbolFolder=new t("symbol-folder",{fontCharacter:"\\ea83"}),t.logoGithub=new t("logo-github",{fontCharacter:"\\ea84"}),t.markGithub=new t("mark-github",{fontCharacter:"\\ea84"}),t.github=new t("github",{fontCharacter:"\\ea84"}),t.terminal=new t("terminal",{fontCharacter:"\\ea85"}),t.console=new t("console",{fontCharacter:"\\ea85"}),t.repl=new t("repl",{fontCharacter:"\\ea85"}),t.zap=new t("zap",{fontCharacter:"\\ea86"}),t.symbolEvent=new t("symbol-event",{fontCharacter:"\\ea86"}),t.error=new t("error",{fontCharacter:"\\ea87"}),t.stop=new t("stop",{fontCharacter:"\\ea87"}),t.variable=new t("variable",{fontCharacter:"\\ea88"}),t.symbolVariable=new t("symbol-variable",{fontCharacter:"\\ea88"}),t.array=new t("array",{fontCharacter:"\\ea8a"}),t.symbolArray=new t("symbol-array",{fontCharacter:"\\ea8a"}),t.symbolModule=new t("symbol-module",{fontCharacter:"\\ea8b"}),t.symbolPackage=new t("symbol-package",{fontCharacter:"\\ea8b"}),t.symbolNamespace=new t("symbol-namespace",{fontCharacter:"\\ea8b"}),t.symbolObject=new t("symbol-object",{fontCharacter:"\\ea8b"}),t.symbolMethod=new t("symbol-method",{fontCharacter:"\\ea8c"}),t.symbolFunction=new t("symbol-function",{fontCharacter:"\\ea8c"}),t.symbolConstructor=new t("symbol-constructor",{fontCharacter:"\\ea8c"}),t.symbolBoolean=new t("symbol-boolean",{fontCharacter:"\\ea8f"}),t.symbolNull=new t("symbol-null",{fontCharacter:"\\ea8f"}),t.symbolNumeric=new t("symbol-numeric",{fontCharacter:"\\ea90"}),t.symbolNumber=new t("symbol-number",{fontCharacter:"\\ea90"}),t.symbolStructure=new t("symbol-structure",{fontCharacter:"\\ea91"}),t.symbolStruct=new t("symbol-struct",{fontCharacter:"\\ea91"}),t.symbolParameter=new t("symbol-parameter",{fontCharacter:"\\ea92"}),t.symbolTypeParameter=new t("symbol-type-parameter",{fontCharacter:"\\ea92"}),t.symbolKey=new t("symbol-key",{fontCharacter:"\\ea93"}),t.symbolText=new t("symbol-text",{fontCharacter:"\\ea93"}),t.symbolReference=new t("symbol-reference",{fontCharacter:"\\ea94"}),t.goToFile=new t("go-to-file",{fontCharacter:"\\ea94"}),t.symbolEnum=new t("symbol-enum",{fontCharacter:"\\ea95"}),t.symbolValue=new t("symbol-value",{fontCharacter:"\\ea95"}),t.symbolRuler=new t("symbol-ruler",{fontCharacter:"\\ea96"}),t.symbolUnit=new t("symbol-unit",{fontCharacter:"\\ea96"}),t.activateBreakpoints=new t("activate-breakpoints",{fontCharacter:"\\ea97"}),t.archive=new t("archive",{fontCharacter:"\\ea98"}),t.arrowBoth=new t("arrow-both",{fontCharacter:"\\ea99"}),t.arrowDown=new t("arrow-down",{fontCharacter:"\\ea9a"}),t.arrowLeft=new t("arrow-left",{fontCharacter:"\\ea9b"}),t.arrowRight=new t("arrow-right",{fontCharacter:"\\ea9c"}),t.arrowSmallDown=new t("arrow-small-down",{fontCharacter:"\\ea9d"}),t.arrowSmallLeft=new t("arrow-small-left",{fontCharacter:"\\ea9e"}),t.arrowSmallRight=new t("arrow-small-right",{fontCharacter:"\\ea9f"}),t.arrowSmallUp=new t("arrow-small-up",{fontCharacter:"\\eaa0"}),t.arrowUp=new t("arrow-up",{fontCharacter:"\\eaa1"}),t.bell=new t("bell",{fontCharacter:"\\eaa2"}),t.bold=new t("bold",{fontCharacter:"\\eaa3"}),t.book=new t("book",{fontCharacter:"\\eaa4"}),t.bookmark=new t("bookmark",{fontCharacter:"\\eaa5"}),t.debugBreakpointConditionalUnverified=new t("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),t.debugBreakpointConditional=new t("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),t.debugBreakpointConditionalDisabled=new t("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),t.debugBreakpointDataUnverified=new t("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),t.debugBreakpointData=new t("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),t.debugBreakpointDataDisabled=new t("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),t.debugBreakpointLogUnverified=new t("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),t.debugBreakpointLog=new t("debug-breakpoint-log",{fontCharacter:"\\eaab"}),t.debugBreakpointLogDisabled=new t("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),t.briefcase=new t("briefcase",{fontCharacter:"\\eaac"}),t.broadcast=new t("broadcast",{fontCharacter:"\\eaad"}),t.browser=new t("browser",{fontCharacter:"\\eaae"}),t.bug=new t("bug",{fontCharacter:"\\eaaf"}),t.calendar=new t("calendar",{fontCharacter:"\\eab0"}),t.caseSensitive=new t("case-sensitive",{fontCharacter:"\\eab1"}),t.check=new t("check",{fontCharacter:"\\eab2"}),t.checklist=new t("checklist",{fontCharacter:"\\eab3"}),t.chevronDown=new t("chevron-down",{fontCharacter:"\\eab4"}),t.dropDownButton=new t("drop-down-button",t.chevronDown.definition),t.chevronLeft=new t("chevron-left",{fontCharacter:"\\eab5"}),t.chevronRight=new t("chevron-right",{fontCharacter:"\\eab6"}),t.chevronUp=new t("chevron-up",{fontCharacter:"\\eab7"}),t.chromeClose=new t("chrome-close",{fontCharacter:"\\eab8"}),t.chromeMaximize=new t("chrome-maximize",{fontCharacter:"\\eab9"}),t.chromeMinimize=new t("chrome-minimize",{fontCharacter:"\\eaba"}),t.chromeRestore=new t("chrome-restore",{fontCharacter:"\\eabb"}),t.circle=new t("circle",{fontCharacter:"\\eabc"}),t.circleOutline=new t("circle-outline",t.circle.definition),t.debugBreakpointUnverified=new t("debug-breakpoint-unverified",t.circle.definition),t.circleSlash=new t("circle-slash",{fontCharacter:"\\eabd"}),t.circuitBoard=new t("circuit-board",{fontCharacter:"\\eabe"}),t.clearAll=new t("clear-all",{fontCharacter:"\\eabf"}),t.clippy=new t("clippy",{fontCharacter:"\\eac0"}),t.closeAll=new t("close-all",{fontCharacter:"\\eac1"}),t.cloudDownload=new t("cloud-download",{fontCharacter:"\\eac2"}),t.cloudUpload=new t("cloud-upload",{fontCharacter:"\\eac3"}),t.code=new t("code",{fontCharacter:"\\eac4"}),t.collapseAll=new t("collapse-all",{fontCharacter:"\\eac5"}),t.colorMode=new t("color-mode",{fontCharacter:"\\eac6"}),t.commentDiscussion=new t("comment-discussion",{fontCharacter:"\\eac7"}),t.compareChanges=new t("compare-changes",{fontCharacter:"\\eafd"}),t.creditCard=new t("credit-card",{fontCharacter:"\\eac9"}),t.dash=new t("dash",{fontCharacter:"\\eacc"}),t.dashboard=new t("dashboard",{fontCharacter:"\\eacd"}),t.database=new t("database",{fontCharacter:"\\eace"}),t.debugContinue=new t("debug-continue",{fontCharacter:"\\eacf"}),t.debugDisconnect=new t("debug-disconnect",{fontCharacter:"\\ead0"}),t.debugPause=new t("debug-pause",{fontCharacter:"\\ead1"}),t.debugRestart=new t("debug-restart",{fontCharacter:"\\ead2"}),t.debugStart=new t("debug-start",{fontCharacter:"\\ead3"}),t.debugStepInto=new t("debug-step-into",{fontCharacter:"\\ead4"}),t.debugStepOut=new t("debug-step-out",{fontCharacter:"\\ead5"}),t.debugStepOver=new t("debug-step-over",{fontCharacter:"\\ead6"}),t.debugStop=new t("debug-stop",{fontCharacter:"\\ead7"}),t.debug=new t("debug",{fontCharacter:"\\ead8"}),t.deviceCameraVideo=new t("device-camera-video",{fontCharacter:"\\ead9"}),t.deviceCamera=new t("device-camera",{fontCharacter:"\\eada"}),t.deviceMobile=new t("device-mobile",{fontCharacter:"\\eadb"}),t.diffAdded=new t("diff-added",{fontCharacter:"\\eadc"}),t.diffIgnored=new t("diff-ignored",{fontCharacter:"\\eadd"}),t.diffModified=new t("diff-modified",{fontCharacter:"\\eade"}),t.diffRemoved=new t("diff-removed",{fontCharacter:"\\eadf"}),t.diffRenamed=new t("diff-renamed",{fontCharacter:"\\eae0"}),t.diff=new t("diff",{fontCharacter:"\\eae1"}),t.discard=new t("discard",{fontCharacter:"\\eae2"}),t.editorLayout=new t("editor-layout",{fontCharacter:"\\eae3"}),t.emptyWindow=new t("empty-window",{fontCharacter:"\\eae4"}),t.exclude=new t("exclude",{fontCharacter:"\\eae5"}),t.extensions=new t("extensions",{fontCharacter:"\\eae6"}),t.eyeClosed=new t("eye-closed",{fontCharacter:"\\eae7"}),t.fileBinary=new t("file-binary",{fontCharacter:"\\eae8"}),t.fileCode=new t("file-code",{fontCharacter:"\\eae9"}),t.fileMedia=new t("file-media",{fontCharacter:"\\eaea"}),t.filePdf=new t("file-pdf",{fontCharacter:"\\eaeb"}),t.fileSubmodule=new t("file-submodule",{fontCharacter:"\\eaec"}),t.fileSymlinkDirectory=new t("file-symlink-directory",{fontCharacter:"\\eaed"}),t.fileSymlinkFile=new t("file-symlink-file",{fontCharacter:"\\eaee"}),t.fileZip=new t("file-zip",{fontCharacter:"\\eaef"}),t.files=new t("files",{fontCharacter:"\\eaf0"}),t.filter=new t("filter",{fontCharacter:"\\eaf1"}),t.flame=new t("flame",{fontCharacter:"\\eaf2"}),t.foldDown=new t("fold-down",{fontCharacter:"\\eaf3"}),t.foldUp=new t("fold-up",{fontCharacter:"\\eaf4"}),t.fold=new t("fold",{fontCharacter:"\\eaf5"}),t.folderActive=new t("folder-active",{fontCharacter:"\\eaf6"}),t.folderOpened=new t("folder-opened",{fontCharacter:"\\eaf7"}),t.gear=new t("gear",{fontCharacter:"\\eaf8"}),t.gift=new t("gift",{fontCharacter:"\\eaf9"}),t.gistSecret=new t("gist-secret",{fontCharacter:"\\eafa"}),t.gist=new t("gist",{fontCharacter:"\\eafb"}),t.gitCommit=new t("git-commit",{fontCharacter:"\\eafc"}),t.gitCompare=new t("git-compare",{fontCharacter:"\\eafd"}),t.gitMerge=new t("git-merge",{fontCharacter:"\\eafe"}),t.githubAction=new t("github-action",{fontCharacter:"\\eaff"}),t.githubAlt=new t("github-alt",{fontCharacter:"\\eb00"}),t.globe=new t("globe",{fontCharacter:"\\eb01"}),t.grabber=new t("grabber",{fontCharacter:"\\eb02"}),t.graph=new t("graph",{fontCharacter:"\\eb03"}),t.gripper=new t("gripper",{fontCharacter:"\\eb04"}),t.heart=new t("heart",{fontCharacter:"\\eb05"}),t.home=new t("home",{fontCharacter:"\\eb06"}),t.horizontalRule=new t("horizontal-rule",{fontCharacter:"\\eb07"}),t.hubot=new t("hubot",{fontCharacter:"\\eb08"}),t.inbox=new t("inbox",{fontCharacter:"\\eb09"}),t.issueClosed=new t("issue-closed",{fontCharacter:"\\eba4"}),t.issueReopened=new t("issue-reopened",{fontCharacter:"\\eb0b"}),t.issues=new t("issues",{fontCharacter:"\\eb0c"}),t.italic=new t("italic",{fontCharacter:"\\eb0d"}),t.jersey=new t("jersey",{fontCharacter:"\\eb0e"}),t.json=new t("json",{fontCharacter:"\\eb0f"}),t.kebabVertical=new t("kebab-vertical",{fontCharacter:"\\eb10"}),t.key=new t("key",{fontCharacter:"\\eb11"}),t.law=new t("law",{fontCharacter:"\\eb12"}),t.lightbulbAutofix=new t("lightbulb-autofix",{fontCharacter:"\\eb13"}),t.linkExternal=new t("link-external",{fontCharacter:"\\eb14"}),t.link=new t("link",{fontCharacter:"\\eb15"}),t.listOrdered=new t("list-ordered",{fontCharacter:"\\eb16"}),t.listUnordered=new t("list-unordered",{fontCharacter:"\\eb17"}),t.liveShare=new t("live-share",{fontCharacter:"\\eb18"}),t.loading=new t("loading",{fontCharacter:"\\eb19"}),t.location=new t("location",{fontCharacter:"\\eb1a"}),t.mailRead=new t("mail-read",{fontCharacter:"\\eb1b"}),t.mail=new t("mail",{fontCharacter:"\\eb1c"}),t.markdown=new t("markdown",{fontCharacter:"\\eb1d"}),t.megaphone=new t("megaphone",{fontCharacter:"\\eb1e"}),t.mention=new t("mention",{fontCharacter:"\\eb1f"}),t.milestone=new t("milestone",{fontCharacter:"\\eb20"}),t.mortarBoard=new t("mortar-board",{fontCharacter:"\\eb21"}),t.move=new t("move",{fontCharacter:"\\eb22"}),t.multipleWindows=new t("multiple-windows",{fontCharacter:"\\eb23"}),t.mute=new t("mute",{fontCharacter:"\\eb24"}),t.noNewline=new t("no-newline",{fontCharacter:"\\eb25"}),t.note=new t("note",{fontCharacter:"\\eb26"}),t.octoface=new t("octoface",{fontCharacter:"\\eb27"}),t.openPreview=new t("open-preview",{fontCharacter:"\\eb28"}),t.package_=new t("package",{fontCharacter:"\\eb29"}),t.paintcan=new t("paintcan",{fontCharacter:"\\eb2a"}),t.pin=new t("pin",{fontCharacter:"\\eb2b"}),t.play=new t("play",{fontCharacter:"\\eb2c"}),t.run=new t("run",{fontCharacter:"\\eb2c"}),t.plug=new t("plug",{fontCharacter:"\\eb2d"}),t.preserveCase=new t("preserve-case",{fontCharacter:"\\eb2e"}),t.preview=new t("preview",{fontCharacter:"\\eb2f"}),t.project=new t("project",{fontCharacter:"\\eb30"}),t.pulse=new t("pulse",{fontCharacter:"\\eb31"}),t.question=new t("question",{fontCharacter:"\\eb32"}),t.quote=new t("quote",{fontCharacter:"\\eb33"}),t.radioTower=new t("radio-tower",{fontCharacter:"\\eb34"}),t.reactions=new t("reactions",{fontCharacter:"\\eb35"}),t.references=new t("references",{fontCharacter:"\\eb36"}),t.refresh=new t("refresh",{fontCharacter:"\\eb37"}),t.regex=new t("regex",{fontCharacter:"\\eb38"}),t.remoteExplorer=new t("remote-explorer",{fontCharacter:"\\eb39"}),t.remote=new t("remote",{fontCharacter:"\\eb3a"}),t.remove=new t("remove",{fontCharacter:"\\eb3b"}),t.replaceAll=new t("replace-all",{fontCharacter:"\\eb3c"}),t.replace=new t("replace",{fontCharacter:"\\eb3d"}),t.repoClone=new t("repo-clone",{fontCharacter:"\\eb3e"}),t.repoForcePush=new t("repo-force-push",{fontCharacter:"\\eb3f"}),t.repoPull=new t("repo-pull",{fontCharacter:"\\eb40"}),t.repoPush=new t("repo-push",{fontCharacter:"\\eb41"}),t.report=new t("report",{fontCharacter:"\\eb42"}),t.requestChanges=new t("request-changes",{fontCharacter:"\\eb43"}),t.rocket=new t("rocket",{fontCharacter:"\\eb44"}),t.rootFolderOpened=new t("root-folder-opened",{fontCharacter:"\\eb45"}),t.rootFolder=new t("root-folder",{fontCharacter:"\\eb46"}),t.rss=new t("rss",{fontCharacter:"\\eb47"}),t.ruby=new t("ruby",{fontCharacter:"\\eb48"}),t.saveAll=new t("save-all",{fontCharacter:"\\eb49"}),t.saveAs=new t("save-as",{fontCharacter:"\\eb4a"}),t.save=new t("save",{fontCharacter:"\\eb4b"}),t.screenFull=new t("screen-full",{fontCharacter:"\\eb4c"}),t.screenNormal=new t("screen-normal",{fontCharacter:"\\eb4d"}),t.searchStop=new t("search-stop",{fontCharacter:"\\eb4e"}),t.server=new t("server",{fontCharacter:"\\eb50"}),t.settingsGear=new t("settings-gear",{fontCharacter:"\\eb51"}),t.settings=new t("settings",{fontCharacter:"\\eb52"}),t.shield=new t("shield",{fontCharacter:"\\eb53"}),t.smiley=new t("smiley",{fontCharacter:"\\eb54"}),t.sortPrecedence=new t("sort-precedence",{fontCharacter:"\\eb55"}),t.splitHorizontal=new t("split-horizontal",{fontCharacter:"\\eb56"}),t.splitVertical=new t("split-vertical",{fontCharacter:"\\eb57"}),t.squirrel=new t("squirrel",{fontCharacter:"\\eb58"}),t.starFull=new t("star-full",{fontCharacter:"\\eb59"}),t.starHalf=new t("star-half",{fontCharacter:"\\eb5a"}),t.symbolClass=new t("symbol-class",{fontCharacter:"\\eb5b"}),t.symbolColor=new t("symbol-color",{fontCharacter:"\\eb5c"}),t.symbolCustomColor=new t("symbol-customcolor",{fontCharacter:"\\eb5c"}),t.symbolConstant=new t("symbol-constant",{fontCharacter:"\\eb5d"}),t.symbolEnumMember=new t("symbol-enum-member",{fontCharacter:"\\eb5e"}),t.symbolField=new t("symbol-field",{fontCharacter:"\\eb5f"}),t.symbolFile=new t("symbol-file",{fontCharacter:"\\eb60"}),t.symbolInterface=new t("symbol-interface",{fontCharacter:"\\eb61"}),t.symbolKeyword=new t("symbol-keyword",{fontCharacter:"\\eb62"}),t.symbolMisc=new t("symbol-misc",{fontCharacter:"\\eb63"}),t.symbolOperator=new t("symbol-operator",{fontCharacter:"\\eb64"}),t.symbolProperty=new t("symbol-property",{fontCharacter:"\\eb65"}),t.wrench=new t("wrench",{fontCharacter:"\\eb65"}),t.wrenchSubaction=new t("wrench-subaction",{fontCharacter:"\\eb65"}),t.symbolSnippet=new t("symbol-snippet",{fontCharacter:"\\eb66"}),t.tasklist=new t("tasklist",{fontCharacter:"\\eb67"}),t.telescope=new t("telescope",{fontCharacter:"\\eb68"}),t.textSize=new t("text-size",{fontCharacter:"\\eb69"}),t.threeBars=new t("three-bars",{fontCharacter:"\\eb6a"}),t.thumbsdown=new t("thumbsdown",{fontCharacter:"\\eb6b"}),t.thumbsup=new t("thumbsup",{fontCharacter:"\\eb6c"}),t.tools=new t("tools",{fontCharacter:"\\eb6d"}),t.triangleDown=new t("triangle-down",{fontCharacter:"\\eb6e"}),t.triangleLeft=new t("triangle-left",{fontCharacter:"\\eb6f"}),t.triangleRight=new t("triangle-right",{fontCharacter:"\\eb70"}),t.triangleUp=new t("triangle-up",{fontCharacter:"\\eb71"}),t.twitter=new t("twitter",{fontCharacter:"\\eb72"}),t.unfold=new t("unfold",{fontCharacter:"\\eb73"}),t.unlock=new t("unlock",{fontCharacter:"\\eb74"}),t.unmute=new t("unmute",{fontCharacter:"\\eb75"}),t.unverified=new t("unverified",{fontCharacter:"\\eb76"}),t.verified=new t("verified",{fontCharacter:"\\eb77"}),t.versions=new t("versions",{fontCharacter:"\\eb78"}),t.vmActive=new t("vm-active",{fontCharacter:"\\eb79"}),t.vmOutline=new t("vm-outline",{fontCharacter:"\\eb7a"}),t.vmRunning=new t("vm-running",{fontCharacter:"\\eb7b"}),t.watch=new t("watch",{fontCharacter:"\\eb7c"}),t.whitespace=new t("whitespace",{fontCharacter:"\\eb7d"}),t.wholeWord=new t("whole-word",{fontCharacter:"\\eb7e"}),t.window=new t("window",{fontCharacter:"\\eb7f"}),t.wordWrap=new t("word-wrap",{fontCharacter:"\\eb80"}),t.zoomIn=new t("zoom-in",{fontCharacter:"\\eb81"}),t.zoomOut=new t("zoom-out",{fontCharacter:"\\eb82"}),t.listFilter=new t("list-filter",{fontCharacter:"\\eb83"}),t.listFlat=new t("list-flat",{fontCharacter:"\\eb84"}),t.listSelection=new t("list-selection",{fontCharacter:"\\eb85"}),t.selection=new t("selection",{fontCharacter:"\\eb85"}),t.listTree=new t("list-tree",{fontCharacter:"\\eb86"}),t.debugBreakpointFunctionUnverified=new t("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),t.debugBreakpointFunction=new t("debug-breakpoint-function",{fontCharacter:"\\eb88"}),t.debugBreakpointFunctionDisabled=new t("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),t.debugStackframeActive=new t("debug-stackframe-active",{fontCharacter:"\\eb89"}),t.circleSmallFilled=new t("circle-small-filled",{fontCharacter:"\\eb8a"}),t.debugStackframeDot=new t("debug-stackframe-dot",t.circleSmallFilled.definition),t.debugStackframe=new t("debug-stackframe",{fontCharacter:"\\eb8b"}),t.debugStackframeFocused=new t("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),t.debugBreakpointUnsupported=new t("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),t.symbolString=new t("symbol-string",{fontCharacter:"\\eb8d"}),t.debugReverseContinue=new t("debug-reverse-continue",{fontCharacter:"\\eb8e"}),t.debugStepBack=new t("debug-step-back",{fontCharacter:"\\eb8f"}),t.debugRestartFrame=new t("debug-restart-frame",{fontCharacter:"\\eb90"}),t.callIncoming=new t("call-incoming",{fontCharacter:"\\eb92"}),t.callOutgoing=new t("call-outgoing",{fontCharacter:"\\eb93"}),t.menu=new t("menu",{fontCharacter:"\\eb94"}),t.expandAll=new t("expand-all",{fontCharacter:"\\eb95"}),t.feedback=new t("feedback",{fontCharacter:"\\eb96"}),t.groupByRefType=new t("group-by-ref-type",{fontCharacter:"\\eb97"}),t.ungroupByRefType=new t("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),t.account=new t("account",{fontCharacter:"\\eb99"}),t.bellDot=new t("bell-dot",{fontCharacter:"\\eb9a"}),t.debugConsole=new t("debug-console",{fontCharacter:"\\eb9b"}),t.library=new t("library",{fontCharacter:"\\eb9c"}),t.output=new t("output",{fontCharacter:"\\eb9d"}),t.runAll=new t("run-all",{fontCharacter:"\\eb9e"}),t.syncIgnored=new t("sync-ignored",{fontCharacter:"\\eb9f"}),t.pinned=new t("pinned",{fontCharacter:"\\eba0"}),t.githubInverted=new t("github-inverted",{fontCharacter:"\\eba1"}),t.debugAlt=new t("debug-alt",{fontCharacter:"\\eb91"}),t.serverProcess=new t("server-process",{fontCharacter:"\\eba2"}),t.serverEnvironment=new t("server-environment",{fontCharacter:"\\eba3"}),t.pass=new t("pass",{fontCharacter:"\\eba4"}),t.stopCircle=new t("stop-circle",{fontCharacter:"\\eba5"}),t.playCircle=new t("play-circle",{fontCharacter:"\\eba6"}),t.record=new t("record",{fontCharacter:"\\eba7"}),t.debugAltSmall=new t("debug-alt-small",{fontCharacter:"\\eba8"}),t.vmConnect=new t("vm-connect",{fontCharacter:"\\eba9"}),t.cloud=new t("cloud",{fontCharacter:"\\ebaa"}),t.merge=new t("merge",{fontCharacter:"\\ebab"}),t.exportIcon=new t("export",{fontCharacter:"\\ebac"}),t.graphLeft=new t("graph-left",{fontCharacter:"\\ebad"}),t.magnet=new t("magnet",{fontCharacter:"\\ebae"}),t.notebook=new t("notebook",{fontCharacter:"\\ebaf"}),t.redo=new t("redo",{fontCharacter:"\\ebb0"}),t.checkAll=new t("check-all",{fontCharacter:"\\ebb1"}),t.pinnedDirty=new t("pinned-dirty",{fontCharacter:"\\ebb2"}),t.passFilled=new t("pass-filled",{fontCharacter:"\\ebb3"}),t.circleLargeFilled=new t("circle-large-filled",{fontCharacter:"\\ebb4"}),t.circleLarge=new t("circle-large",{fontCharacter:"\\ebb5"}),t.circleLargeOutline=new t("circle-large-outline",t.circleLarge.definition),t.combine=new t("combine",{fontCharacter:"\\ebb6"}),t.gather=new t("gather",{fontCharacter:"\\ebb6"}),t.table=new t("table",{fontCharacter:"\\ebb7"}),t.variableGroup=new t("variable-group",{fontCharacter:"\\ebb8"}),t.typeHierarchy=new t("type-hierarchy",{fontCharacter:"\\ebb9"}),t.typeHierarchySub=new t("type-hierarchy-sub",{fontCharacter:"\\ebba"}),t.typeHierarchySuper=new t("type-hierarchy-super",{fontCharacter:"\\ebbb"}),t.gitPullRequestCreate=new t("git-pull-request-create",{fontCharacter:"\\ebbc"}),t.runAbove=new t("run-above",{fontCharacter:"\\ebbd"}),t.runBelow=new t("run-below",{fontCharacter:"\\ebbe"}),t.notebookTemplate=new t("notebook-template",{fontCharacter:"\\ebbf"}),t.debugRerun=new t("debug-rerun",{fontCharacter:"\\ebc0"}),t.workspaceTrusted=new t("workspace-trusted",{fontCharacter:"\\ebc1"}),t.workspaceUntrusted=new t("workspace-untrusted",{fontCharacter:"\\ebc2"}),t.workspaceUnspecified=new t("workspace-unspecified",{fontCharacter:"\\ebc3"}),t.terminalCmd=new t("terminal-cmd",{fontCharacter:"\\ebc4"}),t.terminalDebian=new t("terminal-debian",{fontCharacter:"\\ebc5"}),t.terminalLinux=new t("terminal-linux",{fontCharacter:"\\ebc6"}),t.terminalPowershell=new t("terminal-powershell",{fontCharacter:"\\ebc7"}),t.terminalTmux=new t("terminal-tmux",{fontCharacter:"\\ebc8"}),t.terminalUbuntu=new t("terminal-ubuntu",{fontCharacter:"\\ebc9"}),t.terminalBash=new t("terminal-bash",{fontCharacter:"\\ebca"}),t.arrowSwap=new t("arrow-swap",{fontCharacter:"\\ebcb"}),t.copy=new t("copy",{fontCharacter:"\\ebcc"}),t.personAdd=new t("person-add",{fontCharacter:"\\ebcd"}),t.filterFilled=new t("filter-filled",{fontCharacter:"\\ebce"}),t.wand=new t("wand",{fontCharacter:"\\ebcf"}),t.debugLineByLine=new t("debug-line-by-line",{fontCharacter:"\\ebd0"}),t.inspect=new t("inspect",{fontCharacter:"\\ebd1"}),t.layers=new t("layers",{fontCharacter:"\\ebd2"}),t.layersDot=new t("layers-dot",{fontCharacter:"\\ebd3"}),t.layersActive=new t("layers-active",{fontCharacter:"\\ebd4"}),t.compass=new t("compass",{fontCharacter:"\\ebd5"}),t.compassDot=new t("compass-dot",{fontCharacter:"\\ebd6"}),t.compassActive=new t("compass-active",{fontCharacter:"\\ebd7"}),t.azure=new t("azure",{fontCharacter:"\\ebd8"}),t.issueDraft=new t("issue-draft",{fontCharacter:"\\ebd9"}),t.gitPullRequestClosed=new t("git-pull-request-closed",{fontCharacter:"\\ebda"}),t.gitPullRequestDraft=new t("git-pull-request-draft",{fontCharacter:"\\ebdb"}),t.debugAll=new t("debug-all",{fontCharacter:"\\ebdc"}),t.debugCoverage=new t("debug-coverage",{fontCharacter:"\\ebdd"}),t.runErrors=new t("run-errors",{fontCharacter:"\\ebde"}),t.folderLibrary=new t("folder-library",{fontCharacter:"\\ebdf"}),t.debugContinueSmall=new t("debug-continue-small",{fontCharacter:"\\ebe0"}),t.beakerStop=new t("beaker-stop",{fontCharacter:"\\ebe1"}),t.graphLine=new t("graph-line",{fontCharacter:"\\ebe2"}),t.graphScatter=new t("graph-scatter",{fontCharacter:"\\ebe3"}),t.pieChart=new t("pie-chart",{fontCharacter:"\\ebe4"}),t.bracket=new t("bracket",t.json.definition),t.bracketDot=new t("bracket-dot",{fontCharacter:"\\ebe5"}),t.bracketError=new t("bracket-error",{fontCharacter:"\\ebe6"}),t.lockSmall=new t("lock-small",{fontCharacter:"\\ebe7"}),t.azureDevops=new t("azure-devops",{fontCharacter:"\\ebe8"}),t.verifiedFilled=new t("verified-filled",{fontCharacter:"\\ebe9"}),t.newLine=new t("newline",{fontCharacter:"\\ebea"}),t.layout=new t("layout",{fontCharacter:"\\ebeb"}),t.layoutActivitybarLeft=new t("layout-activitybar-left",{fontCharacter:"\\ebec"}),t.layoutActivitybarRight=new t("layout-activitybar-right",{fontCharacter:"\\ebed"}),t.layoutPanelLeft=new t("layout-panel-left",{fontCharacter:"\\ebee"}),t.layoutPanelCenter=new t("layout-panel-center",{fontCharacter:"\\ebef"}),t.layoutPanelJustify=new t("layout-panel-justify",{fontCharacter:"\\ebf0"}),t.layoutPanelRight=new t("layout-panel-right",{fontCharacter:"\\ebf1"}),t.layoutPanel=new t("layout-panel",{fontCharacter:"\\ebf2"}),t.layoutSidebarLeft=new t("layout-sidebar-left",{fontCharacter:"\\ebf3"}),t.layoutSidebarRight=new t("layout-sidebar-right",{fontCharacter:"\\ebf4"}),t.layoutStatusbar=new t("layout-statusbar",{fontCharacter:"\\ebf5"}),t.layoutMenubar=new t("layout-menubar",{fontCharacter:"\\ebf6"}),t.layoutCentered=new t("layout-centered",{fontCharacter:"\\ebf7"}),t.layoutSidebarRightOff=new t("layout-sidebar-right-off",{fontCharacter:"\\ec00"}),t.layoutPanelOff=new t("layout-panel-off",{fontCharacter:"\\ec01"}),t.layoutSidebarLeftOff=new t("layout-sidebar-left-off",{fontCharacter:"\\ec02"}),t.target=new t("target",{fontCharacter:"\\ebf8"}),t.indent=new t("indent",{fontCharacter:"\\ebf9"}),t.recordSmall=new t("record-small",{fontCharacter:"\\ebfa"}),t.errorSmall=new t("error-small",{fontCharacter:"\\ebfb"}),t.arrowCircleDown=new t("arrow-circle-down",{fontCharacter:"\\ebfc"}),t.arrowCircleLeft=new t("arrow-circle-left",{fontCharacter:"\\ebfd"}),t.arrowCircleRight=new t("arrow-circle-right",{fontCharacter:"\\ebfe"}),t.arrowCircleUp=new t("arrow-circle-up",{fontCharacter:"\\ebff"}),t.heartFilled=new t("heart-filled",{fontCharacter:"\\ec04"}),t.map=new t("map",{fontCharacter:"\\ec05"}),t.mapFilled=new t("map-filled",{fontCharacter:"\\ec06"}),t.circleSmall=new t("circle-small",{fontCharacter:"\\ec07"}),t.bellSlash=new t("bell-slash",{fontCharacter:"\\ec08"}),t.bellSlashDot=new t("bell-slash-dot",{fontCharacter:"\\ec09"}),t.commentUnresolved=new t("comment-unresolved",{fontCharacter:"\\ec0a"}),t.gitPullRequestGoToChanges=new t("git-pull-request-go-to-changes",{fontCharacter:"\\ec0b"}),t.gitPullRequestNewChanges=new t("git-pull-request-new-changes",{fontCharacter:"\\ec0c"}),t.searchFuzzy=new t("search-fuzzy",{fontCharacter:"\\ec0d"}),t.commentDraft=new t("comment-draft",{fontCharacter:"\\ec0e"}),t.dialogError=new t("dialog-error",t.error.definition),t.dialogWarning=new t("dialog-warning",t.warning.definition),t.dialogInfo=new t("dialog-info",t.info.definition),t.dialogClose=new t("dialog-close",t.close.definition),t.treeItemExpanded=new t("tree-item-expanded",t.chevronDown.definition),t.treeFilterOnTypeOn=new t("tree-filter-on-type-on",t.listFilter.definition),t.treeFilterOnTypeOff=new t("tree-filter-on-type-off",t.listSelection.definition),t.treeFilterClear=new t("tree-filter-clear",t.close.definition),t.treeItemLoading=new t("tree-item-loading",t.loading.definition),t.menuSelection=new t("menu-selection",t.check.definition),t.menuSubmenu=new t("menu-submenu",t.chevronRight.definition),t.menuBarMore=new t("menubar-more",t.more.definition),t.scrollbarButtonLeft=new t("scrollbar-button-left",t.triangleLeft.definition),t.scrollbarButtonRight=new t("scrollbar-button-right",t.triangleRight.definition),t.scrollbarButtonUp=new t("scrollbar-button-up",t.triangleUp.definition),t.scrollbarButtonDown=new t("scrollbar-button-down",t.triangleDown.definition),t.toolBarMore=new t("toolbar-more",t.more.definition),t.quickInputBack=new t("quick-input-back",t.arrowLeft.definition);var D;(function(c){c.iconNameSegment="[A-Za-z0-9]+",c.iconNameExpression="[A-Za-z0-9-]+",c.iconModifierExpression="~[A-Za-z]+",c.iconNameCharacter="[A-Za-z0-9~-]";const _=new RegExp(`^(${c.iconNameExpression})(${c.iconModifierExpression})?$`);function h(A){if(A instanceof t)return["codicon","codicon-"+A.id];const R=_.exec(A.id);if(!R)return h(t.error);const[,p,m]=R,e=["codicon","codicon-"+p];return m&&e.push("codicon-modifier-"+m.substring(1)),e}c.asClassNameArray=h;function l(A){return h(A).join(" ")}c.asClassName=l;function f(A){return"."+h(A).join(".")}c.asCSSSelector=f})(D=n.CSSIcon||(n.CSSIcon={}))}),Z(K[25],x([0,1]),function(B,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.DiffChange=void 0;class E{constructor(D,c,_,h){this.originalStart=D,this.originalLength=c,this.modifiedStart=_,this.modifiedLength=h}getOriginalEnd(){return this.originalStart+this.originalLength}getModifiedEnd(){return this.modifiedStart+this.modifiedLength}}n.DiffChange=E}),Z(K[6],x([0,1]),function(B,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.BugIndicatingError=n.ErrorNoTelemetry=n.ExpectedError=n.NotSupportedError=n.NotImplementedError=n.getErrorMessage=n.disposed=n.readonly=n.illegalState=n.illegalArgument=n.canceled=n.CancellationError=n.isCancellationError=n.transformErrorForSerialization=n.onUnexpectedExternalError=n.onUnexpectedError=n.setUnexpectedErrorHandler=n.errorHandler=n.ErrorHandler=void 0;class E{constructor(){this.b=[],this.a=function(o){setTimeout(()=>{throw o.stack?s.isErrorNoTelemetry(o)?new s(o.message+`

`+o.stack):new Error(o.message+`

`+o.stack):o},0)}}addListener(o){return this.b.push(o),()=>{this.d(o)}}c(o){this.b.forEach(u=>{u(o)})}d(o){this.b.splice(this.b.indexOf(o),1)}setUnexpectedErrorHandler(o){this.a=o}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(o){this.a(o),this.c(o)}onUnexpectedExternalError(o){this.a(o)}}n.ErrorHandler=E,n.errorHandler=new E;function t(i){n.errorHandler.setUnexpectedErrorHandler(i)}n.setUnexpectedErrorHandler=t;function D(i){l(i)||n.errorHandler.onUnexpectedError(i)}n.onUnexpectedError=D;function c(i){l(i)||n.errorHandler.onUnexpectedExternalError(i)}n.onUnexpectedExternalError=c;function _(i){if(i instanceof Error){const{name:o,message:u}=i,d=i.stacktrace||i.stack;return{$isError:!0,name:o,message:u,stack:d,noTelemetry:s.isErrorNoTelemetry(i)}}return i}n.transformErrorForSerialization=_;const h="Canceled";function l(i){return i instanceof f?!0:i instanceof Error&&i.name===h&&i.message===h}n.isCancellationError=l;class f extends Error{constructor(){super(h),this.name=this.message}}n.CancellationError=f;function A(){const i=new Error(h);return i.name=i.message,i}n.canceled=A;function R(i){return i?new Error(`Illegal argument: ${i}`):new Error("Illegal argument")}n.illegalArgument=R;function p(i){return i?new Error(`Illegal state: ${i}`):new Error("Illegal state")}n.illegalState=p;function m(i){return i?new Error(`readonly property '${i} cannot be changed'`):new Error("readonly property cannot be changed")}n.readonly=m;function e(i){const o=new Error(`${i} has been disposed`);return o.name="DISPOSED",o}n.disposed=e;function C(i){return i?i.message?i.message:i.stack?i.stack.split(`
`)[0]:String(i):"Error"}n.getErrorMessage=C;class F extends Error{constructor(o){super("NotImplemented"),o&&(this.message=o)}}n.NotImplementedError=F;class y extends Error{constructor(o){super("NotSupported"),o&&(this.message=o)}}n.NotSupportedError=y;class L extends Error{constructor(){super(...arguments),this.isExpected=!0}}n.ExpectedError=L;class s extends Error{constructor(o){super(o),this.name="CodeExpectedError"}static fromError(o){if(o instanceof s)return o;const u=new s;return u.message=o.message,u.stack=o.stack,u}static isErrorNoTelemetry(o){return o.name==="CodeExpectedError"}}n.ErrorNoTelemetry=s;class a extends Error{constructor(o){super(o||"An unexpected bug occurred."),Object.setPrototypeOf(this,a.prototype);debugger}}n.BugIndicatingError=a}),Z(K[26],x([0,1,6]),function(B,n,E){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.CallbackIterable=n.ArrayQueue=n.findMinBy=n.findLastMaxBy=n.findMaxBy=n.numberComparator=n.tieBreakComparators=n.compareBy=n.CompareResult=n.splice=n.insertInto=n.mapFind=n.getRandomElement=n.asArray=n.mapArrayOrNot=n.pushMany=n.pushToEnd=n.pushToStart=n.shuffle=n.arrayInsert=n.remove=n.insert=n.index=n.range=n.flatten=n.commonPrefixLength=n.lastOrDefault=n.firstOrDefault=n.lastIndex=n.findLast=n.uniqueFilter=n.distinct=n.isNonEmptyArray=n.isFalsyOrEmpty=n.move=n.coalesceInPlace=n.coalesce=n.topAsync=n.top=n.delta=n.sortedDiff=n.groupBy=n.quickSelect=n.findFirstInSorted=n.binarySearch2=n.binarySearch=n.removeFastWithoutKeepingOrder=n.equals=n.tail2=n.tail=void 0;function t(k,T=0){return k[k.length-(1+T)]}n.tail=t;function D(k){if(k.length===0)throw new Error("Invalid tail call");return[k.slice(0,k.length-1),k[k.length-1]]}n.tail2=D;function c(k,T,S=(W,H)=>W===H){if(k===T)return!0;if(!k||!T||k.length!==T.length)return!1;for(let W=0,H=k.length;W<H;W++)if(!S(k[W],T[W]))return!1;return!0}n.equals=c;function _(k,T){const S=k.length-1;T<S&&(k[T]=k[S]),k.pop()}n.removeFastWithoutKeepingOrder=_;function h(k,T,S){return l(k.length,W=>S(k[W],T))}n.binarySearch=h;function l(k,T){let S=0,W=k-1;for(;S<=W;){const H=(S+W)/2|0,re=T(H);if(re<0)S=H+1;else if(re>0)W=H-1;else return H}return-(S+1)}n.binarySearch2=l;function f(k,T){let S=0,W=k.length;if(W===0)return 0;for(;S<W;){const H=Math.floor((S+W)/2);T(k[H])?W=H:S=H+1}return S}n.findFirstInSorted=f;function A(k,T,S){if(k=k|0,k>=T.length)throw new TypeError("invalid index");const W=T[Math.floor(T.length*Math.random())],H=[],re=[],ie=[];for(const ue of T){const ae=S(ue,W);ae<0?H.push(ue):ae>0?re.push(ue):ie.push(ue)}return k<H.length?A(k,H,S):k<H.length+ie.length?ie[0]:A(k-(H.length+ie.length),re,S)}n.quickSelect=A;function R(k,T){const S=[];let W;for(const H of k.slice(0).sort(T))!W||T(W[0],H)!==0?(W=[H],S.push(W)):W.push(H);return S}n.groupBy=R;function p(k,T,S){const W=[];function H(ue,ae,fe){if(ae===0&&fe.length===0)return;const he=W[W.length-1];he&&he.start+he.deleteCount===ue?(he.deleteCount+=ae,he.toInsert.push(...fe)):W.push({start:ue,deleteCount:ae,toInsert:fe})}let re=0,ie=0;for(;;){if(re===k.length){H(re,0,T.slice(ie));break}if(ie===T.length){H(re,k.length-re,[]);break}const ue=k[re],ae=T[ie],fe=S(ue,ae);fe===0?(re+=1,ie+=1):fe<0?(H(re,1,[]),re+=1):fe>0&&(H(re,0,[ae]),ie+=1)}return W}n.sortedDiff=p;function m(k,T,S){const W=p(k,T,S),H=[],re=[];for(const ie of W)H.push(...k.slice(ie.start,ie.start+ie.deleteCount)),re.push(...ie.toInsert);return{removed:H,added:re}}n.delta=m;function e(k,T,S){if(S===0)return[];const W=k.slice(0,S).sort(T);return F(k,T,W,S,k.length),W}n.top=e;function C(k,T,S,W,H){return S===0?Promise.resolve([]):new Promise((re,ie)=>{(async()=>{const ue=k.length,ae=k.slice(0,S).sort(T);for(let fe=S,he=Math.min(S+W,ue);fe<ue;fe=he,he=Math.min(he+W,ue)){if(fe>S&&await new Promise(ke=>setTimeout(ke)),H&&H.isCancellationRequested)throw new E.CancellationError;F(k,T,ae,fe,he)}return ae})().then(re,ie)})}n.topAsync=C;function F(k,T,S,W,H){for(const re=S.length;W<H;W++){const ie=k[W];if(T(ie,S[re-1])<0){S.pop();const ue=f(S,ae=>T(ie,ae)<0);S.splice(ue,0,ie)}}}function y(k){return k.filter(T=>!!T)}n.coalesce=y;function L(k){let T=0;for(let S=0;S<k.length;S++)k[S]&&(k[T]=k[S],T+=1);k.length=T}n.coalesceInPlace=L;function s(k,T,S){k.splice(S,0,k.splice(T,1)[0])}n.move=s;function a(k){return!Array.isArray(k)||k.length===0}n.isFalsyOrEmpty=a;function i(k){return Array.isArray(k)&&k.length>0}n.isNonEmptyArray=i;function o(k,T=S=>S){const S=new Set;return k.filter(W=>{const H=T(W);return S.has(H)?!1:(S.add(H),!0)})}n.distinct=o;function u(k){const T=new Set;return S=>{const W=k(S);return T.has(W)?!1:(T.add(W),!0)}}n.uniqueFilter=u;function d(k,T){const S=g(k,T);if(S!==-1)return k[S]}n.findLast=d;function g(k,T){for(let S=k.length-1;S>=0;S--){const W=k[S];if(T(W))return S}return-1}n.lastIndex=g;function N(k,T){return k.length>0?k[0]:T}n.firstOrDefault=N;function b(k,T){return k.length>0?k[k.length-1]:T}n.lastOrDefault=b;function w(k,T,S=(W,H)=>W===H){let W=0;for(let H=0,re=Math.min(k.length,T.length);H<re&&S(k[H],T[H]);H++)W++;return W}n.commonPrefixLength=w;function v(k){return[].concat(...k)}n.flatten=v;function M(k,T){let S=typeof T=="number"?k:0;typeof T=="number"?S=k:(S=0,T=k);const W=[];if(S<=T)for(let H=S;H<T;H++)W.push(H);else for(let H=S;H>T;H--)W.push(H);return W}n.range=M;function I(k,T,S){return k.reduce((W,H)=>(W[T(H)]=S?S(H):H,W),Object.create(null))}n.index=I;function O(k,T){return k.push(T),()=>q(k,T)}n.insert=O;function q(k,T){const S=k.indexOf(T);if(S>-1)return k.splice(S,1),T}n.remove=q;function $(k,T,S){const W=k.slice(0,T),H=k.slice(T);return W.concat(S,H)}n.arrayInsert=$;function j(k,T){let S;if(typeof T=="number"){let W=T;S=()=>{const H=Math.sin(W++)*179426549;return H-Math.floor(H)}}else S=Math.random;for(let W=k.length-1;W>0;W-=1){const H=Math.floor(S()*(W+1)),re=k[W];k[W]=k[H],k[H]=re}}n.shuffle=j;function ne(k,T){const S=k.indexOf(T);S>-1&&(k.splice(S,1),k.unshift(T))}n.pushToStart=ne;function te(k,T){const S=k.indexOf(T);S>-1&&(k.splice(S,1),k.push(T))}n.pushToEnd=te;function Q(k,T){for(const S of T)k.push(S)}n.pushMany=Q;function J(k,T){return Array.isArray(k)?k.map(T):T(k)}n.mapArrayOrNot=J;function r(k){return Array.isArray(k)?k:[k]}n.asArray=r;function ve(k){return k[Math.floor(Math.random()*k.length)]}n.getRandomElement=ve;function Ae(k,T){for(const S of k){const W=T(S);if(W!==void 0)return W}}n.mapFind=Ae;function de(k,T,S){const W=Le(k,T),H=k.length,re=S.length;k.length=H+re;for(let ie=H-1;ie>=W;ie--)k[ie+re]=k[ie];for(let ie=0;ie<re;ie++)k[ie+W]=S[ie]}n.insertInto=de;function Ce(k,T,S,W){const H=Le(k,T),re=k.splice(H,S);return de(k,H,W),re}n.splice=Ce;function Le(k,T){return T<0?Math.max(T+k.length,0):Math.min(T,k.length)}var Ne;(function(k){function T(H){return H<0}k.isLessThan=T;function S(H){return H>0}k.isGreaterThan=S;function W(H){return H===0}k.isNeitherLessOrGreaterThan=W,k.greaterThan=1,k.lessThan=-1,k.neitherLessOrGreaterThan=0})(Ne=n.CompareResult||(n.CompareResult={}));function _e(k,T){return(S,W)=>T(k(S),k(W))}n.compareBy=_e;function Me(...k){return(T,S)=>{for(const W of k){const H=W(T,S);if(!Ne.isNeitherLessOrGreaterThan(H))return H}return Ne.neitherLessOrGreaterThan}}n.tieBreakComparators=Me;const De=(k,T)=>k-T;n.numberComparator=De;function Ee(k,T){if(k.length===0)return;let S=k[0];for(let W=1;W<k.length;W++){const H=k[W];T(H,S)>0&&(S=H)}return S}n.findMaxBy=Ee;function Fe(k,T){if(k.length===0)return;let S=k[0];for(let W=1;W<k.length;W++){const H=k[W];T(H,S)>=0&&(S=H)}return S}n.findLastMaxBy=Fe;function ee(k,T){return Ee(k,(S,W)=>-T(S,W))}n.findMinBy=ee;class G{constructor(T){this.f=T,this.c=0,this.d=this.f.length-1}get length(){return this.d-this.c+1}takeWhile(T){let S=this.c;for(;S<this.f.length&&T(this.f[S]);)S++;const W=S===this.c?null:this.f.slice(this.c,S);return this.c=S,W}takeFromEndWhile(T){let S=this.d;for(;S>=0&&T(this.f[S]);)S--;const W=S===this.d?null:this.f.slice(S+1,this.d+1);return this.d=S,W}peek(){if(this.length!==0)return this.f[this.c]}peekLast(){if(this.length!==0)return this.f[this.d]}dequeue(){const T=this.f[this.c];return this.c++,T}removeLast(){const T=this.f[this.d];return this.d--,T}takeCount(T){const S=this.f.slice(this.c,this.c+T);return this.c+=T,S}}n.ArrayQueue=G;class Y{constructor(T){this.iterate=T}forEach(T){this.iterate(S=>(T(S),!0))}toArray(){const T=[];return this.iterate(S=>(T.push(S),!0)),T}filter(T){return new Y(S=>this.iterate(W=>T(W)?S(W):!0))}map(T){return new Y(S=>this.iterate(W=>S(T(W))))}some(T){let S=!1;return this.iterate(W=>(S=T(W),!S)),S}findFirst(T){let S;return this.iterate(W=>T(W)?(S=W,!1):!0),S}findLast(T){let S;return this.iterate(W=>(T(W)&&(S=W),!0)),S}findLastMaxBy(T){let S,W=!0;return this.iterate(H=>((W||Ne.isGreaterThan(T(H,S)))&&(W=!1,S=H),!0)),S}}n.CallbackIterable=Y,Y.empty=new Y(k=>{})}),Z(K[10],x([0,1,6]),function(B,n,E){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.checkAdjacentItems=n.assertFn=n.assert=n.assertNever=n.ok=void 0;function t(l,f){if(!l)throw new Error(f?`Assertion failed (${f})`:"Assertion Failed")}n.ok=t;function D(l,f="Unreachable"){throw new Error(f)}n.assertNever=D;function c(l){if(!l)throw new E.BugIndicatingError("Assertion Failed")}n.assert=c;function _(l){if(!l()){debugger;l(),(0,E.onUnexpectedError)(new E.BugIndicatingError("Assertion Failed"))}}n.assertFn=_;function h(l,f){let A=0;for(;A<l.length-1;){const R=l[A],p=l[A+1];if(!f(R,p))return!1;A++}return!0}n.checkAdjacentItems=h}),Z(K[13],x([0,1]),function(B,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.once=void 0;function E(t){const D=this;let c=!1,_;return function(){return c||(c=!0,_=t.apply(D,arguments)),_}}n.once=E}),Z(K[14],x([0,1]),function(B,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Iterable=void 0;var E;(function(t){function D(a){return a&&typeof a=="object"&&typeof a[Symbol.iterator]=="function"}t.is=D;const c=Object.freeze([]);function _(){return c}t.empty=_;function*h(a){yield a}t.single=h;function l(a){return D(a)?a:h(a)}t.wrap=l;function f(a){return a||c}t.from=f;function A(a){return!a||a[Symbol.iterator]().next().done===!0}t.isEmpty=A;function R(a){return a[Symbol.iterator]().next().value}t.first=R;function p(a,i){for(const o of a)if(i(o))return!0;return!1}t.some=p;function m(a,i){for(const o of a)if(i(o))return o}t.find=m;function*e(a,i){for(const o of a)i(o)&&(yield o)}t.filter=e;function*C(a,i){let o=0;for(const u of a)yield i(u,o++)}t.map=C;function*F(...a){for(const i of a)for(const o of i)yield o}t.concat=F;function y(a,i,o){let u=o;for(const d of a)u=i(u,d);return u}t.reduce=y;function*L(a,i,o=a.length){for(i<0&&(i+=a.length),o<0?o+=a.length:o>a.length&&(o=a.length);i<o;i++)yield a[i]}t.slice=L;function s(a,i=Number.POSITIVE_INFINITY){const o=[];if(i===0)return[o,a];const u=a[Symbol.iterator]();for(let d=0;d<i;d++){const g=u.next();if(g.done)return[o,t.empty()];o.push(g.value)}return[o,{[Symbol.iterator](){return u}}]}t.consume=s})(E=n.Iterable||(n.Iterable={}))}),Z(K[27],x([0,1]),function(B,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.KeyChord=n.KeyMod=n.KeyCodeUtils=n.IMMUTABLE_KEY_CODE_TO_CODE=n.IMMUTABLE_CODE_TO_KEY_CODE=n.ScanCodeUtils=n.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE=n.EVENT_KEY_CODE_MAP=n.ScanCode=n.KeyCode=void 0;var E;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.Unknown=0]="Unknown",e[e.Backspace=1]="Backspace",e[e.Tab=2]="Tab",e[e.Enter=3]="Enter",e[e.Shift=4]="Shift",e[e.Ctrl=5]="Ctrl",e[e.Alt=6]="Alt",e[e.PauseBreak=7]="PauseBreak",e[e.CapsLock=8]="CapsLock",e[e.Escape=9]="Escape",e[e.Space=10]="Space",e[e.PageUp=11]="PageUp",e[e.PageDown=12]="PageDown",e[e.End=13]="End",e[e.Home=14]="Home",e[e.LeftArrow=15]="LeftArrow",e[e.UpArrow=16]="UpArrow",e[e.RightArrow=17]="RightArrow",e[e.DownArrow=18]="DownArrow",e[e.Insert=19]="Insert",e[e.Delete=20]="Delete",e[e.Digit0=21]="Digit0",e[e.Digit1=22]="Digit1",e[e.Digit2=23]="Digit2",e[e.Digit3=24]="Digit3",e[e.Digit4=25]="Digit4",e[e.Digit5=26]="Digit5",e[e.Digit6=27]="Digit6",e[e.Digit7=28]="Digit7",e[e.Digit8=29]="Digit8",e[e.Digit9=30]="Digit9",e[e.KeyA=31]="KeyA",e[e.KeyB=32]="KeyB",e[e.KeyC=33]="KeyC",e[e.KeyD=34]="KeyD",e[e.KeyE=35]="KeyE",e[e.KeyF=36]="KeyF",e[e.KeyG=37]="KeyG",e[e.KeyH=38]="KeyH",e[e.KeyI=39]="KeyI",e[e.KeyJ=40]="KeyJ",e[e.KeyK=41]="KeyK",e[e.KeyL=42]="KeyL",e[e.KeyM=43]="KeyM",e[e.KeyN=44]="KeyN",e[e.KeyO=45]="KeyO",e[e.KeyP=46]="KeyP",e[e.KeyQ=47]="KeyQ",e[e.KeyR=48]="KeyR",e[e.KeyS=49]="KeyS",e[e.KeyT=50]="KeyT",e[e.KeyU=51]="KeyU",e[e.KeyV=52]="KeyV",e[e.KeyW=53]="KeyW",e[e.KeyX=54]="KeyX",e[e.KeyY=55]="KeyY",e[e.KeyZ=56]="KeyZ",e[e.Meta=57]="Meta",e[e.ContextMenu=58]="ContextMenu",e[e.F1=59]="F1",e[e.F2=60]="F2",e[e.F3=61]="F3",e[e.F4=62]="F4",e[e.F5=63]="F5",e[e.F6=64]="F6",e[e.F7=65]="F7",e[e.F8=66]="F8",e[e.F9=67]="F9",e[e.F10=68]="F10",e[e.F11=69]="F11",e[e.F12=70]="F12",e[e.F13=71]="F13",e[e.F14=72]="F14",e[e.F15=73]="F15",e[e.F16=74]="F16",e[e.F17=75]="F17",e[e.F18=76]="F18",e[e.F19=77]="F19",e[e.NumLock=78]="NumLock",e[e.ScrollLock=79]="ScrollLock",e[e.Semicolon=80]="Semicolon",e[e.Equal=81]="Equal",e[e.Comma=82]="Comma",e[e.Minus=83]="Minus",e[e.Period=84]="Period",e[e.Slash=85]="Slash",e[e.Backquote=86]="Backquote",e[e.BracketLeft=87]="BracketLeft",e[e.Backslash=88]="Backslash",e[e.BracketRight=89]="BracketRight",e[e.Quote=90]="Quote",e[e.OEM_8=91]="OEM_8",e[e.IntlBackslash=92]="IntlBackslash",e[e.Numpad0=93]="Numpad0",e[e.Numpad1=94]="Numpad1",e[e.Numpad2=95]="Numpad2",e[e.Numpad3=96]="Numpad3",e[e.Numpad4=97]="Numpad4",e[e.Numpad5=98]="Numpad5",e[e.Numpad6=99]="Numpad6",e[e.Numpad7=100]="Numpad7",e[e.Numpad8=101]="Numpad8",e[e.Numpad9=102]="Numpad9",e[e.NumpadMultiply=103]="NumpadMultiply",e[e.NumpadAdd=104]="NumpadAdd",e[e.NUMPAD_SEPARATOR=105]="NUMPAD_SEPARATOR",e[e.NumpadSubtract=106]="NumpadSubtract",e[e.NumpadDecimal=107]="NumpadDecimal",e[e.NumpadDivide=108]="NumpadDivide",e[e.KEY_IN_COMPOSITION=109]="KEY_IN_COMPOSITION",e[e.ABNT_C1=110]="ABNT_C1",e[e.ABNT_C2=111]="ABNT_C2",e[e.AudioVolumeMute=112]="AudioVolumeMute",e[e.AudioVolumeUp=113]="AudioVolumeUp",e[e.AudioVolumeDown=114]="AudioVolumeDown",e[e.BrowserSearch=115]="BrowserSearch",e[e.BrowserHome=116]="BrowserHome",e[e.BrowserBack=117]="BrowserBack",e[e.BrowserForward=118]="BrowserForward",e[e.MediaTrackNext=119]="MediaTrackNext",e[e.MediaTrackPrevious=120]="MediaTrackPrevious",e[e.MediaStop=121]="MediaStop",e[e.MediaPlayPause=122]="MediaPlayPause",e[e.LaunchMediaPlayer=123]="LaunchMediaPlayer",e[e.LaunchMail=124]="LaunchMail",e[e.LaunchApp2=125]="LaunchApp2",e[e.Clear=126]="Clear",e[e.MAX_VALUE=127]="MAX_VALUE"})(E=n.KeyCode||(n.KeyCode={}));var t;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.None=0]="None",e[e.Hyper=1]="Hyper",e[e.Super=2]="Super",e[e.Fn=3]="Fn",e[e.FnLock=4]="FnLock",e[e.Suspend=5]="Suspend",e[e.Resume=6]="Resume",e[e.Turbo=7]="Turbo",e[e.Sleep=8]="Sleep",e[e.WakeUp=9]="WakeUp",e[e.KeyA=10]="KeyA",e[e.KeyB=11]="KeyB",e[e.KeyC=12]="KeyC",e[e.KeyD=13]="KeyD",e[e.KeyE=14]="KeyE",e[e.KeyF=15]="KeyF",e[e.KeyG=16]="KeyG",e[e.KeyH=17]="KeyH",e[e.KeyI=18]="KeyI",e[e.KeyJ=19]="KeyJ",e[e.KeyK=20]="KeyK",e[e.KeyL=21]="KeyL",e[e.KeyM=22]="KeyM",e[e.KeyN=23]="KeyN",e[e.KeyO=24]="KeyO",e[e.KeyP=25]="KeyP",e[e.KeyQ=26]="KeyQ",e[e.KeyR=27]="KeyR",e[e.KeyS=28]="KeyS",e[e.KeyT=29]="KeyT",e[e.KeyU=30]="KeyU",e[e.KeyV=31]="KeyV",e[e.KeyW=32]="KeyW",e[e.KeyX=33]="KeyX",e[e.KeyY=34]="KeyY",e[e.KeyZ=35]="KeyZ",e[e.Digit1=36]="Digit1",e[e.Digit2=37]="Digit2",e[e.Digit3=38]="Digit3",e[e.Digit4=39]="Digit4",e[e.Digit5=40]="Digit5",e[e.Digit6=41]="Digit6",e[e.Digit7=42]="Digit7",e[e.Digit8=43]="Digit8",e[e.Digit9=44]="Digit9",e[e.Digit0=45]="Digit0",e[e.Enter=46]="Enter",e[e.Escape=47]="Escape",e[e.Backspace=48]="Backspace",e[e.Tab=49]="Tab",e[e.Space=50]="Space",e[e.Minus=51]="Minus",e[e.Equal=52]="Equal",e[e.BracketLeft=53]="BracketLeft",e[e.BracketRight=54]="BracketRight",e[e.Backslash=55]="Backslash",e[e.IntlHash=56]="IntlHash",e[e.Semicolon=57]="Semicolon",e[e.Quote=58]="Quote",e[e.Backquote=59]="Backquote",e[e.Comma=60]="Comma",e[e.Period=61]="Period",e[e.Slash=62]="Slash",e[e.CapsLock=63]="CapsLock",e[e.F1=64]="F1",e[e.F2=65]="F2",e[e.F3=66]="F3",e[e.F4=67]="F4",e[e.F5=68]="F5",e[e.F6=69]="F6",e[e.F7=70]="F7",e[e.F8=71]="F8",e[e.F9=72]="F9",e[e.F10=73]="F10",e[e.F11=74]="F11",e[e.F12=75]="F12",e[e.PrintScreen=76]="PrintScreen",e[e.ScrollLock=77]="ScrollLock",e[e.Pause=78]="Pause",e[e.Insert=79]="Insert",e[e.Home=80]="Home",e[e.PageUp=81]="PageUp",e[e.Delete=82]="Delete",e[e.End=83]="End",e[e.PageDown=84]="PageDown",e[e.ArrowRight=85]="ArrowRight",e[e.ArrowLeft=86]="ArrowLeft",e[e.ArrowDown=87]="ArrowDown",e[e.ArrowUp=88]="ArrowUp",e[e.NumLock=89]="NumLock",e[e.NumpadDivide=90]="NumpadDivide",e[e.NumpadMultiply=91]="NumpadMultiply",e[e.NumpadSubtract=92]="NumpadSubtract",e[e.NumpadAdd=93]="NumpadAdd",e[e.NumpadEnter=94]="NumpadEnter",e[e.Numpad1=95]="Numpad1",e[e.Numpad2=96]="Numpad2",e[e.Numpad3=97]="Numpad3",e[e.Numpad4=98]="Numpad4",e[e.Numpad5=99]="Numpad5",e[e.Numpad6=100]="Numpad6",e[e.Numpad7=101]="Numpad7",e[e.Numpad8=102]="Numpad8",e[e.Numpad9=103]="Numpad9",e[e.Numpad0=104]="Numpad0",e[e.NumpadDecimal=105]="NumpadDecimal",e[e.IntlBackslash=106]="IntlBackslash",e[e.ContextMenu=107]="ContextMenu",e[e.Power=108]="Power",e[e.NumpadEqual=109]="NumpadEqual",e[e.F13=110]="F13",e[e.F14=111]="F14",e[e.F15=112]="F15",e[e.F16=113]="F16",e[e.F17=114]="F17",e[e.F18=115]="F18",e[e.F19=116]="F19",e[e.F20=117]="F20",e[e.F21=118]="F21",e[e.F22=119]="F22",e[e.F23=120]="F23",e[e.F24=121]="F24",e[e.Open=122]="Open",e[e.Help=123]="Help",e[e.Select=124]="Select",e[e.Again=125]="Again",e[e.Undo=126]="Undo",e[e.Cut=127]="Cut",e[e.Copy=128]="Copy",e[e.Paste=129]="Paste",e[e.Find=130]="Find",e[e.AudioVolumeMute=131]="AudioVolumeMute",e[e.AudioVolumeUp=132]="AudioVolumeUp",e[e.AudioVolumeDown=133]="AudioVolumeDown",e[e.NumpadComma=134]="NumpadComma",e[e.IntlRo=135]="IntlRo",e[e.KanaMode=136]="KanaMode",e[e.IntlYen=137]="IntlYen",e[e.Convert=138]="Convert",e[e.NonConvert=139]="NonConvert",e[e.Lang1=140]="Lang1",e[e.Lang2=141]="Lang2",e[e.Lang3=142]="Lang3",e[e.Lang4=143]="Lang4",e[e.Lang5=144]="Lang5",e[e.Abort=145]="Abort",e[e.Props=146]="Props",e[e.NumpadParenLeft=147]="NumpadParenLeft",e[e.NumpadParenRight=148]="NumpadParenRight",e[e.NumpadBackspace=149]="NumpadBackspace",e[e.NumpadMemoryStore=150]="NumpadMemoryStore",e[e.NumpadMemoryRecall=151]="NumpadMemoryRecall",e[e.NumpadMemoryClear=152]="NumpadMemoryClear",e[e.NumpadMemoryAdd=153]="NumpadMemoryAdd",e[e.NumpadMemorySubtract=154]="NumpadMemorySubtract",e[e.NumpadClear=155]="NumpadClear",e[e.NumpadClearEntry=156]="NumpadClearEntry",e[e.ControlLeft=157]="ControlLeft",e[e.ShiftLeft=158]="ShiftLeft",e[e.AltLeft=159]="AltLeft",e[e.MetaLeft=160]="MetaLeft",e[e.ControlRight=161]="ControlRight",e[e.ShiftRight=162]="ShiftRight",e[e.AltRight=163]="AltRight",e[e.MetaRight=164]="MetaRight",e[e.BrightnessUp=165]="BrightnessUp",e[e.BrightnessDown=166]="BrightnessDown",e[e.MediaPlay=167]="MediaPlay",e[e.MediaRecord=168]="MediaRecord",e[e.MediaFastForward=169]="MediaFastForward",e[e.MediaRewind=170]="MediaRewind",e[e.MediaTrackNext=171]="MediaTrackNext",e[e.MediaTrackPrevious=172]="MediaTrackPrevious",e[e.MediaStop=173]="MediaStop",e[e.Eject=174]="Eject",e[e.MediaPlayPause=175]="MediaPlayPause",e[e.MediaSelect=176]="MediaSelect",e[e.LaunchMail=177]="LaunchMail",e[e.LaunchApp2=178]="LaunchApp2",e[e.LaunchApp1=179]="LaunchApp1",e[e.SelectTask=180]="SelectTask",e[e.LaunchScreenSaver=181]="LaunchScreenSaver",e[e.BrowserSearch=182]="BrowserSearch",e[e.BrowserHome=183]="BrowserHome",e[e.BrowserBack=184]="BrowserBack",e[e.BrowserForward=185]="BrowserForward",e[e.BrowserStop=186]="BrowserStop",e[e.BrowserRefresh=187]="BrowserRefresh",e[e.BrowserFavorites=188]="BrowserFavorites",e[e.ZoomToggle=189]="ZoomToggle",e[e.MailReply=190]="MailReply",e[e.MailForward=191]="MailForward",e[e.MailSend=192]="MailSend",e[e.MAX_VALUE=193]="MAX_VALUE"})(t=n.ScanCode||(n.ScanCode={}));class D{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(C,F){this._keyCodeToStr[C]=F,this._strToKeyCode[F.toLowerCase()]=C}keyCodeToStr(C){return this._keyCodeToStr[C]}strToKeyCode(C){return this._strToKeyCode[C.toLowerCase()]||0}}const c=new D,_=new D,h=new D;n.EVENT_KEY_CODE_MAP=new Array(230),n.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE={};const l=[],f=Object.create(null),A=Object.create(null);n.ScanCodeUtils={lowerCaseToEnum:e=>A[e]||0,toEnum:e=>f[e]||0,toString:e=>l[e]||"None"},n.IMMUTABLE_CODE_TO_KEY_CODE=[],n.IMMUTABLE_KEY_CODE_TO_CODE=[];for(let e=0;e<=193;e++)n.IMMUTABLE_CODE_TO_KEY_CODE[e]=-1;for(let e=0;e<=127;e++)n.IMMUTABLE_KEY_CODE_TO_CODE[e]=-1;(function(){const e="",C=[[0,1,0,"None",0,"unknown",0,"VK_UNKNOWN",e,e],[0,1,1,"Hyper",0,e,0,e,e,e],[0,1,2,"Super",0,e,0,e,e,e],[0,1,3,"Fn",0,e,0,e,e,e],[0,1,4,"FnLock",0,e,0,e,e,e],[0,1,5,"Suspend",0,e,0,e,e,e],[0,1,6,"Resume",0,e,0,e,e,e],[0,1,7,"Turbo",0,e,0,e,e,e],[0,1,8,"Sleep",0,e,0,"VK_SLEEP",e,e],[0,1,9,"WakeUp",0,e,0,e,e,e],[31,0,10,"KeyA",31,"A",65,"VK_A",e,e],[32,0,11,"KeyB",32,"B",66,"VK_B",e,e],[33,0,12,"KeyC",33,"C",67,"VK_C",e,e],[34,0,13,"KeyD",34,"D",68,"VK_D",e,e],[35,0,14,"KeyE",35,"E",69,"VK_E",e,e],[36,0,15,"KeyF",36,"F",70,"VK_F",e,e],[37,0,16,"KeyG",37,"G",71,"VK_G",e,e],[38,0,17,"KeyH",38,"H",72,"VK_H",e,e],[39,0,18,"KeyI",39,"I",73,"VK_I",e,e],[40,0,19,"KeyJ",40,"J",74,"VK_J",e,e],[41,0,20,"KeyK",41,"K",75,"VK_K",e,e],[42,0,21,"KeyL",42,"L",76,"VK_L",e,e],[43,0,22,"KeyM",43,"M",77,"VK_M",e,e],[44,0,23,"KeyN",44,"N",78,"VK_N",e,e],[45,0,24,"KeyO",45,"O",79,"VK_O",e,e],[46,0,25,"KeyP",46,"P",80,"VK_P",e,e],[47,0,26,"KeyQ",47,"Q",81,"VK_Q",e,e],[48,0,27,"KeyR",48,"R",82,"VK_R",e,e],[49,0,28,"KeyS",49,"S",83,"VK_S",e,e],[50,0,29,"KeyT",50,"T",84,"VK_T",e,e],[51,0,30,"KeyU",51,"U",85,"VK_U",e,e],[52,0,31,"KeyV",52,"V",86,"VK_V",e,e],[53,0,32,"KeyW",53,"W",87,"VK_W",e,e],[54,0,33,"KeyX",54,"X",88,"VK_X",e,e],[55,0,34,"KeyY",55,"Y",89,"VK_Y",e,e],[56,0,35,"KeyZ",56,"Z",90,"VK_Z",e,e],[22,0,36,"Digit1",22,"1",49,"VK_1",e,e],[23,0,37,"Digit2",23,"2",50,"VK_2",e,e],[24,0,38,"Digit3",24,"3",51,"VK_3",e,e],[25,0,39,"Digit4",25,"4",52,"VK_4",e,e],[26,0,40,"Digit5",26,"5",53,"VK_5",e,e],[27,0,41,"Digit6",27,"6",54,"VK_6",e,e],[28,0,42,"Digit7",28,"7",55,"VK_7",e,e],[29,0,43,"Digit8",29,"8",56,"VK_8",e,e],[30,0,44,"Digit9",30,"9",57,"VK_9",e,e],[21,0,45,"Digit0",21,"0",48,"VK_0",e,e],[3,1,46,"Enter",3,"Enter",13,"VK_RETURN",e,e],[9,1,47,"Escape",9,"Escape",27,"VK_ESCAPE",e,e],[1,1,48,"Backspace",1,"Backspace",8,"VK_BACK",e,e],[2,1,49,"Tab",2,"Tab",9,"VK_TAB",e,e],[10,1,50,"Space",10,"Space",32,"VK_SPACE",e,e],[83,0,51,"Minus",83,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[81,0,52,"Equal",81,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[87,0,53,"BracketLeft",87,"[",219,"VK_OEM_4","[","OEM_4"],[89,0,54,"BracketRight",89,"]",221,"VK_OEM_6","]","OEM_6"],[88,0,55,"Backslash",88,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,0,56,"IntlHash",0,e,0,e,e,e],[80,0,57,"Semicolon",80,";",186,"VK_OEM_1",";","OEM_1"],[90,0,58,"Quote",90,"'",222,"VK_OEM_7","'","OEM_7"],[86,0,59,"Backquote",86,"`",192,"VK_OEM_3","`","OEM_3"],[82,0,60,"Comma",82,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[84,0,61,"Period",84,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[85,0,62,"Slash",85,"/",191,"VK_OEM_2","/","OEM_2"],[8,1,63,"CapsLock",8,"CapsLock",20,"VK_CAPITAL",e,e],[59,1,64,"F1",59,"F1",112,"VK_F1",e,e],[60,1,65,"F2",60,"F2",113,"VK_F2",e,e],[61,1,66,"F3",61,"F3",114,"VK_F3",e,e],[62,1,67,"F4",62,"F4",115,"VK_F4",e,e],[63,1,68,"F5",63,"F5",116,"VK_F5",e,e],[64,1,69,"F6",64,"F6",117,"VK_F6",e,e],[65,1,70,"F7",65,"F7",118,"VK_F7",e,e],[66,1,71,"F8",66,"F8",119,"VK_F8",e,e],[67,1,72,"F9",67,"F9",120,"VK_F9",e,e],[68,1,73,"F10",68,"F10",121,"VK_F10",e,e],[69,1,74,"F11",69,"F11",122,"VK_F11",e,e],[70,1,75,"F12",70,"F12",123,"VK_F12",e,e],[0,1,76,"PrintScreen",0,e,0,e,e,e],[79,1,77,"ScrollLock",79,"ScrollLock",145,"VK_SCROLL",e,e],[7,1,78,"Pause",7,"PauseBreak",19,"VK_PAUSE",e,e],[19,1,79,"Insert",19,"Insert",45,"VK_INSERT",e,e],[14,1,80,"Home",14,"Home",36,"VK_HOME",e,e],[11,1,81,"PageUp",11,"PageUp",33,"VK_PRIOR",e,e],[20,1,82,"Delete",20,"Delete",46,"VK_DELETE",e,e],[13,1,83,"End",13,"End",35,"VK_END",e,e],[12,1,84,"PageDown",12,"PageDown",34,"VK_NEXT",e,e],[17,1,85,"ArrowRight",17,"RightArrow",39,"VK_RIGHT","Right",e],[15,1,86,"ArrowLeft",15,"LeftArrow",37,"VK_LEFT","Left",e],[18,1,87,"ArrowDown",18,"DownArrow",40,"VK_DOWN","Down",e],[16,1,88,"ArrowUp",16,"UpArrow",38,"VK_UP","Up",e],[78,1,89,"NumLock",78,"NumLock",144,"VK_NUMLOCK",e,e],[108,1,90,"NumpadDivide",108,"NumPad_Divide",111,"VK_DIVIDE",e,e],[103,1,91,"NumpadMultiply",103,"NumPad_Multiply",106,"VK_MULTIPLY",e,e],[106,1,92,"NumpadSubtract",106,"NumPad_Subtract",109,"VK_SUBTRACT",e,e],[104,1,93,"NumpadAdd",104,"NumPad_Add",107,"VK_ADD",e,e],[3,1,94,"NumpadEnter",3,e,0,e,e,e],[94,1,95,"Numpad1",94,"NumPad1",97,"VK_NUMPAD1",e,e],[95,1,96,"Numpad2",95,"NumPad2",98,"VK_NUMPAD2",e,e],[96,1,97,"Numpad3",96,"NumPad3",99,"VK_NUMPAD3",e,e],[97,1,98,"Numpad4",97,"NumPad4",100,"VK_NUMPAD4",e,e],[98,1,99,"Numpad5",98,"NumPad5",101,"VK_NUMPAD5",e,e],[99,1,100,"Numpad6",99,"NumPad6",102,"VK_NUMPAD6",e,e],[100,1,101,"Numpad7",100,"NumPad7",103,"VK_NUMPAD7",e,e],[101,1,102,"Numpad8",101,"NumPad8",104,"VK_NUMPAD8",e,e],[102,1,103,"Numpad9",102,"NumPad9",105,"VK_NUMPAD9",e,e],[93,1,104,"Numpad0",93,"NumPad0",96,"VK_NUMPAD0",e,e],[107,1,105,"NumpadDecimal",107,"NumPad_Decimal",110,"VK_DECIMAL",e,e],[92,0,106,"IntlBackslash",92,"OEM_102",226,"VK_OEM_102",e,e],[58,1,107,"ContextMenu",58,"ContextMenu",93,e,e,e],[0,1,108,"Power",0,e,0,e,e,e],[0,1,109,"NumpadEqual",0,e,0,e,e,e],[71,1,110,"F13",71,"F13",124,"VK_F13",e,e],[72,1,111,"F14",72,"F14",125,"VK_F14",e,e],[73,1,112,"F15",73,"F15",126,"VK_F15",e,e],[74,1,113,"F16",74,"F16",127,"VK_F16",e,e],[75,1,114,"F17",75,"F17",128,"VK_F17",e,e],[76,1,115,"F18",76,"F18",129,"VK_F18",e,e],[77,1,116,"F19",77,"F19",130,"VK_F19",e,e],[0,1,117,"F20",0,e,0,"VK_F20",e,e],[0,1,118,"F21",0,e,0,"VK_F21",e,e],[0,1,119,"F22",0,e,0,"VK_F22",e,e],[0,1,120,"F23",0,e,0,"VK_F23",e,e],[0,1,121,"F24",0,e,0,"VK_F24",e,e],[0,1,122,"Open",0,e,0,e,e,e],[0,1,123,"Help",0,e,0,e,e,e],[0,1,124,"Select",0,e,0,e,e,e],[0,1,125,"Again",0,e,0,e,e,e],[0,1,126,"Undo",0,e,0,e,e,e],[0,1,127,"Cut",0,e,0,e,e,e],[0,1,128,"Copy",0,e,0,e,e,e],[0,1,129,"Paste",0,e,0,e,e,e],[0,1,130,"Find",0,e,0,e,e,e],[0,1,131,"AudioVolumeMute",112,"AudioVolumeMute",173,"VK_VOLUME_MUTE",e,e],[0,1,132,"AudioVolumeUp",113,"AudioVolumeUp",175,"VK_VOLUME_UP",e,e],[0,1,133,"AudioVolumeDown",114,"AudioVolumeDown",174,"VK_VOLUME_DOWN",e,e],[105,1,134,"NumpadComma",105,"NumPad_Separator",108,"VK_SEPARATOR",e,e],[110,0,135,"IntlRo",110,"ABNT_C1",193,"VK_ABNT_C1",e,e],[0,1,136,"KanaMode",0,e,0,e,e,e],[0,0,137,"IntlYen",0,e,0,e,e,e],[0,1,138,"Convert",0,e,0,e,e,e],[0,1,139,"NonConvert",0,e,0,e,e,e],[0,1,140,"Lang1",0,e,0,e,e,e],[0,1,141,"Lang2",0,e,0,e,e,e],[0,1,142,"Lang3",0,e,0,e,e,e],[0,1,143,"Lang4",0,e,0,e,e,e],[0,1,144,"Lang5",0,e,0,e,e,e],[0,1,145,"Abort",0,e,0,e,e,e],[0,1,146,"Props",0,e,0,e,e,e],[0,1,147,"NumpadParenLeft",0,e,0,e,e,e],[0,1,148,"NumpadParenRight",0,e,0,e,e,e],[0,1,149,"NumpadBackspace",0,e,0,e,e,e],[0,1,150,"NumpadMemoryStore",0,e,0,e,e,e],[0,1,151,"NumpadMemoryRecall",0,e,0,e,e,e],[0,1,152,"NumpadMemoryClear",0,e,0,e,e,e],[0,1,153,"NumpadMemoryAdd",0,e,0,e,e,e],[0,1,154,"NumpadMemorySubtract",0,e,0,e,e,e],[0,1,155,"NumpadClear",126,"Clear",12,"VK_CLEAR",e,e],[0,1,156,"NumpadClearEntry",0,e,0,e,e,e],[5,1,0,e,5,"Ctrl",17,"VK_CONTROL",e,e],[4,1,0,e,4,"Shift",16,"VK_SHIFT",e,e],[6,1,0,e,6,"Alt",18,"VK_MENU",e,e],[57,1,0,e,57,"Meta",0,"VK_COMMAND",e,e],[5,1,157,"ControlLeft",5,e,0,"VK_LCONTROL",e,e],[4,1,158,"ShiftLeft",4,e,0,"VK_LSHIFT",e,e],[6,1,159,"AltLeft",6,e,0,"VK_LMENU",e,e],[57,1,160,"MetaLeft",57,e,0,"VK_LWIN",e,e],[5,1,161,"ControlRight",5,e,0,"VK_RCONTROL",e,e],[4,1,162,"ShiftRight",4,e,0,"VK_RSHIFT",e,e],[6,1,163,"AltRight",6,e,0,"VK_RMENU",e,e],[57,1,164,"MetaRight",57,e,0,"VK_RWIN",e,e],[0,1,165,"BrightnessUp",0,e,0,e,e,e],[0,1,166,"BrightnessDown",0,e,0,e,e,e],[0,1,167,"MediaPlay",0,e,0,e,e,e],[0,1,168,"MediaRecord",0,e,0,e,e,e],[0,1,169,"MediaFastForward",0,e,0,e,e,e],[0,1,170,"MediaRewind",0,e,0,e,e,e],[114,1,171,"MediaTrackNext",119,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",e,e],[115,1,172,"MediaTrackPrevious",120,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",e,e],[116,1,173,"MediaStop",121,"MediaStop",178,"VK_MEDIA_STOP",e,e],[0,1,174,"Eject",0,e,0,e,e,e],[117,1,175,"MediaPlayPause",122,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",e,e],[0,1,176,"MediaSelect",123,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",e,e],[0,1,177,"LaunchMail",124,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",e,e],[0,1,178,"LaunchApp2",125,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",e,e],[0,1,179,"LaunchApp1",0,e,0,"VK_MEDIA_LAUNCH_APP1",e,e],[0,1,180,"SelectTask",0,e,0,e,e,e],[0,1,181,"LaunchScreenSaver",0,e,0,e,e,e],[0,1,182,"BrowserSearch",115,"BrowserSearch",170,"VK_BROWSER_SEARCH",e,e],[0,1,183,"BrowserHome",116,"BrowserHome",172,"VK_BROWSER_HOME",e,e],[112,1,184,"BrowserBack",117,"BrowserBack",166,"VK_BROWSER_BACK",e,e],[113,1,185,"BrowserForward",118,"BrowserForward",167,"VK_BROWSER_FORWARD",e,e],[0,1,186,"BrowserStop",0,e,0,"VK_BROWSER_STOP",e,e],[0,1,187,"BrowserRefresh",0,e,0,"VK_BROWSER_REFRESH",e,e],[0,1,188,"BrowserFavorites",0,e,0,"VK_BROWSER_FAVORITES",e,e],[0,1,189,"ZoomToggle",0,e,0,e,e,e],[0,1,190,"MailReply",0,e,0,e,e,e],[0,1,191,"MailForward",0,e,0,e,e,e],[0,1,192,"MailSend",0,e,0,e,e,e],[109,1,0,e,109,"KeyInComposition",229,e,e,e],[111,1,0,e,111,"ABNT_C2",194,"VK_ABNT_C2",e,e],[91,1,0,e,91,"OEM_8",223,"VK_OEM_8",e,e],[0,1,0,e,0,e,0,"VK_KANA",e,e],[0,1,0,e,0,e,0,"VK_HANGUL",e,e],[0,1,0,e,0,e,0,"VK_JUNJA",e,e],[0,1,0,e,0,e,0,"VK_FINAL",e,e],[0,1,0,e,0,e,0,"VK_HANJA",e,e],[0,1,0,e,0,e,0,"VK_KANJI",e,e],[0,1,0,e,0,e,0,"VK_CONVERT",e,e],[0,1,0,e,0,e,0,"VK_NONCONVERT",e,e],[0,1,0,e,0,e,0,"VK_ACCEPT",e,e],[0,1,0,e,0,e,0,"VK_MODECHANGE",e,e],[0,1,0,e,0,e,0,"VK_SELECT",e,e],[0,1,0,e,0,e,0,"VK_PRINT",e,e],[0,1,0,e,0,e,0,"VK_EXECUTE",e,e],[0,1,0,e,0,e,0,"VK_SNAPSHOT",e,e],[0,1,0,e,0,e,0,"VK_HELP",e,e],[0,1,0,e,0,e,0,"VK_APPS",e,e],[0,1,0,e,0,e,0,"VK_PROCESSKEY",e,e],[0,1,0,e,0,e,0,"VK_PACKET",e,e],[0,1,0,e,0,e,0,"VK_DBE_SBCSCHAR",e,e],[0,1,0,e,0,e,0,"VK_DBE_DBCSCHAR",e,e],[0,1,0,e,0,e,0,"VK_ATTN",e,e],[0,1,0,e,0,e,0,"VK_CRSEL",e,e],[0,1,0,e,0,e,0,"VK_EXSEL",e,e],[0,1,0,e,0,e,0,"VK_EREOF",e,e],[0,1,0,e,0,e,0,"VK_PLAY",e,e],[0,1,0,e,0,e,0,"VK_ZOOM",e,e],[0,1,0,e,0,e,0,"VK_NONAME",e,e],[0,1,0,e,0,e,0,"VK_PA1",e,e],[0,1,0,e,0,e,0,"VK_OEM_CLEAR",e,e]],F=[],y=[];for(const L of C){const[s,a,i,o,u,d,g,N,b,w]=L;if(y[i]||(y[i]=!0,l[i]=o,f[o]=i,A[o.toLowerCase()]=i,a&&(n.IMMUTABLE_CODE_TO_KEY_CODE[i]=u,u!==0&&u!==3&&u!==5&&u!==4&&u!==6&&u!==57&&(n.IMMUTABLE_KEY_CODE_TO_CODE[u]=i))),!F[u]){if(F[u]=!0,!d)throw new Error(`String representation missing for key code ${u} around scan code ${o}`);c.define(u,d),_.define(u,b||d),h.define(u,w||b||d)}g&&(n.EVENT_KEY_CODE_MAP[g]=u),N&&(n.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE[N]=u)}n.IMMUTABLE_KEY_CODE_TO_CODE[3]=46})();var R;(function(e){function C(i){return c.keyCodeToStr(i)}e.toString=C;function F(i){return c.strToKeyCode(i)}e.fromString=F;function y(i){return _.keyCodeToStr(i)}e.toUserSettingsUS=y;function L(i){return h.keyCodeToStr(i)}e.toUserSettingsGeneral=L;function s(i){return _.strToKeyCode(i)||h.strToKeyCode(i)}e.fromUserSettings=s;function a(i){if(i>=93&&i<=108)return null;switch(i){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return c.keyCodeToStr(i)}e.toElectronAccelerator=a})(R=n.KeyCodeUtils||(n.KeyCodeUtils={}));var p;(function(e){e[e.CtrlCmd=2048]="CtrlCmd",e[e.Shift=1024]="Shift",e[e.Alt=512]="Alt",e[e.WinCtrl=256]="WinCtrl"})(p=n.KeyMod||(n.KeyMod={}));function m(e,C){const F=(C&65535)<<16>>>0;return(e|F)>>>0}n.KeyChord=m}),Z(K[28],x([0,1]),function(B,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Lazy=void 0;class E{constructor(D){this.d=D,this.a=!1}hasValue(){return this.a}getValue(){if(!this.a)try{this.b=this.d()}catch(D){this.c=D}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}map(D){return new E(()=>D(this.getValue()))}}n.Lazy=E}),Z(K[7],x([0,1,13,14]),function(B,n,E,t){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.DisposableMap=n.disposeOnReturn=n.ImmortalReference=n.AsyncReferenceCollection=n.ReferenceCollection=n.SafeDisposable=n.RefCountedDisposable=n.MutableDisposable=n.Disposable=n.DisposableStore=n.toDisposable=n.combinedDisposable=n.disposeIfDisposable=n.dispose=n.isDisposable=n.markAsSingleton=n.setDisposableTracker=void 0;const D=!1;let c=null;function _(b){c=b}if(n.setDisposableTracker=_,D){const b="__is_disposable_tracked__";_(new class{trackDisposable(w){const v=new Error("Potentially leaked disposable").stack;setTimeout(()=>{w[b]||console.log(v)},3e3)}setParent(w,v){if(w&&w!==L.None)try{w[b]=!0}catch{}}markAsDisposed(w){if(w&&w!==L.None)try{w[b]=!0}catch{}}markAsSingleton(w){}})}function h(b){return c?.trackDisposable(b),b}function l(b){c?.markAsDisposed(b)}function f(b,w){c?.setParent(b,w)}function A(b,w){if(!!c)for(const v of b)c.setParent(v,w)}function R(b){return c?.markAsSingleton(b),b}n.markAsSingleton=R;function p(b){return typeof b.dispose=="function"&&b.dispose.length===0}n.isDisposable=p;function m(b){if(t.Iterable.is(b)){const w=[];for(const v of b)if(v)try{v.dispose()}catch(M){w.push(M)}if(w.length===1)throw w[0];if(w.length>1)throw new AggregateError(w,"Encountered errors while disposing of store");return Array.isArray(b)?[]:b}else if(b)return b.dispose(),b}n.dispose=m;function e(b){for(const w of b)p(w)&&w.dispose();return[]}n.disposeIfDisposable=e;function C(...b){const w=F(()=>m(b));return A(b,w),w}n.combinedDisposable=C;function F(b){const w=h({dispose:(0,E.once)(()=>{l(w),b()})});return w}n.toDisposable=F;class y{constructor(){this.c=new Set,this.f=!1,h(this)}dispose(){this.f||(l(this),this.f=!0,this.clear())}get isDisposed(){return this.f}clear(){if(this.c.size!==0)try{m(this.c)}finally{this.c.clear()}}add(w){if(!w)return w;if(w===this)throw new Error("Cannot register a disposable on itself!");return f(w,this),this.f?y.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.c.add(w),w}}n.DisposableStore=y,y.DISABLE_DISPOSED_WARNING=!1;class L{constructor(){this.q=new y,h(this),f(this.q,this)}dispose(){l(this),this.q.dispose()}B(w){if(w===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(w)}}n.Disposable=L,L.None=Object.freeze({dispose(){}});class s{constructor(){this.b=!1,h(this)}get value(){return this.b?void 0:this.a}set value(w){this.b||w===this.a||(this.a?.dispose(),w&&f(w,this),this.a=w)}clear(){this.value=void 0}dispose(){this.b=!0,l(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const w=this.a;return this.a=void 0,w&&f(w,null),w}}n.MutableDisposable=s;class a{constructor(w){this.b=w,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}n.RefCountedDisposable=a;class i{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,h(this)}set(w){let v=w;return this.unset=()=>v=void 0,this.isset=()=>v!==void 0,this.dispose=()=>{v&&(v(),v=void 0,l(this))},this}}n.SafeDisposable=i;class o{constructor(){this.a=new Map}acquire(w,...v){let M=this.a.get(w);M||(M={counter:0,object:this.b(w,...v)},this.a.set(w,M));const{object:I}=M,O=(0,E.once)(()=>{--M.counter===0&&(this.c(w,M.object),this.a.delete(w))});return M.counter++,{object:I,dispose:O}}}n.ReferenceCollection=o;class u{constructor(w){this.a=w}async acquire(w,...v){const M=this.a.acquire(w,...v);try{return{object:await M.object,dispose:()=>M.dispose()}}catch(I){throw M.dispose(),I}}}n.AsyncReferenceCollection=u;class d{constructor(w){this.object=w}dispose(){}}n.ImmortalReference=d;function g(b){const w=new y;try{b(w)}finally{w.dispose()}}n.disposeOnReturn=g;class N{constructor(){this.a=new Map,this.b=!1,h(this)}dispose(){l(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(!!this.a.size)try{m(this.a.values())}finally{this.a.clear()}}has(w){return this.a.has(w)}get(w){return this.a.get(w)}set(w,v,M=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),M||this.a.get(w)?.dispose(),this.a.set(w,v)}deleteAndDispose(w){this.a.get(w)?.dispose(),this.a.delete(w)}[Symbol.iterator](){return this.a[Symbol.iterator]()}}n.DisposableMap=N}),Z(K[15],x([0,1]),function(B,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.LinkedList=void 0;class E{constructor(c){this.element=c,this.next=E.Undefined,this.prev=E.Undefined}}E.Undefined=new E(void 0);class t{constructor(){this.a=E.Undefined,this.b=E.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===E.Undefined}clear(){let c=this.a;for(;c!==E.Undefined;){const _=c.next;c.prev=E.Undefined,c.next=E.Undefined,c=_}this.a=E.Undefined,this.b=E.Undefined,this.c=0}unshift(c){return this.d(c,!1)}push(c){return this.d(c,!0)}d(c,_){const h=new E(c);if(this.a===E.Undefined)this.a=h,this.b=h;else if(_){const f=this.b;this.b=h,h.prev=f,f.next=h}else{const f=this.a;this.a=h,h.next=f,f.prev=h}this.c+=1;let l=!1;return()=>{l||(l=!0,this.e(h))}}shift(){if(this.a!==E.Undefined){const c=this.a.element;return this.e(this.a),c}}pop(){if(this.b!==E.Undefined){const c=this.b.element;return this.e(this.b),c}}e(c){if(c.prev!==E.Undefined&&c.next!==E.Undefined){const _=c.prev;_.next=c.next,c.next.prev=_}else c.prev===E.Undefined&&c.next===E.Undefined?(this.a=E.Undefined,this.b=E.Undefined):c.next===E.Undefined?(this.b=this.b.prev,this.b.next=E.Undefined):c.prev===E.Undefined&&(this.a=this.a.next,this.a.prev=E.Undefined);this.c-=1}*[Symbol.iterator](){let c=this.a;for(;c!==E.Undefined;)yield c.element,c=c.next}}n.LinkedList=t}),Z(K[5],x([0,1]),function(B,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.isAndroid=n.isEdge=n.isSafari=n.isFirefox=n.isChrome=n.isLittleEndian=n.OS=n.OperatingSystem=n.setTimeout0=n.setTimeout0IsFaster=n.translationsConfigFile=n.locale=n.Language=n.language=n.userAgent=n.platform=n.isCI=n.isMobile=n.isIOS=n.isWebWorker=n.isWeb=n.isElectron=n.isNative=n.isLinuxSnap=n.isLinux=n.isMacintosh=n.isWindows=n.PlatformToString=n.Platform=n.globals=n.LANGUAGE_DEFAULT=void 0,n.LANGUAGE_DEFAULT="en";let E=!1,t=!1,D=!1,c=!1,_=!1,h=!1,l=!1,f=!1,A=!1,R=!1,p,m=n.LANGUAGE_DEFAULT,e,C;n.globals=typeof self=="object"?self:typeof global=="object"?global:{};let F;typeof n.globals.vscode<"u"&&typeof n.globals.vscode.process<"u"?F=n.globals.vscode.process:typeof process<"u"&&(F=process);const y=typeof F?.versions?.electron=="string",L=y&&F?.type==="renderer";if(typeof navigator=="object"&&!L){C=navigator.userAgent,E=C.indexOf("Windows")>=0,t=C.indexOf("Macintosh")>=0,f=(C.indexOf("Macintosh")>=0||C.indexOf("iPad")>=0||C.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,D=C.indexOf("Linux")>=0,R=C?.indexOf("Mobi")>=0,h=!0,p=n.LANGUAGE_DEFAULT,m=p;const b=typeof document<"u"&&document.getElementById("vscode-remote-nls-configuration"),w=b&&b.getAttribute("data-settings");if(w)try{const v=JSON.parse(w);p=v.locale,e=v._translationsConfigFile,m=v.availableLanguages["*"]||n.LANGUAGE_DEFAULT}catch{}}else if(typeof F=="object"){E=F.platform==="win32",t=F.platform==="darwin",D=F.platform==="linux",c=D&&!!F.env.SNAP&&!!F.env.SNAP_REVISION,l=y,A=!!F.env.CI||!!F.env.BUILD_ARTIFACTSTAGINGDIRECTORY,p=n.LANGUAGE_DEFAULT,m=n.LANGUAGE_DEFAULT;const b=F.env.VSCODE_NLS_CONFIG;if(b)try{const w=JSON.parse(b),v=w.availableLanguages["*"];p=w.locale,m=v||n.LANGUAGE_DEFAULT,e=w._translationsConfigFile}catch{}_=!0}else console.error("Unable to resolve platform.");var s;(function(b){b[b.Web=0]="Web",b[b.Mac=1]="Mac",b[b.Linux=2]="Linux",b[b.Windows=3]="Windows"})(s=n.Platform||(n.Platform={}));function a(b){switch(b){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}n.PlatformToString=a;let i=0;t?i=1:E?i=3:D&&(i=2),n.isWindows=E,n.isMacintosh=t,n.isLinux=D,n.isLinuxSnap=c,n.isNative=_,n.isElectron=l,n.isWeb=h,n.isWebWorker=h&&typeof n.globals.importScripts=="function",n.isIOS=f,n.isMobile=R,n.isCI=A,n.platform=i,n.userAgent=C,n.language=m;var o;(function(b){function w(){return n.language}b.value=w;function v(){return n.language.length===2?n.language==="en":n.language.length>=3?n.language[0]==="e"&&n.language[1]==="n"&&n.language[2]==="-":!1}b.isDefaultVariant=v;function M(){return n.language==="en"}b.isDefault=M})(o=n.Language||(n.Language={})),n.locale=p,n.translationsConfigFile=e,n.setTimeout0IsFaster=typeof n.globals.postMessage=="function"&&!n.globals.importScripts,n.setTimeout0=(()=>{if(n.setTimeout0IsFaster){const b=[];n.globals.addEventListener("message",v=>{if(v.data&&v.data.vscodeScheduleAsyncWork)for(let M=0,I=b.length;M<I;M++){const O=b[M];if(O.id===v.data.vscodeScheduleAsyncWork){b.splice(M,1),O.callback();return}}});let w=0;return v=>{const M=++w;b.push({id:M,callback:v}),n.globals.postMessage({vscodeScheduleAsyncWork:M},"*")}}return b=>setTimeout(b)})();var u;(function(b){b[b.Windows=1]="Windows",b[b.Macintosh=2]="Macintosh",b[b.Linux=3]="Linux"})(u=n.OperatingSystem||(n.OperatingSystem={})),n.OS=t||f?2:E?1:3;let d=!0,g=!1;function N(){if(!g){g=!0;const b=new Uint8Array(2);b[0]=1,b[1]=2,d=new Uint16Array(b.buffer)[0]===(2<<8)+1}return d}n.isLittleEndian=N,n.isChrome=!!(n.userAgent&&n.userAgent.indexOf("Chrome")>=0),n.isFirefox=!!(n.userAgent&&n.userAgent.indexOf("Firefox")>=0),n.isSafari=!!(!n.isChrome&&n.userAgent&&n.userAgent.indexOf("Safari")>=0),n.isEdge=!!(n.userAgent&&n.userAgent.indexOf("Edg/")>=0),n.isAndroid=!!(n.userAgent&&n.userAgent.indexOf("Android")>=0)}),Z(K[29],x([0,1,5]),function(B,n,E){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.arch=n.platform=n.env=n.cwd=void 0;let t;if(typeof E.globals.vscode<"u"&&typeof E.globals.vscode.process<"u"){const D=E.globals.vscode.process;t={get platform(){return D.platform},get arch(){return D.arch},get env(){return D.env},cwd(){return D.cwd()}}}else typeof process<"u"?t={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:t={get platform(){return E.isWindows?"win32":E.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};n.cwd=t.cwd,n.env=t.env,n.platform=t.platform,n.arch=t.arch}),Z(K[30],x([0,1,29]),function(B,n,E){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.delimiter=n.sep=n.toNamespacedPath=n.parse=n.format=n.extname=n.basename=n.dirname=n.relative=n.resolve=n.join=n.isAbsolute=n.normalize=n.posix=n.win32=void 0;const t=65,D=97,c=90,_=122,h=46,l=47,f=92,A=58,R=63;class p extends Error{constructor(a,i,o){let u;typeof i=="string"&&i.indexOf("not ")===0?(u="must not be",i=i.replace(/^not /,"")):u="must be";const d=a.indexOf(".")!==-1?"property":"argument";let g=`The "${a}" ${d} ${u} of type ${i}`;g+=`. Received type ${typeof o}`,super(g),this.code="ERR_INVALID_ARG_TYPE"}}function m(s,a){if(typeof s!="string")throw new p(a,"string",s)}function e(s){return s===l||s===f}function C(s){return s===l}function F(s){return s>=t&&s<=c||s>=D&&s<=_}function y(s,a,i,o){let u="",d=0,g=-1,N=0,b=0;for(let w=0;w<=s.length;++w){if(w<s.length)b=s.charCodeAt(w);else{if(o(b))break;b=l}if(o(b)){if(!(g===w-1||N===1))if(N===2){if(u.length<2||d!==2||u.charCodeAt(u.length-1)!==h||u.charCodeAt(u.length-2)!==h){if(u.length>2){const v=u.lastIndexOf(i);v===-1?(u="",d=0):(u=u.slice(0,v),d=u.length-1-u.lastIndexOf(i)),g=w,N=0;continue}else if(u.length!==0){u="",d=0,g=w,N=0;continue}}a&&(u+=u.length>0?`${i}..`:"..",d=2)}else u.length>0?u+=`${i}${s.slice(g+1,w)}`:u=s.slice(g+1,w),d=w-g-1;g=w,N=0}else b===h&&N!==-1?++N:N=-1}return u}function L(s,a){if(a===null||typeof a!="object")throw new p("pathObject","Object",a);const i=a.dir||a.root,o=a.base||`${a.name||""}${a.ext||""}`;return i?i===a.root?`${i}${o}`:`${i}${s}${o}`:o}n.win32={resolve(...s){let a="",i="",o=!1;for(let u=s.length-1;u>=-1;u--){let d;if(u>=0){if(d=s[u],m(d,"path"),d.length===0)continue}else a.length===0?d=E.cwd():(d=E.env[`=${a}`]||E.cwd(),(d===void 0||d.slice(0,2).toLowerCase()!==a.toLowerCase()&&d.charCodeAt(2)===f)&&(d=`${a}\\`));const g=d.length;let N=0,b="",w=!1;const v=d.charCodeAt(0);if(g===1)e(v)&&(N=1,w=!0);else if(e(v))if(w=!0,e(d.charCodeAt(1))){let M=2,I=M;for(;M<g&&!e(d.charCodeAt(M));)M++;if(M<g&&M!==I){const O=d.slice(I,M);for(I=M;M<g&&e(d.charCodeAt(M));)M++;if(M<g&&M!==I){for(I=M;M<g&&!e(d.charCodeAt(M));)M++;(M===g||M!==I)&&(b=`\\\\${O}\\${d.slice(I,M)}`,N=M)}}}else N=1;else F(v)&&d.charCodeAt(1)===A&&(b=d.slice(0,2),N=2,g>2&&e(d.charCodeAt(2))&&(w=!0,N=3));if(b.length>0)if(a.length>0){if(b.toLowerCase()!==a.toLowerCase())continue}else a=b;if(o){if(a.length>0)break}else if(i=`${d.slice(N)}\\${i}`,o=w,w&&a.length>0)break}return i=y(i,!o,"\\",e),o?`${a}\\${i}`:`${a}${i}`||"."},normalize(s){m(s,"path");const a=s.length;if(a===0)return".";let i=0,o,u=!1;const d=s.charCodeAt(0);if(a===1)return C(d)?"\\":s;if(e(d))if(u=!0,e(s.charCodeAt(1))){let N=2,b=N;for(;N<a&&!e(s.charCodeAt(N));)N++;if(N<a&&N!==b){const w=s.slice(b,N);for(b=N;N<a&&e(s.charCodeAt(N));)N++;if(N<a&&N!==b){for(b=N;N<a&&!e(s.charCodeAt(N));)N++;if(N===a)return`\\\\${w}\\${s.slice(b)}\\`;N!==b&&(o=`\\\\${w}\\${s.slice(b,N)}`,i=N)}}}else i=1;else F(d)&&s.charCodeAt(1)===A&&(o=s.slice(0,2),i=2,a>2&&e(s.charCodeAt(2))&&(u=!0,i=3));let g=i<a?y(s.slice(i),!u,"\\",e):"";return g.length===0&&!u&&(g="."),g.length>0&&e(s.charCodeAt(a-1))&&(g+="\\"),o===void 0?u?`\\${g}`:g:u?`${o}\\${g}`:`${o}${g}`},isAbsolute(s){m(s,"path");const a=s.length;if(a===0)return!1;const i=s.charCodeAt(0);return e(i)||a>2&&F(i)&&s.charCodeAt(1)===A&&e(s.charCodeAt(2))},join(...s){if(s.length===0)return".";let a,i;for(let d=0;d<s.length;++d){const g=s[d];m(g,"path"),g.length>0&&(a===void 0?a=i=g:a+=`\\${g}`)}if(a===void 0)return".";let o=!0,u=0;if(typeof i=="string"&&e(i.charCodeAt(0))){++u;const d=i.length;d>1&&e(i.charCodeAt(1))&&(++u,d>2&&(e(i.charCodeAt(2))?++u:o=!1))}if(o){for(;u<a.length&&e(a.charCodeAt(u));)u++;u>=2&&(a=`\\${a.slice(u)}`)}return n.win32.normalize(a)},relative(s,a){if(m(s,"from"),m(a,"to"),s===a)return"";const i=n.win32.resolve(s),o=n.win32.resolve(a);if(i===o||(s=i.toLowerCase(),a=o.toLowerCase(),s===a))return"";let u=0;for(;u<s.length&&s.charCodeAt(u)===f;)u++;let d=s.length;for(;d-1>u&&s.charCodeAt(d-1)===f;)d--;const g=d-u;let N=0;for(;N<a.length&&a.charCodeAt(N)===f;)N++;let b=a.length;for(;b-1>N&&a.charCodeAt(b-1)===f;)b--;const w=b-N,v=g<w?g:w;let M=-1,I=0;for(;I<v;I++){const q=s.charCodeAt(u+I);if(q!==a.charCodeAt(N+I))break;q===f&&(M=I)}if(I!==v){if(M===-1)return o}else{if(w>v){if(a.charCodeAt(N+I)===f)return o.slice(N+I+1);if(I===2)return o.slice(N+I)}g>v&&(s.charCodeAt(u+I)===f?M=I:I===2&&(M=3)),M===-1&&(M=0)}let O="";for(I=u+M+1;I<=d;++I)(I===d||s.charCodeAt(I)===f)&&(O+=O.length===0?"..":"\\..");return N+=M,O.length>0?`${O}${o.slice(N,b)}`:(o.charCodeAt(N)===f&&++N,o.slice(N,b))},toNamespacedPath(s){if(typeof s!="string")return s;if(s.length===0)return"";const a=n.win32.resolve(s);if(a.length<=2)return s;if(a.charCodeAt(0)===f){if(a.charCodeAt(1)===f){const i=a.charCodeAt(2);if(i!==R&&i!==h)return`\\\\?\\UNC\\${a.slice(2)}`}}else if(F(a.charCodeAt(0))&&a.charCodeAt(1)===A&&a.charCodeAt(2)===f)return`\\\\?\\${a}`;return s},dirname(s){m(s,"path");const a=s.length;if(a===0)return".";let i=-1,o=0;const u=s.charCodeAt(0);if(a===1)return e(u)?s:".";if(e(u)){if(i=o=1,e(s.charCodeAt(1))){let N=2,b=N;for(;N<a&&!e(s.charCodeAt(N));)N++;if(N<a&&N!==b){for(b=N;N<a&&e(s.charCodeAt(N));)N++;if(N<a&&N!==b){for(b=N;N<a&&!e(s.charCodeAt(N));)N++;if(N===a)return s;N!==b&&(i=o=N+1)}}}}else F(u)&&s.charCodeAt(1)===A&&(i=a>2&&e(s.charCodeAt(2))?3:2,o=i);let d=-1,g=!0;for(let N=a-1;N>=o;--N)if(e(s.charCodeAt(N))){if(!g){d=N;break}}else g=!1;if(d===-1){if(i===-1)return".";d=i}return s.slice(0,d)},basename(s,a){a!==void 0&&m(a,"ext"),m(s,"path");let i=0,o=-1,u=!0,d;if(s.length>=2&&F(s.charCodeAt(0))&&s.charCodeAt(1)===A&&(i=2),a!==void 0&&a.length>0&&a.length<=s.length){if(a===s)return"";let g=a.length-1,N=-1;for(d=s.length-1;d>=i;--d){const b=s.charCodeAt(d);if(e(b)){if(!u){i=d+1;break}}else N===-1&&(u=!1,N=d+1),g>=0&&(b===a.charCodeAt(g)?--g===-1&&(o=d):(g=-1,o=N))}return i===o?o=N:o===-1&&(o=s.length),s.slice(i,o)}for(d=s.length-1;d>=i;--d)if(e(s.charCodeAt(d))){if(!u){i=d+1;break}}else o===-1&&(u=!1,o=d+1);return o===-1?"":s.slice(i,o)},extname(s){m(s,"path");let a=0,i=-1,o=0,u=-1,d=!0,g=0;s.length>=2&&s.charCodeAt(1)===A&&F(s.charCodeAt(0))&&(a=o=2);for(let N=s.length-1;N>=a;--N){const b=s.charCodeAt(N);if(e(b)){if(!d){o=N+1;break}continue}u===-1&&(d=!1,u=N+1),b===h?i===-1?i=N:g!==1&&(g=1):i!==-1&&(g=-1)}return i===-1||u===-1||g===0||g===1&&i===u-1&&i===o+1?"":s.slice(i,u)},format:L.bind(null,"\\"),parse(s){m(s,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(s.length===0)return a;const i=s.length;let o=0,u=s.charCodeAt(0);if(i===1)return e(u)?(a.root=a.dir=s,a):(a.base=a.name=s,a);if(e(u)){if(o=1,e(s.charCodeAt(1))){let M=2,I=M;for(;M<i&&!e(s.charCodeAt(M));)M++;if(M<i&&M!==I){for(I=M;M<i&&e(s.charCodeAt(M));)M++;if(M<i&&M!==I){for(I=M;M<i&&!e(s.charCodeAt(M));)M++;M===i?o=M:M!==I&&(o=M+1)}}}}else if(F(u)&&s.charCodeAt(1)===A){if(i<=2)return a.root=a.dir=s,a;if(o=2,e(s.charCodeAt(2))){if(i===3)return a.root=a.dir=s,a;o=3}}o>0&&(a.root=s.slice(0,o));let d=-1,g=o,N=-1,b=!0,w=s.length-1,v=0;for(;w>=o;--w){if(u=s.charCodeAt(w),e(u)){if(!b){g=w+1;break}continue}N===-1&&(b=!1,N=w+1),u===h?d===-1?d=w:v!==1&&(v=1):d!==-1&&(v=-1)}return N!==-1&&(d===-1||v===0||v===1&&d===N-1&&d===g+1?a.base=a.name=s.slice(g,N):(a.name=s.slice(g,d),a.base=s.slice(g,N),a.ext=s.slice(d,N))),g>0&&g!==o?a.dir=s.slice(0,g-1):a.dir=a.root,a},sep:"\\",delimiter:";",win32:null,posix:null},n.posix={resolve(...s){let a="",i=!1;for(let o=s.length-1;o>=-1&&!i;o--){const u=o>=0?s[o]:E.cwd();m(u,"path"),u.length!==0&&(a=`${u}/${a}`,i=u.charCodeAt(0)===l)}return a=y(a,!i,"/",C),i?`/${a}`:a.length>0?a:"."},normalize(s){if(m(s,"path"),s.length===0)return".";const a=s.charCodeAt(0)===l,i=s.charCodeAt(s.length-1)===l;return s=y(s,!a,"/",C),s.length===0?a?"/":i?"./":".":(i&&(s+="/"),a?`/${s}`:s)},isAbsolute(s){return m(s,"path"),s.length>0&&s.charCodeAt(0)===l},join(...s){if(s.length===0)return".";let a;for(let i=0;i<s.length;++i){const o=s[i];m(o,"path"),o.length>0&&(a===void 0?a=o:a+=`/${o}`)}return a===void 0?".":n.posix.normalize(a)},relative(s,a){if(m(s,"from"),m(a,"to"),s===a||(s=n.posix.resolve(s),a=n.posix.resolve(a),s===a))return"";const i=1,o=s.length,u=o-i,d=1,g=a.length-d,N=u<g?u:g;let b=-1,w=0;for(;w<N;w++){const M=s.charCodeAt(i+w);if(M!==a.charCodeAt(d+w))break;M===l&&(b=w)}if(w===N)if(g>N){if(a.charCodeAt(d+w)===l)return a.slice(d+w+1);if(w===0)return a.slice(d+w)}else u>N&&(s.charCodeAt(i+w)===l?b=w:w===0&&(b=0));let v="";for(w=i+b+1;w<=o;++w)(w===o||s.charCodeAt(w)===l)&&(v+=v.length===0?"..":"/..");return`${v}${a.slice(d+b)}`},toNamespacedPath(s){return s},dirname(s){if(m(s,"path"),s.length===0)return".";const a=s.charCodeAt(0)===l;let i=-1,o=!0;for(let u=s.length-1;u>=1;--u)if(s.charCodeAt(u)===l){if(!o){i=u;break}}else o=!1;return i===-1?a?"/":".":a&&i===1?"//":s.slice(0,i)},basename(s,a){a!==void 0&&m(a,"ext"),m(s,"path");let i=0,o=-1,u=!0,d;if(a!==void 0&&a.length>0&&a.length<=s.length){if(a===s)return"";let g=a.length-1,N=-1;for(d=s.length-1;d>=0;--d){const b=s.charCodeAt(d);if(b===l){if(!u){i=d+1;break}}else N===-1&&(u=!1,N=d+1),g>=0&&(b===a.charCodeAt(g)?--g===-1&&(o=d):(g=-1,o=N))}return i===o?o=N:o===-1&&(o=s.length),s.slice(i,o)}for(d=s.length-1;d>=0;--d)if(s.charCodeAt(d)===l){if(!u){i=d+1;break}}else o===-1&&(u=!1,o=d+1);return o===-1?"":s.slice(i,o)},extname(s){m(s,"path");let a=-1,i=0,o=-1,u=!0,d=0;for(let g=s.length-1;g>=0;--g){const N=s.charCodeAt(g);if(N===l){if(!u){i=g+1;break}continue}o===-1&&(u=!1,o=g+1),N===h?a===-1?a=g:d!==1&&(d=1):a!==-1&&(d=-1)}return a===-1||o===-1||d===0||d===1&&a===o-1&&a===i+1?"":s.slice(a,o)},format:L.bind(null,"/"),parse(s){m(s,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(s.length===0)return a;const i=s.charCodeAt(0)===l;let o;i?(a.root="/",o=1):o=0;let u=-1,d=0,g=-1,N=!0,b=s.length-1,w=0;for(;b>=o;--b){const v=s.charCodeAt(b);if(v===l){if(!N){d=b+1;break}continue}g===-1&&(N=!1,g=b+1),v===h?u===-1?u=b:w!==1&&(w=1):u!==-1&&(w=-1)}if(g!==-1){const v=d===0&&i?1:d;u===-1||w===0||w===1&&u===g-1&&u===d+1?a.base=a.name=s.slice(v,g):(a.name=s.slice(v,u),a.base=s.slice(v,g),a.ext=s.slice(u,g))}return d>0?a.dir=s.slice(0,d-1):i&&(a.dir="/"),a},sep:"/",delimiter:":",win32:null,posix:null},n.posix.win32=n.win32.win32=n.win32,n.posix.posix=n.win32.posix=n.posix,n.normalize=E.platform==="win32"?n.win32.normalize:n.posix.normalize,n.isAbsolute=E.platform==="win32"?n.win32.isAbsolute:n.posix.isAbsolute,n.join=E.platform==="win32"?n.win32.join:n.posix.join,n.resolve=E.platform==="win32"?n.win32.resolve:n.posix.resolve,n.relative=E.platform==="win32"?n.win32.relative:n.posix.relative,n.dirname=E.platform==="win32"?n.win32.dirname:n.posix.dirname,n.basename=E.platform==="win32"?n.win32.basename:n.posix.basename,n.extname=E.platform==="win32"?n.win32.extname:n.posix.extname,n.format=E.platform==="win32"?n.win32.format:n.posix.format,n.parse=E.platform==="win32"?n.win32.parse:n.posix.parse,n.toNamespacedPath=E.platform==="win32"?n.win32.toNamespacedPath:n.posix.toNamespacedPath,n.sep=E.platform==="win32"?n.win32.sep:n.posix.sep,n.delimiter=E.platform==="win32"?n.win32.delimiter:n.posix.delimiter}),Z(K[16],x([0,1,5]),function(B,n,E){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.StopWatch=void 0;const t=E.globals.performance&&typeof E.globals.performance.now=="function";class D{static create(_=!0){return new D(_)}constructor(_){this.a=t&&_,this.b=this.d(),this.c=-1}stop(){this.c=this.d()}reset(){this.b=this.d(),this.c=-1}elapsed(){return this.c!==-1?this.c-this.b:this.d()-this.b}d(){return this.a?E.globals.performance.now():Date.now()}}n.StopWatch=D}),Z(K[8],x([0,1,6,13,7,15,16]),function(B,n,E,t,D,c,_){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Relay=n.EventBufferer=n.EventMultiplexer=n.MicrotaskEmitter=n.DebounceEmitter=n.PauseableEmitter=n.AsyncEmitter=n.EventDeliveryQueue=n.Emitter=n.setGlobalLeakWarningThreshold=n.EventProfiling=n.Event=void 0;const h=!1,l=!1;var f;(function(b){b.None=()=>D.Disposable.None;function w(ee){if(l){const{onDidAddListener:G}=ee,Y=e.create();let k=0;ee.onDidAddListener=()=>{++k===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),Y.print()),G?.()}}}function v(ee,G){return Q(ee,()=>{},0,void 0,void 0,G)}b.defer=v;function M(ee){return(G,Y=null,k)=>{let T=!1,S;return S=ee(W=>{if(!T)return S?S.dispose():T=!0,G.call(Y,W)},null,k),T&&S.dispose(),S}}b.once=M;function I(ee,G,Y){return te((k,T=null,S)=>ee(W=>k.call(T,G(W)),null,S),Y)}b.map=I;function O(ee,G,Y){return te((k,T=null,S)=>ee(W=>{G(W),k.call(T,W)},null,S),Y)}b.forEach=O;function q(ee,G,Y){return te((k,T=null,S)=>ee(W=>G(W)&&k.call(T,W),null,S),Y)}b.filter=q;function $(ee){return ee}b.signal=$;function j(...ee){return(G,Y=null,k)=>(0,D.combinedDisposable)(...ee.map(T=>T(S=>G.call(Y,S),null,k)))}b.any=j;function ne(ee,G,Y,k){let T=Y;return I(ee,S=>(T=G(T,S),T),k)}b.reduce=ne;function te(ee,G){let Y;const k={onWillAddFirstListener(){Y=ee(T.fire,T)},onDidRemoveLastListener(){Y?.dispose()}};G||w(k);const T=new F(k);return G?.add(T),T.event}function Q(ee,G,Y=100,k=!1,T,S){let W,H,re,ie=0;const ue={leakWarningThreshold:T,onWillAddFirstListener(){W=ee(fe=>{ie++,H=G(H,fe),k&&!re&&(ae.fire(H),H=void 0),clearTimeout(re),re=setTimeout(()=>{const he=H;H=void 0,re=void 0,(!k||ie>1)&&ae.fire(he),ie=0},Y)})},onDidRemoveLastListener(){W.dispose()}};S||w(ue);const ae=new F(ue);return S?.add(ae),ae.event}b.debounce=Q;function J(ee,G=0,Y){return b.debounce(ee,(k,T)=>k?(k.push(T),k):[T],G,void 0,void 0,Y)}b.accumulate=J;function r(ee,G=(k,T)=>k===T,Y){let k=!0,T;return q(ee,S=>{const W=k||!G(S,T);return k=!1,T=S,W},Y)}b.latch=r;function ve(ee,G,Y){return[b.filter(ee,G,Y),b.filter(ee,k=>!G(k),Y)]}b.split=ve;function Ae(ee,G=!1,Y=[]){let k=Y.slice(),T=ee(H=>{k?k.push(H):W.fire(H)});const S=()=>{k?.forEach(H=>W.fire(H)),k=null},W=new F({onWillAddFirstListener(){T||(T=ee(H=>W.fire(H)))},onDidAddFirstListener(){k&&(G?setTimeout(S):S())},onDidRemoveLastListener(){T&&T.dispose(),T=null}});return W.event}b.buffer=Ae;class de{constructor(G){this.event=G,this.c=new D.DisposableStore}map(G){return new de(I(this.event,G,this.c))}forEach(G){return new de(O(this.event,G,this.c))}filter(G){return new de(q(this.event,G,this.c))}reduce(G,Y){return new de(ne(this.event,G,Y,this.c))}latch(){return new de(r(this.event,void 0,this.c))}debounce(G,Y=100,k=!1,T){return new de(Q(this.event,G,Y,k,T,this.c))}on(G,Y,k){return this.event(G,Y,k)}once(G,Y,k){return M(this.event)(G,Y,k)}dispose(){this.c.dispose()}}function Ce(ee){return new de(ee)}b.chain=Ce;function Le(ee,G,Y=k=>k){const k=(...H)=>W.fire(Y(...H)),T=()=>ee.on(G,k),S=()=>ee.removeListener(G,k),W=new F({onWillAddFirstListener:T,onDidRemoveLastListener:S});return W.event}b.fromNodeEventEmitter=Le;function Ne(ee,G,Y=k=>k){const k=(...H)=>W.fire(Y(...H)),T=()=>ee.addEventListener(G,k),S=()=>ee.removeEventListener(G,k),W=new F({onWillAddFirstListener:T,onDidRemoveLastListener:S});return W.event}b.fromDOMEventEmitter=Ne;function _e(ee){return new Promise(G=>M(ee)(G))}b.toPromise=_e;function Me(ee,G){return G(void 0),ee(Y=>G(Y))}b.runAndSubscribe=Me;function De(ee,G){let Y=null;function k(S){Y?.dispose(),Y=new D.DisposableStore,G(S,Y)}k(void 0);const T=ee(S=>k(S));return(0,D.toDisposable)(()=>{T.dispose(),Y?.dispose()})}b.runAndSubscribeWithStore=De;class Ee{constructor(G,Y){this.obs=G,this.c=0,this.d=!1;const k={onWillAddFirstListener:()=>{G.addObserver(this)},onDidRemoveLastListener:()=>{G.removeObserver(this)}};Y||w(k),this.emitter=new F(k),Y&&Y.add(this.emitter)}beginUpdate(G){this.c++}handleChange(G,Y){this.d=!0}endUpdate(G){--this.c===0&&this.d&&(this.d=!1,this.emitter.fire(this.obs.get()))}}function Fe(ee,G){return new Ee(ee,G).emitter.event}b.fromObservable=Fe})(f=n.Event||(n.Event={}));class A{constructor(w){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${w}_${A.c++}`,A.all.add(this)}start(w){this.d=new _.StopWatch(!0),this.listenerCount=w}stop(){if(this.d){const w=this.d.elapsed();this.durations.push(w),this.elapsedOverall+=w,this.invocationCount+=1,this.d=void 0}}}n.EventProfiling=A,A.all=new Set,A.c=0;let R=-1;function p(b){const w=R;return R=b,{dispose(){R=w}}}n.setGlobalLeakWarningThreshold=p;class m{constructor(w,v=Math.random().toString(18).slice(2,5)){this.threshold=w,this.name=v,this.d=0}dispose(){this.c?.clear()}check(w,v){const M=this.threshold;if(M<=0||v<M)return;this.c||(this.c=new Map);const I=this.c.get(w.value)||0;if(this.c.set(w.value,I+1),this.d-=1,this.d<=0){this.d=M*.5;let O,q=0;for(const[$,j]of this.c)(!O||q<j)&&(O=$,q=j);console.warn(`[${this.name}] potential listener LEAK detected, having ${v} listeners already. MOST frequent listener (${q}):`),console.warn(O)}return()=>{const O=this.c.get(w.value)||0;this.c.set(w.value,O-1)}}}class e{static create(){return new e(new Error().stack??"")}constructor(w){this.value=w}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class C{constructor(w,v,M){this.callback=w,this.callbackThis=v,this.stack=M,this.subscription=new D.SafeDisposable}invoke(w){this.callback.call(this.callbackThis,w)}}class F{constructor(w){this.j=!1,this.d=w,this.f=R>0||this.d?.leakWarningThreshold?new m(this.d?.leakWarningThreshold??R):void 0,this.g=this.d?._profName?new A(this.d._profName):void 0,this.m=this.d?.deliveryQueue}dispose(){if(!this.j){if(this.j=!0,this.q){if(h){const w=Array.from(this.q);queueMicrotask(()=>{for(const v of w)v.subscription.isset()&&(v.subscription.unset(),v.stack?.print())})}this.q.clear()}this.m?.clear(this),this.d?.onDidRemoveLastListener?.(),this.f?.dispose()}}get event(){return this.l||(this.l=(w,v,M)=>{if(this.q||(this.q=new c.LinkedList),this.f&&this.q.size>this.f.threshold*3)return console.warn(`[${this.f.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),D.Disposable.None;const I=this.q.isEmpty();I&&this.d?.onWillAddFirstListener&&this.d.onWillAddFirstListener(this);let O,q;this.f&&this.q.size>=Math.ceil(this.f.threshold*.2)&&(q=e.create(),O=this.f.check(q,this.q.size+1)),h&&(q=q??e.create());const $=new C(w,v,q),j=this.q.push($);I&&this.d?.onDidAddFirstListener&&this.d.onDidAddFirstListener(this),this.d?.onDidAddListener&&this.d.onDidAddListener(this,w,v);const ne=$.subscription.set(()=>{O?.(),this.j||(j(),this.d&&this.d.onDidRemoveLastListener&&(this.q&&!this.q.isEmpty()||this.d.onDidRemoveLastListener(this)))});return M instanceof D.DisposableStore?M.add(ne):Array.isArray(M)&&M.push(ne),ne}),this.l}fire(w){if(this.q){this.m||(this.m=new L);for(const v of this.q)this.m.push(this,v,w);this.g?.start(this.m.size),this.m.deliver(),this.g?.stop()}}hasListeners(){return this.q?!this.q.isEmpty():!1}}n.Emitter=F;class y{constructor(){this.c=new c.LinkedList}get size(){return this.c.size}push(w,v,M){this.c.push(new s(w,v,M))}clear(w){const v=new c.LinkedList;for(const M of this.c)M.emitter!==w&&v.push(M);this.c=v}deliver(){for(;this.c.size>0;){const w=this.c.shift();try{w.listener.invoke(w.event)}catch(v){(0,E.onUnexpectedError)(v)}}}}n.EventDeliveryQueue=y;class L extends y{clear(w){this.c.clear()}}class s{constructor(w,v,M){this.emitter=w,this.listener=v,this.event=M}}class a extends F{async fireAsync(w,v,M){if(!!this.q){this.c||(this.c=new c.LinkedList);for(const I of this.q)this.c.push([I,w]);for(;this.c.size>0&&!v.isCancellationRequested;){const[I,O]=this.c.shift(),q=[],$={...O,token:v,waitUntil:j=>{if(Object.isFrozen(q))throw new Error("waitUntil can NOT be called asynchronous");M&&(j=M(j,I.callback)),q.push(j)}};try{I.invoke($)}catch(j){(0,E.onUnexpectedError)(j);continue}Object.freeze(q),await Promise.allSettled(q).then(j=>{for(const ne of j)ne.status==="rejected"&&(0,E.onUnexpectedError)(ne.reason)})}}}}n.AsyncEmitter=a;class i extends F{constructor(w){super(w),this.h=0,this.s=new c.LinkedList,this.t=w?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.t){if(this.s.size>0){const w=Array.from(this.s);this.s.clear(),super.fire(this.t(w))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(w){this.q&&(this.h!==0?this.s.push(w):super.fire(w))}}n.PauseableEmitter=i;class o extends i{constructor(w){super(w),this.c=w.delay??100}fire(w){this.k||(this.pause(),this.k=setTimeout(()=>{this.k=void 0,this.resume()},this.c)),super.fire(w)}}n.DebounceEmitter=o;class u extends F{constructor(w){super(w),this.c=[],this.h=w?.merge}fire(w){!this.hasListeners()||(this.c.push(w),this.c.length===1&&queueMicrotask(()=>{this.h?super.fire(this.h(this.c)):this.c.forEach(v=>super.fire(v)),this.c=[]}))}}n.MicrotaskEmitter=u;class d{constructor(){this.d=!1,this.f=[],this.c=new F({onWillAddFirstListener:()=>this.g(),onDidRemoveLastListener:()=>this.h()})}get event(){return this.c.event}add(w){const v={event:w,listener:null};this.f.push(v),this.d&&this.j(v);const M=()=>{this.d&&this.k(v);const I=this.f.indexOf(v);this.f.splice(I,1)};return(0,D.toDisposable)((0,t.once)(M))}g(){this.d=!0,this.f.forEach(w=>this.j(w))}h(){this.d=!1,this.f.forEach(w=>this.k(w))}j(w){w.listener=w.event(v=>this.c.fire(v))}k(w){w.listener&&w.listener.dispose(),w.listener=null}dispose(){this.c.dispose()}}n.EventMultiplexer=d;class g{constructor(){this.c=[]}wrapEvent(w){return(v,M,I)=>w(O=>{const q=this.c[this.c.length-1];q?q.push(()=>v.call(M,O)):v.call(M,O)},void 0,I)}bufferEvents(w){const v=[];this.c.push(v);const M=w();return this.c.pop(),v.forEach(I=>I()),M}}n.EventBufferer=g;class N{constructor(){this.c=!1,this.d=f.None,this.f=D.Disposable.None,this.g=new F({onDidAddFirstListener:()=>{this.c=!0,this.f=this.d(this.g.fire,this.g)},onDidRemoveLastListener:()=>{this.c=!1,this.f.dispose()}}),this.event=this.g.event}set input(w){this.d=w,this.c&&(this.f.dispose(),this.f=w(this.g.fire,this.g))}dispose(){this.f.dispose(),this.g.dispose()}}n.Relay=N}),Z(K[17],x([0,1,8]),function(B,n,E){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.CancellationTokenSource=n.CancellationToken=void 0;const t=Object.freeze(function(h,l){const f=setTimeout(h.bind(l),0);return{dispose(){clearTimeout(f)}}});var D;(function(h){function l(f){return f===h.None||f===h.Cancelled||f instanceof c?!0:!f||typeof f!="object"?!1:typeof f.isCancellationRequested=="boolean"&&typeof f.onCancellationRequested=="function"}h.isCancellationToken=l,h.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:E.Event.None}),h.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:t})})(D=n.CancellationToken||(n.CancellationToken={}));class c{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?t:(this.b||(this.b=new E.Emitter),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class _{constructor(l){this.a=void 0,this.b=void 0,this.b=l&&l.onCancellationRequested(this.cancel,this)}get token(){return this.a||(this.a=new c),this.a}cancel(){this.a?this.a instanceof c&&this.a.cancel():this.a=D.Cancelled}dispose(l=!1){l&&this.cancel(),this.b?.dispose(),this.a?this.a instanceof c&&this.a.dispose():this.a=D.None}}n.CancellationTokenSource=_}),Z(K[31],x([0,1,17]),function(B,n,E){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.CachedFunction=n.LRUCachedFunction=n.Cache=void 0;class t{constructor(h){this.b=h,this.a=null}get(){if(this.a)return this.a;const h=new E.CancellationTokenSource,l=this.b(h.token);return this.a={promise:l,dispose:()=>{this.a=null,h.cancel(),h.dispose()}},this.a}}n.Cache=t;class D{constructor(h){this.c=h,this.a=void 0,this.b=void 0}get(h){const l=JSON.stringify(h);return this.b!==l&&(this.b=l,this.a=this.c(h)),this.a}}n.LRUCachedFunction=D;class c{get cachedValues(){return this.a}constructor(h){this.b=h,this.a=new Map}get(h){if(this.a.has(h))return this.a.get(h);const l=this.b(h);return this.a.set(h,l),l}}n.CachedFunction=c}),Z(K[4],x([0,1,31,28]),function(B,n,E,t){"use strict";var D;Object.defineProperty(n,"__esModule",{value:!0}),n.InvisibleCharacters=n.AmbiguousCharacters=n.noBreakWhitespace=n.getLeftDeleteOffset=n.GraphemeBreakType=n.getGraphemeBreakType=n.singleLetterHash=n.getNLines=n.uppercaseFirstLetter=n.containsUppercaseCharacter=n.fuzzyContains=n.stripUTF8BOM=n.startsWithUTF8BOM=n.UTF8_BOM_CHARACTER=n.removeAnsiEscapeCodes=n.lcut=n.isEmojiImprecise=n.isFullWidthCharacter=n.containsUnusualLineTerminators=n.UNUSUAL_LINE_TERMINATORS=n.isBasicASCII=n.containsRTL=n.charCount=n.getCharContainingOffset=n.prevCharLength=n.nextCharLength=n.GraphemeIterator=n.CodePointIterator=n.getNextCodePoint=n.computeCodePoint=n.isLowSurrogate=n.isHighSurrogate=n.commonSuffixLength=n.commonPrefixLength=n.startsWithIgnoreCase=n.equalsIgnoreCase=n.isUpperAsciiLetter=n.isLowerAsciiLetter=n.isAsciiDigit=n.compareSubstringIgnoreCase=n.compareIgnoreCase=n.compareSubstring=n.compare=n.replaceAsync=n.lastNonWhitespaceIndex=n.getLeadingWhitespace=n.firstNonWhitespaceIndex=n.splitLines=n.regExpFlags=n.regExpContainsBackreference=n.regExpLeadsToEndlessLoop=n.createRegExp=n.stripWildcards=n.convertSimple2RegExpPattern=n.rtrim=n.ltrim=n.trim=n.truncate=n.count=n.escapeRegExpCharacters=n.escape=n.format2=n.format=n.isFalsyOrWhitespace=void 0;function c(P){return!P||typeof P!="string"?!0:P.trim().length===0}n.isFalsyOrWhitespace=c;const _=/{(\d+)}/g;function h(P,...U){return U.length===0?P:P.replace(_,function(V,z){const X=parseInt(z,10);return isNaN(X)||X<0||X>=U.length?V:U[X]})}n.format=h;const l=/{([^}]+)}/g;function f(P,U){return P.replace(l,(V,z)=>U[z]??V)}n.format2=f;function A(P){return P.replace(/[<>&]/g,function(U){switch(U){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return U}})}n.escape=A;function R(P){return P.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}n.escapeRegExpCharacters=R;function p(P,U){let V=0;const z=U.charCodeAt(0);for(let X=P.length-1;X>=0;X--)P.charCodeAt(X)===z&&V++;return V}n.count=p;function m(P,U,V="\u2026"){return P.length<=U?P:`${P.substr(0,U)}${V}`}n.truncate=m;function e(P,U=" "){const V=C(P,U);return F(V,U)}n.trim=e;function C(P,U){if(!P||!U)return P;const V=U.length;if(V===0||P.length===0)return P;let z=0;for(;P.indexOf(U,z)===z;)z=z+V;return P.substring(z)}n.ltrim=C;function F(P,U){if(!P||!U)return P;const V=U.length,z=P.length;if(V===0||z===0)return P;let X=z,se=-1;for(;se=P.lastIndexOf(U,X-1),!(se===-1||se+V!==X);){if(se===0)return"";X=se}return P.substring(0,X)}n.rtrim=F;function y(P){return P.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}n.convertSimple2RegExpPattern=y;function L(P){return P.replace(/\*/g,"")}n.stripWildcards=L;function s(P,U,V={}){if(!P)throw new Error("Cannot create regex from empty string");U||(P=R(P)),V.wholeWord&&(/\B/.test(P.charAt(0))||(P="\\b"+P),/\B/.test(P.charAt(P.length-1))||(P=P+"\\b"));let z="";return V.global&&(z+="g"),V.matchCase||(z+="i"),V.multiline&&(z+="m"),V.unicode&&(z+="u"),new RegExp(P,z)}n.createRegExp=s;function a(P){return P.source==="^"||P.source==="^$"||P.source==="$"||P.source==="^\\s*$"?!1:!!(P.exec("")&&P.lastIndex===0)}n.regExpLeadsToEndlessLoop=a;function i(P){return!!P.match(/([^\\]|^)(\\\\)*\\\d+/)}n.regExpContainsBackreference=i;function o(P){return(P.global?"g":"")+(P.ignoreCase?"i":"")+(P.multiline?"m":"")+(P.unicode?"u":"")}n.regExpFlags=o;function u(P){return P.split(/\r\n|\r|\n/)}n.splitLines=u;function d(P){for(let U=0,V=P.length;U<V;U++){const z=P.charCodeAt(U);if(z!==32&&z!==9)return U}return-1}n.firstNonWhitespaceIndex=d;function g(P,U=0,V=P.length){for(let z=U;z<V;z++){const X=P.charCodeAt(z);if(X!==32&&X!==9)return P.substring(U,z)}return P.substring(U,V)}n.getLeadingWhitespace=g;function N(P,U=P.length-1){for(let V=U;V>=0;V--){const z=P.charCodeAt(V);if(z!==32&&z!==9)return V}return-1}n.lastNonWhitespaceIndex=N;function b(P,U,V){const z=[];let X=0;for(const se of P.matchAll(U)){if(z.push(P.slice(X,se.index)),se.index===void 0)throw new Error("match.index should be defined");X=se.index+se[0].length,z.push(V(se[0],...se.slice(1),se.index,P,se.groups))}return z.push(P.slice(X)),Promise.all(z).then(se=>se.join(""))}n.replaceAsync=b;function w(P,U){return P<U?-1:P>U?1:0}n.compare=w;function v(P,U,V=0,z=P.length,X=0,se=U.length){for(;V<z&&X<se;V++,X++){const be=P.charCodeAt(V),oe=U.charCodeAt(X);if(be<oe)return-1;if(be>oe)return 1}const ce=z-V,ye=se-X;return ce<ye?-1:ce>ye?1:0}n.compareSubstring=v;function M(P,U){return I(P,U,0,P.length,0,U.length)}n.compareIgnoreCase=M;function I(P,U,V=0,z=P.length,X=0,se=U.length){for(;V<z&&X<se;V++,X++){let be=P.charCodeAt(V),oe=U.charCodeAt(X);if(be===oe)continue;if(be>=128||oe>=128)return v(P.toLowerCase(),U.toLowerCase(),V,z,X,se);q(be)&&(be-=32),q(oe)&&(oe-=32);const ge=be-oe;if(ge!==0)return ge}const ce=z-V,ye=se-X;return ce<ye?-1:ce>ye?1:0}n.compareSubstringIgnoreCase=I;function O(P){return P>=48&&P<=57}n.isAsciiDigit=O;function q(P){return P>=97&&P<=122}n.isLowerAsciiLetter=q;function $(P){return P>=65&&P<=90}n.isUpperAsciiLetter=$;function j(P,U){return P.length===U.length&&I(P,U)===0}n.equalsIgnoreCase=j;function ne(P,U){const V=U.length;return U.length>P.length?!1:I(P,U,0,V)===0}n.startsWithIgnoreCase=ne;function te(P,U){const V=Math.min(P.length,U.length);let z;for(z=0;z<V;z++)if(P.charCodeAt(z)!==U.charCodeAt(z))return z;return V}n.commonPrefixLength=te;function Q(P,U){const V=Math.min(P.length,U.length);let z;const X=P.length-1,se=U.length-1;for(z=0;z<V;z++)if(P.charCodeAt(X-z)!==U.charCodeAt(se-z))return z;return V}n.commonSuffixLength=Q;function J(P){return 55296<=P&&P<=56319}n.isHighSurrogate=J;function r(P){return 56320<=P&&P<=57343}n.isLowSurrogate=r;function ve(P,U){return(P-55296<<10)+(U-56320)+65536}n.computeCodePoint=ve;function Ae(P,U,V){const z=P.charCodeAt(V);if(J(z)&&V+1<U){const X=P.charCodeAt(V+1);if(r(X))return ve(z,X)}return z}n.getNextCodePoint=Ae;function de(P,U){const V=P.charCodeAt(U-1);if(r(V)&&U>1){const z=P.charCodeAt(U-2);if(J(z))return ve(z,V)}return V}class Ce{get offset(){return this.e}constructor(U,V=0){this.c=U,this.d=U.length,this.e=V}setOffset(U){this.e=U}prevCodePoint(){const U=de(this.c,this.e);return this.e-=U>=65536?2:1,U}nextCodePoint(){const U=Ae(this.c,this.d,this.e);return this.e+=U>=65536?2:1,U}eol(){return this.e>=this.d}}n.CodePointIterator=Ce;class Le{get offset(){return this.c.offset}constructor(U,V=0){this.c=new Ce(U,V)}nextGraphemeLength(){const U=pe.getInstance(),V=this.c,z=V.offset;let X=U.getGraphemeBreakType(V.nextCodePoint());for(;!V.eol();){const se=V.offset,ce=U.getGraphemeBreakType(V.nextCodePoint());if(Se(X,ce)){V.setOffset(se);break}X=ce}return V.offset-z}prevGraphemeLength(){const U=pe.getInstance(),V=this.c,z=V.offset;let X=U.getGraphemeBreakType(V.prevCodePoint());for(;V.offset>0;){const se=V.offset,ce=U.getGraphemeBreakType(V.prevCodePoint());if(Se(ce,X)){V.setOffset(se);break}X=ce}return z-V.offset}eol(){return this.c.eol()}}n.GraphemeIterator=Le;function Ne(P,U){return new Le(P,U).nextGraphemeLength()}n.nextCharLength=Ne;function _e(P,U){return new Le(P,U).prevGraphemeLength()}n.prevCharLength=_e;function Me(P,U){U>0&&r(P.charCodeAt(U))&&U--;const V=U+Ne(P,U);return[V-_e(P,V),V]}n.getCharContainingOffset=Me;function De(P){const U=new Le(P);let V=0;for(;!U.eol();)V++,U.nextGraphemeLength();return V}n.charCount=De;let Ee;function Fe(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function ee(P){return Ee||(Ee=Fe()),Ee.test(P)}n.containsRTL=ee;const G=/^[\t\n\r\x20-\x7E]*$/;function Y(P){return G.test(P)}n.isBasicASCII=Y,n.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function k(P){return n.UNUSUAL_LINE_TERMINATORS.test(P)}n.containsUnusualLineTerminators=k;function T(P){return P>=11904&&P<=55215||P>=63744&&P<=64255||P>=65281&&P<=65374}n.isFullWidthCharacter=T;function S(P){return P>=127462&&P<=127487||P===8986||P===8987||P===9200||P===9203||P>=9728&&P<=10175||P===11088||P===11093||P>=127744&&P<=128591||P>=128640&&P<=128764||P>=128992&&P<=129008||P>=129280&&P<=129535||P>=129648&&P<=129782}n.isEmojiImprecise=S;function W(P,U){if(P.length<U)return P;const V=/\b/g;let z=0;for(;V.test(P)&&!(P.length-V.lastIndex<U);)z=V.lastIndex,V.lastIndex+=1;return P.substring(z).replace(/^\s/,"")}n.lcut=W;const H=/\x1B\x5B[12]?K/g,re=/\x1b\[\d+m/g,ie=/\x1b\[0?m/g;function ue(P){return P&&(P=P.replace(H,""),P=P.replace(re,""),P=P.replace(ie,"")),P}n.removeAnsiEscapeCodes=ue,n.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function ae(P){return!!(P&&P.length>0&&P.charCodeAt(0)===65279)}n.startsWithUTF8BOM=ae;function fe(P){return ae(P)?P.substr(1):P}n.stripUTF8BOM=fe;function he(P,U){if(!P||!U||P.length<U.length)return!1;const V=U.length,z=P.toLowerCase();let X=0,se=-1;for(;X<V;){const ce=z.indexOf(U[X],se+1);if(ce<0)return!1;se=ce,X++}return!0}n.fuzzyContains=he;function ke(P,U=!1){return P?(U&&(P=P.replace(/\\./g,"")),P.toLowerCase()!==P):!1}n.containsUppercaseCharacter=ke;function Be(P){return P.charAt(0).toUpperCase()+P.slice(1)}n.uppercaseFirstLetter=Be;function We(P,U=1){if(U===0)return"";let V=-1;do V=P.indexOf(`
`,V+1),U--;while(U>0&&V>=0);return V===-1?P:(P[V-1]==="\r"&&V--,P.substr(0,V))}n.getNLines=We;function qe(P){return P=P%(2*26),P<26?String.fromCharCode(97+P):String.fromCharCode(65+P-26)}n.singleLetterHash=qe;function Ve(P){return pe.getInstance().getGraphemeBreakType(P)}n.getGraphemeBreakType=Ve;function Se(P,U){return P===0?U!==5&&U!==7:P===2&&U===3?!1:P===4||P===2||P===3||U===4||U===2||U===3?!0:!(P===8&&(U===8||U===9||U===11||U===12)||(P===11||P===9)&&(U===9||U===10)||(P===12||P===10)&&U===10||U===5||U===13||U===7||P===1||P===13&&U===14||P===6&&U===6)}var He;(function(P){P[P.Other=0]="Other",P[P.Prepend=1]="Prepend",P[P.CR=2]="CR",P[P.LF=3]="LF",P[P.Control=4]="Control",P[P.Extend=5]="Extend",P[P.Regional_Indicator=6]="Regional_Indicator",P[P.SpacingMark=7]="SpacingMark",P[P.L=8]="L",P[P.V=9]="V",P[P.T=10]="T",P[P.LV=11]="LV",P[P.LVT=12]="LVT",P[P.ZWJ=13]="ZWJ",P[P.Extended_Pictographic=14]="Extended_Pictographic"})(He=n.GraphemeBreakType||(n.GraphemeBreakType={}));class pe{static getInstance(){return pe.c||(pe.c=new pe),pe.c}constructor(){this.d=je()}getGraphemeBreakType(U){if(U<32)return U===10?3:U===13?2:4;if(U<127)return 0;const V=this.d,z=V.length/3;let X=1;for(;X<=z;)if(U<V[3*X])X=2*X;else if(U>V[3*X+1])X=2*X+1;else return V[3*X+2];return 0}}pe.c=null;function je(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function ze(P,U){if(P===0)return 0;const V=$e(P,U);if(V!==void 0)return V;const z=new Ce(U,P);return z.prevCodePoint(),z.offset}n.getLeftDeleteOffset=ze;function $e(P,U){const V=new Ce(U,P);let z=V.prevCodePoint();for(;Ge(z)||z===65039||z===8419;){if(V.offset===0)return;z=V.prevCodePoint()}if(!S(z))return;let X=V.offset;return X>0&&V.prevCodePoint()===8205&&(X=V.offset),X}function Ge(P){return 127995<=P&&P<=127999}var Ie;(function(P){P[P.zwj=8205]="zwj",P[P.emojiVariantSelector=65039]="emojiVariantSelector",P[P.enclosingKeyCap=8419]="enclosingKeyCap"})(Ie||(Ie={})),n.noBreakWhitespace="\xA0";class me{static getInstance(U){return me.d.get(Array.from(U))}static getLocales(){return me.e.getValue()}constructor(U){this.f=U}isAmbiguous(U){return this.f.has(U)}getPrimaryConfusable(U){return this.f.get(U)}getConfusableCodePoints(){return new Set(this.f.keys())}}n.AmbiguousCharacters=me,D=me,me.c=new t.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),me.d=new E.LRUCachedFunction(P=>{function U(oe){const ge=new Map;for(let we=0;we<oe.length;we+=2)ge.set(oe[we],oe[we+1]);return ge}function V(oe,ge){const we=new Map(oe);for(const[Pe,Te]of ge)we.set(Pe,Te);return we}function z(oe,ge){if(!oe)return ge;const we=new Map;for(const[Pe,Te]of oe)ge.has(Pe)&&we.set(Pe,Te);return we}const X=D.c.getValue();let se=P.filter(oe=>!oe.startsWith("_")&&oe in X);se.length===0&&(se=["_default"]);let ce;for(const oe of se){const ge=U(X[oe]);ce=z(ce,ge)}const ye=U(X._common),be=V(ye,ce);return new me(be)}),me.e=new t.Lazy(()=>Object.keys(me.c.getValue()).filter(P=>!P.startsWith("_")));class Re{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static e(){return this.d||(this.d=new Set(Re.c())),this.d}static isInvisibleCharacter(U){return Re.e().has(U)}static get codePoints(){return Re.e()}}n.InvisibleCharacters=Re,Re.d=void 0}),Z(K[32],x([0,1,4]),function(B,n,E){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.StringSHA1=n.toHexString=n.Hasher=n.stringHash=n.numberHash=n.doHash=n.hash=void 0;function t(y){return D(y,0)}n.hash=t;function D(y,L){switch(typeof y){case"object":return y===null?c(349,L):Array.isArray(y)?l(y,L):f(y,L);case"string":return h(y,L);case"boolean":return _(y,L);case"number":return c(y,L);case"undefined":return c(937,L);default:return c(617,L)}}n.doHash=D;function c(y,L){return(L<<5)-L+y|0}n.numberHash=c;function _(y,L){return c(y?433:863,L)}function h(y,L){L=c(149417,L);for(let s=0,a=y.length;s<a;s++)L=c(y.charCodeAt(s),L);return L}n.stringHash=h;function l(y,L){return L=c(104579,L),y.reduce((s,a)=>D(a,s),L)}function f(y,L){return L=c(181387,L),Object.keys(y).sort().reduce((s,a)=>(s=h(a,s),D(y[a],s)),L)}class A{constructor(){this.g=0}get value(){return this.g}hash(L){return this.g=D(L,this.g),this.g}}n.Hasher=A;var R;(function(y){y[y.BLOCK_SIZE=64]="BLOCK_SIZE",y[y.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(R||(R={}));function p(y,L,s=32){const a=s-L,i=~((1<<a)-1);return(y<<L|(i&y)>>>a)>>>0}function m(y,L=0,s=y.byteLength,a=0){for(let i=0;i<s;i++)y[L+i]=a}function e(y,L,s="0"){for(;y.length<L;)y=s+y;return y}function C(y,L=32){return y instanceof ArrayBuffer?Array.from(new Uint8Array(y)).map(s=>s.toString(16).padStart(2,"0")).join(""):e((y>>>0).toString(16),L/4)}n.toHexString=C;class F{constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(L){const s=L.length;if(s===0)return;const a=this.p;let i=this.r,o=this.u,u,d;for(o!==0?(u=o,d=-1,o=0):(u=L.charCodeAt(0),d=0);;){let g=u;if(E.isHighSurrogate(u))if(d+1<s){const N=L.charCodeAt(d+1);E.isLowSurrogate(N)?(d++,g=E.computeCodePoint(u,N)):g=65533}else{o=u;break}else E.isLowSurrogate(u)&&(g=65533);if(i=this.w(a,i,g),d++,d<s)u=L.charCodeAt(d);else break}this.r=i,this.u=o}w(L,s,a){return a<128?L[s++]=a:a<2048?(L[s++]=192|(a&1984)>>>6,L[s++]=128|(a&63)>>>0):a<65536?(L[s++]=224|(a&61440)>>>12,L[s++]=128|(a&4032)>>>6,L[s++]=128|(a&63)>>>0):(L[s++]=240|(a&1835008)>>>18,L[s++]=128|(a&258048)>>>12,L[s++]=128|(a&4032)>>>6,L[s++]=128|(a&63)>>>0),s>=64&&(this.y(),s-=64,this.t+=64,L[0]=L[64+0],L[1]=L[64+1],L[2]=L[64+2]),s}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),C(this.h)+C(this.l)+C(this.m)+C(this.n)+C(this.o)}x(){this.p[this.r++]=128,m(this.p,this.r),this.r>56&&(this.y(),m(this.p));const L=8*this.t;this.q.setUint32(56,Math.floor(L/4294967296),!1),this.q.setUint32(60,L%4294967296,!1),this.y()}y(){const L=F.g,s=this.q;for(let w=0;w<64;w+=4)L.setUint32(w,s.getUint32(w,!1),!1);for(let w=64;w<320;w+=4)L.setUint32(w,p(L.getUint32(w-12,!1)^L.getUint32(w-32,!1)^L.getUint32(w-56,!1)^L.getUint32(w-64,!1),1),!1);let a=this.h,i=this.l,o=this.m,u=this.n,d=this.o,g,N,b;for(let w=0;w<80;w++)w<20?(g=i&o|~i&u,N=1518500249):w<40?(g=i^o^u,N=1859775393):w<60?(g=i&o|i&u|o&u,N=2400959708):(g=i^o^u,N=3395469782),b=p(a,5)+g+d+N+L.getUint32(w*4,!1)&4294967295,d=u,u=o,o=p(i,30),i=a,a=b;this.h=this.h+a&4294967295,this.l=this.l+i&4294967295,this.m=this.m+o&4294967295,this.n=this.n+u&4294967295,this.o=this.o+d&4294967295}}n.StringSHA1=F,F.g=new DataView(new ArrayBuffer(320))}),Z(K[18],x([0,1,25,32]),function(B,n,E,t){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.LcsDiff=n.stringDiff=n.StringDiffSequence=void 0;class D{constructor(p){this.a=p}getElements(){const p=this.a,m=new Int32Array(p.length);for(let e=0,C=p.length;e<C;e++)m[e]=p.charCodeAt(e);return m}}n.StringDiffSequence=D;function c(R,p,m){return new A(new D(R),new D(p)).ComputeDiff(m).changes}n.stringDiff=c;class _{static Assert(p,m){if(!p)throw new Error(m)}}class h{static Copy(p,m,e,C,F){for(let y=0;y<F;y++)e[C+y]=p[m+y]}static Copy2(p,m,e,C,F){for(let y=0;y<F;y++)e[C+y]=p[m+y]}}var l;(function(R){R[R.MaxDifferencesHistory=1447]="MaxDifferencesHistory"})(l||(l={}));class f{constructor(){this.a=[],this.b=1073741824,this.c=1073741824,this.d=0,this.e=0}MarkNextChange(){(this.d>0||this.e>0)&&this.a.push(new E.DiffChange(this.b,this.d,this.c,this.e)),this.d=0,this.e=0,this.b=1073741824,this.c=1073741824}AddOriginalElement(p,m){this.b=Math.min(this.b,p),this.c=Math.min(this.c,m),this.d++}AddModifiedElement(p,m){this.b=Math.min(this.b,p),this.c=Math.min(this.c,m),this.e++}getChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a}getReverseChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a.reverse(),this.a}}class A{constructor(p,m,e=null){this.a=e,this.b=p,this.c=m;const[C,F,y]=A.o(p),[L,s,a]=A.o(m);this.d=y&&a,this.e=C,this.f=F,this.g=L,this.h=s,this.k=[],this.m=[]}static n(p){return p.length>0&&typeof p[0]=="string"}static o(p){const m=p.getElements();if(A.n(m)){const e=new Int32Array(m.length);for(let C=0,F=m.length;C<F;C++)e[C]=(0,t.stringHash)(m[C],0);return[m,e,!0]}return m instanceof Int32Array?[[],m,!1]:[[],new Int32Array(m),!1]}p(p,m){return this.f[p]!==this.h[m]?!1:this.d?this.e[p]===this.g[m]:!0}q(p,m){if(!this.p(p,m))return!1;const e=A.r(this.b,p),C=A.r(this.c,m);return e===C}static r(p,m){return typeof p.getStrictElement=="function"?p.getStrictElement(m):null}s(p,m){return this.f[p]!==this.f[m]?!1:this.d?this.e[p]===this.e[m]:!0}u(p,m){return this.h[p]!==this.h[m]?!1:this.d?this.g[p]===this.g[m]:!0}ComputeDiff(p){return this.v(0,this.f.length-1,0,this.h.length-1,p)}v(p,m,e,C,F){const y=[!1];let L=this.w(p,m,e,C,y);return F&&(L=this.z(L)),{quitEarly:y[0],changes:L}}w(p,m,e,C,F){for(F[0]=!1;p<=m&&e<=C&&this.p(p,e);)p++,e++;for(;m>=p&&C>=e&&this.p(m,C);)m--,C--;if(p>m||e>C){let o;return e<=C?(_.Assert(p===m+1,"originalStart should only be one more than originalEnd"),o=[new E.DiffChange(p,0,e,C-e+1)]):p<=m?(_.Assert(e===C+1,"modifiedStart should only be one more than modifiedEnd"),o=[new E.DiffChange(p,m-p+1,e,0)]):(_.Assert(p===m+1,"originalStart should only be one more than originalEnd"),_.Assert(e===C+1,"modifiedStart should only be one more than modifiedEnd"),o=[]),o}const y=[0],L=[0],s=this.y(p,m,e,C,y,L,F),a=y[0],i=L[0];if(s!==null)return s;if(!F[0]){const o=this.w(p,a,e,i,F);let u=[];return F[0]?u=[new E.DiffChange(a+1,m-(a+1)+1,i+1,C-(i+1)+1)]:u=this.w(a+1,m,i+1,C,F),this.H(o,u)}return[new E.DiffChange(p,m-p+1,e,C-e+1)]}x(p,m,e,C,F,y,L,s,a,i,o,u,d,g,N,b,w,v){let M=null,I=null,O=new f,q=m,$=e,j=d[0]-b[0]-C,ne=-1073741824,te=this.k.length-1;do{const Q=j+p;Q===q||Q<$&&a[Q-1]<a[Q+1]?(o=a[Q+1],g=o-j-C,o<ne&&O.MarkNextChange(),ne=o,O.AddModifiedElement(o+1,g),j=Q+1-p):(o=a[Q-1]+1,g=o-j-C,o<ne&&O.MarkNextChange(),ne=o-1,O.AddOriginalElement(o,g+1),j=Q-1-p),te>=0&&(a=this.k[te],p=a[0],q=1,$=a.length-1)}while(--te>=-1);if(M=O.getReverseChanges(),v[0]){let Q=d[0]+1,J=b[0]+1;if(M!==null&&M.length>0){const r=M[M.length-1];Q=Math.max(Q,r.getOriginalEnd()),J=Math.max(J,r.getModifiedEnd())}I=[new E.DiffChange(Q,u-Q+1,J,N-J+1)]}else{O=new f,q=y,$=L,j=d[0]-b[0]-s,ne=1073741824,te=w?this.m.length-1:this.m.length-2;do{const Q=j+F;Q===q||Q<$&&i[Q-1]>=i[Q+1]?(o=i[Q+1]-1,g=o-j-s,o>ne&&O.MarkNextChange(),ne=o+1,O.AddOriginalElement(o+1,g+1),j=Q+1-F):(o=i[Q-1],g=o-j-s,o>ne&&O.MarkNextChange(),ne=o,O.AddModifiedElement(o+1,g+1),j=Q-1-F),te>=0&&(i=this.m[te],F=i[0],q=1,$=i.length-1)}while(--te>=-1);I=O.getChanges()}return this.H(M,I)}y(p,m,e,C,F,y,L){let s=0,a=0,i=0,o=0,u=0,d=0;p--,e--,F[0]=0,y[0]=0,this.k=[],this.m=[];const g=m-p+(C-e),N=g+1,b=new Int32Array(N),w=new Int32Array(N),v=C-e,M=m-p,I=p-e,O=m-C,$=(M-v)%2===0;b[v]=p,w[M]=m,L[0]=!1;for(let j=1;j<=g/2+1;j++){let ne=0,te=0;i=this.J(v-j,j,v,N),o=this.J(v+j,j,v,N);for(let J=i;J<=o;J+=2){J===i||J<o&&b[J-1]<b[J+1]?s=b[J+1]:s=b[J-1]+1,a=s-(J-v)-I;const r=s;for(;s<m&&a<C&&this.p(s+1,a+1);)s++,a++;if(b[J]=s,s+a>ne+te&&(ne=s,te=a),!$&&Math.abs(J-M)<=j-1&&s>=w[J])return F[0]=s,y[0]=a,r<=w[J]&&1447>0&&j<=1447+1?this.x(v,i,o,I,M,u,d,O,b,w,s,m,F,a,C,y,$,L):null}const Q=(ne-p+(te-e)-j)/2;if(this.a!==null&&!this.a(ne,Q))return L[0]=!0,F[0]=ne,y[0]=te,Q>0&&1447>0&&j<=1447+1?this.x(v,i,o,I,M,u,d,O,b,w,s,m,F,a,C,y,$,L):(p++,e++,[new E.DiffChange(p,m-p+1,e,C-e+1)]);u=this.J(M-j,j,M,N),d=this.J(M+j,j,M,N);for(let J=u;J<=d;J+=2){J===u||J<d&&w[J-1]>=w[J+1]?s=w[J+1]-1:s=w[J-1],a=s-(J-M)-O;const r=s;for(;s>p&&a>e&&this.p(s,a);)s--,a--;if(w[J]=s,$&&Math.abs(J-v)<=j&&s<=b[J])return F[0]=s,y[0]=a,r>=b[J]&&1447>0&&j<=1447+1?this.x(v,i,o,I,M,u,d,O,b,w,s,m,F,a,C,y,$,L):null}if(j<=1447){let J=new Int32Array(o-i+2);J[0]=v-i+1,h.Copy2(b,i,J,1,o-i+1),this.k.push(J),J=new Int32Array(d-u+2),J[0]=M-u+1,h.Copy2(w,u,J,1,d-u+1),this.m.push(J)}}return this.x(v,i,o,I,M,u,d,O,b,w,s,m,F,a,C,y,$,L)}z(p){for(let m=0;m<p.length;m++){const e=p[m],C=m<p.length-1?p[m+1].originalStart:this.f.length,F=m<p.length-1?p[m+1].modifiedStart:this.h.length,y=e.originalLength>0,L=e.modifiedLength>0;for(;e.originalStart+e.originalLength<C&&e.modifiedStart+e.modifiedLength<F&&(!y||this.s(e.originalStart,e.originalStart+e.originalLength))&&(!L||this.u(e.modifiedStart,e.modifiedStart+e.modifiedLength));){const a=this.q(e.originalStart,e.modifiedStart);if(this.q(e.originalStart+e.originalLength,e.modifiedStart+e.modifiedLength)&&!a)break;e.originalStart++,e.modifiedStart++}const s=[null];if(m<p.length-1&&this.I(p[m],p[m+1],s)){p[m]=s[0],p.splice(m+1,1),m--;continue}}for(let m=p.length-1;m>=0;m--){const e=p[m];let C=0,F=0;if(m>0){const o=p[m-1];C=o.originalStart+o.originalLength,F=o.modifiedStart+o.modifiedLength}const y=e.originalLength>0,L=e.modifiedLength>0;let s=0,a=this.G(e.originalStart,e.originalLength,e.modifiedStart,e.modifiedLength);for(let o=1;;o++){const u=e.originalStart-o,d=e.modifiedStart-o;if(u<C||d<F||y&&!this.s(u,u+e.originalLength)||L&&!this.u(d,d+e.modifiedLength))break;const N=(u===C&&d===F?5:0)+this.G(u,e.originalLength,d,e.modifiedLength);N>a&&(a=N,s=o)}e.originalStart-=s,e.modifiedStart-=s;const i=[null];if(m>0&&this.I(p[m-1],p[m],i)){p[m-1]=i[0],p.splice(m,1),m++;continue}}if(this.d)for(let m=1,e=p.length;m<e;m++){const C=p[m-1],F=p[m],y=F.originalStart-C.originalStart-C.originalLength,L=C.originalStart,s=F.originalStart+F.originalLength,a=s-L,i=C.modifiedStart,o=F.modifiedStart+F.modifiedLength,u=o-i;if(y<5&&a<20&&u<20){const d=this.A(L,a,i,u,y);if(d){const[g,N]=d;(g!==C.originalStart+C.originalLength||N!==C.modifiedStart+C.modifiedLength)&&(C.originalLength=g-C.originalStart,C.modifiedLength=N-C.modifiedStart,F.originalStart=g+y,F.modifiedStart=N+y,F.originalLength=s-F.originalStart,F.modifiedLength=o-F.modifiedStart)}}}return p}A(p,m,e,C,F){if(m<F||C<F)return null;const y=p+m-F+1,L=e+C-F+1;let s=0,a=0,i=0;for(let o=p;o<y;o++)for(let u=e;u<L;u++){const d=this.B(o,u,F);d>0&&d>s&&(s=d,a=o,i=u)}return s>0?[a,i]:null}B(p,m,e){let C=0;for(let F=0;F<e;F++){if(!this.p(p+F,m+F))return 0;C+=this.e[p+F].length}return C}C(p){return p<=0||p>=this.f.length-1?!0:this.d&&/^\s*$/.test(this.e[p])}D(p,m){if(this.C(p)||this.C(p-1))return!0;if(m>0){const e=p+m;if(this.C(e-1)||this.C(e))return!0}return!1}E(p){return p<=0||p>=this.h.length-1?!0:this.d&&/^\s*$/.test(this.g[p])}F(p,m){if(this.E(p)||this.E(p-1))return!0;if(m>0){const e=p+m;if(this.E(e-1)||this.E(e))return!0}return!1}G(p,m,e,C){const F=this.D(p,m)?1:0,y=this.F(e,C)?1:0;return F+y}H(p,m){const e=[];if(p.length===0||m.length===0)return m.length>0?m:p;if(this.I(p[p.length-1],m[0],e)){const C=new Array(p.length+m.length-1);return h.Copy(p,0,C,0,p.length-1),C[p.length-1]=e[0],h.Copy(m,1,C,p.length,m.length-1),C}else{const C=new Array(p.length+m.length);return h.Copy(p,0,C,0,p.length),h.Copy(m,0,C,p.length,m.length),C}}I(p,m,e){if(_.Assert(p.originalStart<=m.originalStart,"Left change is not less than or equal to right change"),_.Assert(p.modifiedStart<=m.modifiedStart,"Left change is not less than or equal to right change"),p.originalStart+p.originalLength>=m.originalStart||p.modifiedStart+p.modifiedLength>=m.modifiedStart){const C=p.originalStart;let F=p.originalLength;const y=p.modifiedStart;let L=p.modifiedLength;return p.originalStart+p.originalLength>=m.originalStart&&(F=m.originalStart+m.originalLength-p.originalStart),p.modifiedStart+p.modifiedLength>=m.modifiedStart&&(L=m.modifiedStart+m.modifiedLength-p.modifiedStart),e[0]=new E.DiffChange(C,F,y,L),!0}else return e[0]=null,!1}J(p,m,e,C){if(p>=0&&p<C)return p;const F=e,y=C-e-1,L=m%2===0;if(p<0){const s=F%2===0;return L===s?0:1}else{const s=y%2===0;return L===s?C-1:C-2}}}n.LcsDiff=A}),Z(K[33],x([0,1]),function(B,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.withUndefinedAsNull=n.withNullAsUndefined=n.validateConstraint=n.validateConstraints=n.areFunctions=n.isFunction=n.isEmptyObject=n.assertAllDefined=n.assertIsDefined=n.assertType=n.isUndefinedOrNull=n.isDefined=n.isUndefined=n.isBoolean=n.isIterable=n.isNumber=n.isTypedArray=n.isObject=n.isStringArray=n.isString=void 0;function E(u){return typeof u=="string"}n.isString=E;function t(u){return Array.isArray(u)&&u.every(d=>E(d))}n.isStringArray=t;function D(u){return typeof u=="object"&&u!==null&&!Array.isArray(u)&&!(u instanceof RegExp)&&!(u instanceof Date)}n.isObject=D;function c(u){const d=Object.getPrototypeOf(Uint8Array);return typeof u=="object"&&u instanceof d}n.isTypedArray=c;function _(u){return typeof u=="number"&&!isNaN(u)}n.isNumber=_;function h(u){return!!u&&typeof u[Symbol.iterator]=="function"}n.isIterable=h;function l(u){return u===!0||u===!1}n.isBoolean=l;function f(u){return typeof u>"u"}n.isUndefined=f;function A(u){return!R(u)}n.isDefined=A;function R(u){return f(u)||u===null}n.isUndefinedOrNull=R;function p(u,d){if(!u)throw new Error(d?`Unexpected type, expected '${d}'`:"Unexpected type")}n.assertType=p;function m(u){if(R(u))throw new Error("Assertion Failed: argument is undefined or null");return u}n.assertIsDefined=m;function e(...u){const d=[];for(let g=0;g<u.length;g++){const N=u[g];if(R(N))throw new Error(`Assertion Failed: argument at index ${g} is undefined or null`);d.push(N)}return d}n.assertAllDefined=e;const C=Object.prototype.hasOwnProperty;function F(u){if(!D(u))return!1;for(const d in u)if(C.call(u,d))return!1;return!0}n.isEmptyObject=F;function y(u){return typeof u=="function"}n.isFunction=y;function L(...u){return u.length>0&&u.every(y)}n.areFunctions=L;function s(u,d){const g=Math.min(u.length,d.length);for(let N=0;N<g;N++)a(u[N],d[N])}n.validateConstraints=s;function a(u,d){if(E(d)){if(typeof u!==d)throw new Error(`argument does not match constraint: typeof ${d}`)}else if(y(d)){try{if(u instanceof d)return}catch{}if(!R(u)&&u.constructor===d||d.length===1&&d.call(void 0,u)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}n.validateConstraint=a;function i(u){return u===null?void 0:u}n.withNullAsUndefined=i;function o(u){return typeof u>"u"?null:u}n.withUndefinedAsNull=o}),Z(K[11],x([0,1,33]),function(B,n,E){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.createProxyObject=n.getAllMethodNames=n.getAllPropertyNames=n.filter=n.getCaseInsensitive=n.distinct=n.safeStringify=n.equals=n.mixin=n.cloneAndChange=n.deepFreeze=n.deepClone=void 0;function t(y){if(!y||typeof y!="object"||y instanceof RegExp)return y;const L=Array.isArray(y)?[]:{};return Object.entries(y).forEach(([s,a])=>{L[s]=a&&typeof a=="object"?t(a):a}),L}n.deepClone=t;function D(y){if(!y||typeof y!="object")return y;const L=[y];for(;L.length>0;){const s=L.shift();Object.freeze(s);for(const a in s)if(c.call(s,a)){const i=s[a];typeof i=="object"&&!Object.isFrozen(i)&&!(0,E.isTypedArray)(i)&&L.push(i)}}return y}n.deepFreeze=D;const c=Object.prototype.hasOwnProperty;function _(y,L){return h(y,L,new Set)}n.cloneAndChange=_;function h(y,L,s){if((0,E.isUndefinedOrNull)(y))return y;const a=L(y);if(typeof a<"u")return a;if(Array.isArray(y)){const i=[];for(const o of y)i.push(h(o,L,s));return i}if((0,E.isObject)(y)){if(s.has(y))throw new Error("Cannot clone recursive data-structure");s.add(y);const i={};for(const o in y)c.call(y,o)&&(i[o]=h(y[o],L,s));return s.delete(y),i}return y}function l(y,L,s=!0){return(0,E.isObject)(y)?((0,E.isObject)(L)&&Object.keys(L).forEach(a=>{a in y?s&&((0,E.isObject)(y[a])&&(0,E.isObject)(L[a])?l(y[a],L[a],s):y[a]=L[a]):y[a]=L[a]}),y):L}n.mixin=l;function f(y,L){if(y===L)return!0;if(y==null||L===null||L===void 0||typeof y!=typeof L||typeof y!="object"||Array.isArray(y)!==Array.isArray(L))return!1;let s,a;if(Array.isArray(y)){if(y.length!==L.length)return!1;for(s=0;s<y.length;s++)if(!f(y[s],L[s]))return!1}else{const i=[];for(a in y)i.push(a);i.sort();const o=[];for(a in L)o.push(a);if(o.sort(),!f(i,o))return!1;for(s=0;s<i.length;s++)if(!f(y[i[s]],L[i[s]]))return!1}return!0}n.equals=f;function A(y){const L=new Set;return JSON.stringify(y,(s,a)=>{if((0,E.isObject)(a)||Array.isArray(a)){if(L.has(a))return"[Circular]";L.add(a)}return a})}n.safeStringify=A;function R(y,L){const s=Object.create(null);return!y||!L||Object.keys(L).forEach(i=>{const o=y[i],u=L[i];f(o,u)||(s[i]=u)}),s}n.distinct=R;function p(y,L){const s=L.toLowerCase(),a=Object.keys(y).find(i=>i.toLowerCase()===s);return a?y[a]:y[L]}n.getCaseInsensitive=p;function m(y,L){const s=Object.create(null);for(const[a,i]of Object.entries(y))L(a,i)&&(s[a]=i);return s}n.filter=m;function e(y){let L=[],s=Object.getPrototypeOf(y);for(;Object.prototype!==s;)L=L.concat(Object.getOwnPropertyNames(s)),s=Object.getPrototypeOf(s);return L}n.getAllPropertyNames=e;function C(y){const L=[];for(const s of e(y))typeof y[s]=="function"&&L.push(s);return L}n.getAllMethodNames=C;function F(y,L){const s=i=>function(){const o=Array.prototype.slice.call(arguments,0);return L(i,o)},a={};for(const i of y)a[i]=s(i);return a}n.createProxyObject=F}),Z(K[19],x([0,1]),function(B,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.toUint32=n.toUint8=n.Constants=void 0;var E;(function(c){c[c.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",c[c.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",c[c.MAX_UINT_8=255]="MAX_UINT_8",c[c.MAX_UINT_16=65535]="MAX_UINT_16",c[c.MAX_UINT_32=4294967295]="MAX_UINT_32",c[c.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(E=n.Constants||(n.Constants={}));function t(c){return c<0?0:c>255?255:c|0}n.toUint8=t;function D(c){return c<0?0:c>4294967295?4294967295:c|0}n.toUint32=D}),Z(K[12],x([0,1,30,5]),function(B,n,E,t){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.uriToFsPath=n.URI=void 0;const D=/^\w[\w\d+.-]*$/,c=/^\//,_=/^\/\//;function h(d,g){if(!d.scheme&&g)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${d.authority}", path: "${d.path}", query: "${d.query}", fragment: "${d.fragment}"}`);if(d.scheme&&!D.test(d.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(d.path){if(d.authority){if(!c.test(d.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(_.test(d.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function l(d,g){return!d&&!g?"file":d}function f(d,g){switch(d){case"https":case"http":case"file":g?g[0]!==R&&(g=R+g):g=R;break}return g}const A="",R="/",p=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class m{static isUri(g){return g instanceof m?!0:g?typeof g.authority=="string"&&typeof g.fragment=="string"&&typeof g.path=="string"&&typeof g.query=="string"&&typeof g.scheme=="string"&&typeof g.fsPath=="string"&&typeof g.with=="function"&&typeof g.toString=="function":!1}constructor(g,N,b,w,v,M=!1){typeof g=="object"?(this.scheme=g.scheme||A,this.authority=g.authority||A,this.path=g.path||A,this.query=g.query||A,this.fragment=g.fragment||A):(this.scheme=l(g,M),this.authority=N||A,this.path=f(this.scheme,b||A),this.query=w||A,this.fragment=v||A,h(this,M))}get fsPath(){return s(this,!1)}with(g){if(!g)return this;let{scheme:N,authority:b,path:w,query:v,fragment:M}=g;return N===void 0?N=this.scheme:N===null&&(N=A),b===void 0?b=this.authority:b===null&&(b=A),w===void 0?w=this.path:w===null&&(w=A),v===void 0?v=this.query:v===null&&(v=A),M===void 0?M=this.fragment:M===null&&(M=A),N===this.scheme&&b===this.authority&&w===this.path&&v===this.query&&M===this.fragment?this:new C(N,b,w,v,M)}static parse(g,N=!1){const b=p.exec(g);return b?new C(b[2]||A,u(b[4]||A),u(b[5]||A),u(b[7]||A),u(b[9]||A),N):new C(A,A,A,A,A)}static file(g){let N=A;if(t.isWindows&&(g=g.replace(/\\/g,R)),g[0]===R&&g[1]===R){const b=g.indexOf(R,2);b===-1?(N=g.substring(2),g=R):(N=g.substring(2,b),g=g.substring(b)||R)}return new C("file",N,g,A,A)}static from(g){const N=new C(g.scheme,g.authority,g.path,g.query,g.fragment);return h(N,!0),N}static joinPath(g,...N){if(!g.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let b;return t.isWindows&&g.scheme==="file"?b=m.file(E.win32.join(s(g,!0),...N)).path:b=E.posix.join(g.path,...N),g.with({path:b})}toString(g=!1){return a(this,g)}toJSON(){return this}static revive(g){if(g){if(g instanceof m)return g;{const N=new C(g);return N._formatted=g.external,N._fsPath=g._sep===e?g.fsPath:null,N}}else return g}}n.URI=m;const e=t.isWindows?1:void 0;class C extends m{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=s(this,!1)),this._fsPath}toString(g=!1){return g?a(this,!0):(this._formatted||(this._formatted=a(this,!1)),this._formatted)}toJSON(){const g={$mid:1};return this._fsPath&&(g.fsPath=this._fsPath,g._sep=e),this._formatted&&(g.external=this._formatted),this.path&&(g.path=this.path),this.scheme&&(g.scheme=this.scheme),this.authority&&(g.authority=this.authority),this.query&&(g.query=this.query),this.fragment&&(g.fragment=this.fragment),g}}const F={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function y(d,g){let N,b=-1;for(let w=0;w<d.length;w++){const v=d.charCodeAt(w);if(v>=97&&v<=122||v>=65&&v<=90||v>=48&&v<=57||v===45||v===46||v===95||v===126||g&&v===47)b!==-1&&(N+=encodeURIComponent(d.substring(b,w)),b=-1),N!==void 0&&(N+=d.charAt(w));else{N===void 0&&(N=d.substr(0,w));const M=F[v];M!==void 0?(b!==-1&&(N+=encodeURIComponent(d.substring(b,w)),b=-1),N+=M):b===-1&&(b=w)}}return b!==-1&&(N+=encodeURIComponent(d.substring(b))),N!==void 0?N:d}function L(d){let g;for(let N=0;N<d.length;N++){const b=d.charCodeAt(N);b===35||b===63?(g===void 0&&(g=d.substr(0,N)),g+=F[b]):g!==void 0&&(g+=d[N])}return g!==void 0?g:d}function s(d,g){let N;return d.authority&&d.path.length>1&&d.scheme==="file"?N=`//${d.authority}${d.path}`:d.path.charCodeAt(0)===47&&(d.path.charCodeAt(1)>=65&&d.path.charCodeAt(1)<=90||d.path.charCodeAt(1)>=97&&d.path.charCodeAt(1)<=122)&&d.path.charCodeAt(2)===58?g?N=d.path.substr(1):N=d.path[1].toLowerCase()+d.path.substr(2):N=d.path,t.isWindows&&(N=N.replace(/\//g,"\\")),N}n.uriToFsPath=s;function a(d,g){const N=g?L:y;let b="",{scheme:w,authority:v,path:M,query:I,fragment:O}=d;if(w&&(b+=w,b+=":"),(v||w==="file")&&(b+=R,b+=R),v){let q=v.indexOf("@");if(q!==-1){const $=v.substr(0,q);v=v.substr(q+1),q=$.indexOf(":"),q===-1?b+=N($,!1):(b+=N($.substr(0,q),!1),b+=":",b+=N($.substr(q+1),!1)),b+="@"}v=v.toLowerCase(),q=v.indexOf(":"),q===-1?b+=N(v,!1):(b+=N(v.substr(0,q),!1),b+=v.substr(q))}if(M){if(M.length>=3&&M.charCodeAt(0)===47&&M.charCodeAt(2)===58){const q=M.charCodeAt(1);q>=65&&q<=90&&(M=`/${String.fromCharCode(q+32)}:${M.substr(3)}`)}else if(M.length>=2&&M.charCodeAt(1)===58){const q=M.charCodeAt(0);q>=65&&q<=90&&(M=`${String.fromCharCode(q+32)}:${M.substr(2)}`)}b+=N(M,!0)}return I&&(b+="?",b+=N(I,!1)),O&&(b+="#",b+=g?O:y(O,!1)),b}function i(d){try{return decodeURIComponent(d)}catch{return d.length>3?d.substr(0,3)+i(d.substr(3)):d}}const o=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function u(d){return d.match(o)?d.replace(o,g=>i(g)):d}}),Z(K[54],x([0,1,6,8,7,11,5,4]),function(B,n,E,t,D,c,_,h){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.create=n.SimpleWorkerServer=n.SimpleWorkerClient=n.logOnceWebWorkerWarning=void 0;const l="$initialize";let f=!1;function A(d){!_.isWeb||(f||(f=!0,console.warn("Could not create web worker(s). Falling back to loading web worker code in main thread, which might cause UI freezes. Please see https://github.com/microsoft/monaco-editor#faq")),console.warn(d.message))}n.logOnceWebWorkerWarning=A;var R;(function(d){d[d.Request=0]="Request",d[d.Reply=1]="Reply",d[d.SubscribeEvent=2]="SubscribeEvent",d[d.Event=3]="Event",d[d.UnsubscribeEvent=4]="UnsubscribeEvent"})(R||(R={}));class p{constructor(g,N,b,w){this.vsWorker=g,this.req=N,this.method=b,this.args=w,this.type=0}}class m{constructor(g,N,b,w){this.vsWorker=g,this.seq=N,this.res=b,this.err=w,this.type=1}}class e{constructor(g,N,b,w){this.vsWorker=g,this.req=N,this.eventName=b,this.arg=w,this.type=2}}class C{constructor(g,N,b){this.vsWorker=g,this.req=N,this.event=b,this.type=3}}class F{constructor(g,N){this.vsWorker=g,this.req=N,this.type=4}}class y{constructor(g){this.a=-1,this.g=g,this.b=0,this.c=Object.create(null),this.d=new Map,this.f=new Map}setWorkerId(g){this.a=g}sendMessage(g,N){const b=String(++this.b);return new Promise((w,v)=>{this.c[b]={resolve:w,reject:v},this.o(new p(this.a,b,g,N))})}listen(g,N){let b=null;const w=new t.Emitter({onWillAddFirstListener:()=>{b=String(++this.b),this.d.set(b,w),this.o(new e(this.a,b,g,N))},onDidRemoveLastListener:()=>{this.d.delete(b),this.o(new F(this.a,b)),b=null}});return w.event}handleMessage(g){!g||!g.vsWorker||this.a!==-1&&g.vsWorker!==this.a||this.h(g)}h(g){switch(g.type){case 1:return this.j(g);case 0:return this.k(g);case 2:return this.l(g);case 3:return this.m(g);case 4:return this.n(g)}}j(g){if(!this.c[g.seq]){console.warn("Got reply to unknown seq");return}const N=this.c[g.seq];if(delete this.c[g.seq],g.err){let b=g.err;g.err.$isError&&(b=new Error,b.name=g.err.name,b.message=g.err.message,b.stack=g.err.stack),N.reject(b);return}N.resolve(g.res)}k(g){const N=g.req;this.g.handleMessage(g.method,g.args).then(w=>{this.o(new m(this.a,N,w,void 0))},w=>{w.detail instanceof Error&&(w.detail=(0,E.transformErrorForSerialization)(w.detail)),this.o(new m(this.a,N,void 0,(0,E.transformErrorForSerialization)(w)))})}l(g){const N=g.req,b=this.g.handleEvent(g.eventName,g.arg)(w=>{this.o(new C(this.a,N,w))});this.f.set(N,b)}m(g){if(!this.d.has(g.req)){console.warn("Got event for unknown req");return}this.d.get(g.req).fire(g.event)}n(g){if(!this.f.has(g.req)){console.warn("Got unsubscribe for unknown req");return}this.f.get(g.req).dispose(),this.f.delete(g.req)}o(g){const N=[];if(g.type===0)for(let b=0;b<g.args.length;b++)g.args[b]instanceof ArrayBuffer&&N.push(g.args[b]);else g.type===1&&g.res instanceof ArrayBuffer&&N.push(g.res);this.g.sendMessage(g,N)}}class L extends D.Disposable{constructor(g,N,b){super();let w=null;this.a=this.B(g.create("vs/base/common/worker/simpleWorker",q=>{this.c.handleMessage(q)},q=>{w?.(q)})),this.c=new y({sendMessage:(q,$)=>{this.a.postMessage(q,$)},handleMessage:(q,$)=>{if(typeof b[q]!="function")return Promise.reject(new Error("Missing method "+q+" on main thread host."));try{return Promise.resolve(b[q].apply(b,$))}catch(j){return Promise.reject(j)}},handleEvent:(q,$)=>{if(a(q)){const j=b[q].call(b,$);if(typeof j!="function")throw new Error(`Missing dynamic event ${q} on main thread host.`);return j}if(s(q)){const j=b[q];if(typeof j!="function")throw new Error(`Missing event ${q} on main thread host.`);return j}throw new Error(`Malformed event name ${q}`)}}),this.c.setWorkerId(this.a.getId());let v=null;typeof _.globals.require<"u"&&typeof _.globals.require.getConfig=="function"?v=_.globals.require.getConfig():typeof _.globals.requirejs<"u"&&(v=_.globals.requirejs.s.contexts._.config);const M=(0,c.getAllMethodNames)(b);this.b=this.c.sendMessage(l,[this.a.getId(),JSON.parse(JSON.stringify(v)),N,M]);const I=(q,$)=>this.g(q,$),O=(q,$)=>this.c.listen(q,$);this.f=new Promise((q,$)=>{w=$,this.b.then(j=>{q(i(j,I,O))},j=>{$(j),this.h("Worker failed to load "+N,j)})})}getProxyObject(){return this.f}g(g,N){return new Promise((b,w)=>{this.b.then(()=>{this.c.sendMessage(g,N).then(b,w)},w)})}h(g,N){console.error(g),console.info(N)}}n.SimpleWorkerClient=L;function s(d){return d[0]==="o"&&d[1]==="n"&&h.isUpperAsciiLetter(d.charCodeAt(2))}function a(d){return/^onDynamic/.test(d)&&h.isUpperAsciiLetter(d.charCodeAt(9))}function i(d,g,N){const b=M=>function(){const I=Array.prototype.slice.call(arguments,0);return g(M,I)},w=M=>function(I){return N(M,I)},v={};for(const M of d){if(a(M)){v[M]=w(M);continue}if(s(M)){v[M]=N(M,void 0);continue}v[M]=b(M)}return v}class o{constructor(g,N){this.a=N,this.b=null,this.c=new y({sendMessage:(b,w)=>{g(b,w)},handleMessage:(b,w)=>this.d(b,w),handleEvent:(b,w)=>this.f(b,w)})}onmessage(g){this.c.handleMessage(g)}d(g,N){if(g===l)return this.g(N[0],N[1],N[2],N[3]);if(!this.b||typeof this.b[g]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+g));try{return Promise.resolve(this.b[g].apply(this.b,N))}catch(b){return Promise.reject(b)}}f(g,N){if(!this.b)throw new Error("Missing requestHandler");if(a(g)){const b=this.b[g].call(this.b,N);if(typeof b!="function")throw new Error(`Missing dynamic event ${g} on request handler.`);return b}if(s(g)){const b=this.b[g];if(typeof b!="function")throw new Error(`Missing event ${g} on request handler.`);return b}throw new Error(`Malformed event name ${g}`)}g(g,N,b,w){this.c.setWorkerId(g);const I=i(w,(O,q)=>this.c.sendMessage(O,q),(O,q)=>this.c.listen(O,q));return this.a?(this.b=this.a(I),Promise.resolve((0,c.getAllMethodNames)(this.b))):(N&&(typeof N.baseUrl<"u"&&delete N.baseUrl,typeof N.paths<"u"&&typeof N.paths.vs<"u"&&delete N.paths.vs,typeof N.trustedTypesPolicy!==void 0&&delete N.trustedTypesPolicy,N.catchError=!0,_.globals.require.config(N)),new Promise((O,q)=>{(_.globals.require||B)([b],j=>{if(this.b=j.create(I),!this.b){q(new Error("No RequestHandler!"));return}O((0,c.getAllMethodNames)(this.b))},q)}))}}n.SimpleWorkerServer=o;function u(d){return new o(d,null)}n.create=u}),Z(K[20],x([0,1,19]),function(B,n,E){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.CharacterSet=n.CharacterClassifier=void 0;class t{constructor(h){const l=(0,E.toUint8)(h);this.c=l,this.a=t.d(l),this.b=new Map}static d(h){const l=new Uint8Array(256);return l.fill(h),l}set(h,l){const f=(0,E.toUint8)(l);h>=0&&h<256?this.a[h]=f:this.b.set(h,f)}get(h){return h>=0&&h<256?this.a[h]:this.b.get(h)||this.c}clear(){this.a.fill(this.c),this.b.clear()}}n.CharacterClassifier=t;var D;(function(_){_[_.False=0]="False",_[_.True=1]="True"})(D||(D={}));class c{constructor(){this.a=new t(0)}add(h){this.a.set(h,1)}has(h){return this.a.get(h)===1}clear(){return this.a.clear()}}n.CharacterSet=c}),Z(K[3],x([0,1]),function(B,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Position=void 0;class E{constructor(D,c){this.lineNumber=D,this.column=c}with(D=this.lineNumber,c=this.column){return D===this.lineNumber&&c===this.column?this:new E(D,c)}delta(D=0,c=0){return this.with(this.lineNumber+D,this.column+c)}equals(D){return E.equals(this,D)}static equals(D,c){return!D&&!c?!0:!!D&&!!c&&D.lineNumber===c.lineNumber&&D.column===c.column}isBefore(D){return E.isBefore(this,D)}static isBefore(D,c){return D.lineNumber<c.lineNumber?!0:c.lineNumber<D.lineNumber?!1:D.column<c.column}isBeforeOrEqual(D){return E.isBeforeOrEqual(this,D)}static isBeforeOrEqual(D,c){return D.lineNumber<c.lineNumber?!0:c.lineNumber<D.lineNumber?!1:D.column<=c.column}static compare(D,c){const _=D.lineNumber|0,h=c.lineNumber|0;if(_===h){const l=D.column|0,f=c.column|0;return l-f}return _-h}clone(){return new E(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(D){return new E(D.lineNumber,D.column)}static isIPosition(D){return D&&typeof D.lineNumber=="number"&&typeof D.column=="number"}}n.Position=E}),Z(K[2],x([0,1,3]),function(B,n,E){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Range=void 0;class t{constructor(c,_,h,l){c>h||c===h&&_>l?(this.startLineNumber=h,this.startColumn=l,this.endLineNumber=c,this.endColumn=_):(this.startLineNumber=c,this.startColumn=_,this.endLineNumber=h,this.endColumn=l)}isEmpty(){return t.isEmpty(this)}static isEmpty(c){return c.startLineNumber===c.endLineNumber&&c.startColumn===c.endColumn}containsPosition(c){return t.containsPosition(this,c)}static containsPosition(c,_){return!(_.lineNumber<c.startLineNumber||_.lineNumber>c.endLineNumber||_.lineNumber===c.startLineNumber&&_.column<c.startColumn||_.lineNumber===c.endLineNumber&&_.column>c.endColumn)}static strictContainsPosition(c,_){return!(_.lineNumber<c.startLineNumber||_.lineNumber>c.endLineNumber||_.lineNumber===c.startLineNumber&&_.column<=c.startColumn||_.lineNumber===c.endLineNumber&&_.column>=c.endColumn)}containsRange(c){return t.containsRange(this,c)}static containsRange(c,_){return!(_.startLineNumber<c.startLineNumber||_.endLineNumber<c.startLineNumber||_.startLineNumber>c.endLineNumber||_.endLineNumber>c.endLineNumber||_.startLineNumber===c.startLineNumber&&_.startColumn<c.startColumn||_.endLineNumber===c.endLineNumber&&_.endColumn>c.endColumn)}strictContainsRange(c){return t.strictContainsRange(this,c)}static strictContainsRange(c,_){return!(_.startLineNumber<c.startLineNumber||_.endLineNumber<c.startLineNumber||_.startLineNumber>c.endLineNumber||_.endLineNumber>c.endLineNumber||_.startLineNumber===c.startLineNumber&&_.startColumn<=c.startColumn||_.endLineNumber===c.endLineNumber&&_.endColumn>=c.endColumn)}plusRange(c){return t.plusRange(this,c)}static plusRange(c,_){let h,l,f,A;return _.startLineNumber<c.startLineNumber?(h=_.startLineNumber,l=_.startColumn):_.startLineNumber===c.startLineNumber?(h=_.startLineNumber,l=Math.min(_.startColumn,c.startColumn)):(h=c.startLineNumber,l=c.startColumn),_.endLineNumber>c.endLineNumber?(f=_.endLineNumber,A=_.endColumn):_.endLineNumber===c.endLineNumber?(f=_.endLineNumber,A=Math.max(_.endColumn,c.endColumn)):(f=c.endLineNumber,A=c.endColumn),new t(h,l,f,A)}intersectRanges(c){return t.intersectRanges(this,c)}static intersectRanges(c,_){let h=c.startLineNumber,l=c.startColumn,f=c.endLineNumber,A=c.endColumn;const R=_.startLineNumber,p=_.startColumn,m=_.endLineNumber,e=_.endColumn;return h<R?(h=R,l=p):h===R&&(l=Math.max(l,p)),f>m?(f=m,A=e):f===m&&(A=Math.min(A,e)),h>f||h===f&&l>A?null:new t(h,l,f,A)}equalsRange(c){return t.equalsRange(this,c)}static equalsRange(c,_){return!c&&!_?!0:!!c&&!!_&&c.startLineNumber===_.startLineNumber&&c.startColumn===_.startColumn&&c.endLineNumber===_.endLineNumber&&c.endColumn===_.endColumn}getEndPosition(){return t.getEndPosition(this)}static getEndPosition(c){return new E.Position(c.endLineNumber,c.endColumn)}getStartPosition(){return t.getStartPosition(this)}static getStartPosition(c){return new E.Position(c.startLineNumber,c.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(c,_){return new t(this.startLineNumber,this.startColumn,c,_)}setStartPosition(c,_){return new t(c,_,this.endLineNumber,this.endColumn)}collapseToStart(){return t.collapseToStart(this)}delta(c){return new t(this.startLineNumber+c,this.startColumn,this.endLineNumber+c,this.endColumn)}static collapseToStart(c){return new t(c.startLineNumber,c.startColumn,c.startLineNumber,c.startColumn)}static fromPositions(c,_=c){return new t(c.lineNumber,c.column,_.lineNumber,_.column)}static lift(c){return c?new t(c.startLineNumber,c.startColumn,c.endLineNumber,c.endColumn):null}static isIRange(c){return c&&typeof c.startLineNumber=="number"&&typeof c.startColumn=="number"&&typeof c.endLineNumber=="number"&&typeof c.endColumn=="number"}static areIntersectingOrTouching(c,_){return!(c.endLineNumber<_.startLineNumber||c.endLineNumber===_.startLineNumber&&c.endColumn<_.startColumn||_.endLineNumber<c.startLineNumber||_.endLineNumber===c.startLineNumber&&_.endColumn<c.startColumn)}static areIntersecting(c,_){return!(c.endLineNumber<_.startLineNumber||c.endLineNumber===_.startLineNumber&&c.endColumn<=_.startColumn||_.endLineNumber<c.startLineNumber||_.endLineNumber===c.startLineNumber&&_.endColumn<=c.startColumn)}static compareRangesUsingStarts(c,_){if(c&&_){const f=c.startLineNumber|0,A=_.startLineNumber|0;if(f===A){const R=c.startColumn|0,p=_.startColumn|0;if(R===p){const m=c.endLineNumber|0,e=_.endLineNumber|0;if(m===e){const C=c.endColumn|0,F=_.endColumn|0;return C-F}return m-e}return R-p}return f-A}return(c?1:0)-(_?1:0)}static compareRangesUsingEnds(c,_){return c.endLineNumber===_.endLineNumber?c.endColumn===_.endColumn?c.startLineNumber===_.startLineNumber?c.startColumn-_.startColumn:c.startLineNumber-_.startLineNumber:c.endColumn-_.endColumn:c.endLineNumber-_.endLineNumber}static spansMultipleLines(c){return c.endLineNumber>c.startLineNumber}toJSON(){return this}}n.Range=t}),Z(K[34],x([0,1,3,2]),function(B,n,E,t){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Selection=n.SelectionDirection=void 0;var D;(function(_){_[_.LTR=0]="LTR",_[_.RTL=1]="RTL"})(D=n.SelectionDirection||(n.SelectionDirection={}));class c extends t.Range{constructor(h,l,f,A){super(h,l,f,A),this.selectionStartLineNumber=h,this.selectionStartColumn=l,this.positionLineNumber=f,this.positionColumn=A}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(h){return c.selectionsEqual(this,h)}static selectionsEqual(h,l){return h.selectionStartLineNumber===l.selectionStartLineNumber&&h.selectionStartColumn===l.selectionStartColumn&&h.positionLineNumber===l.positionLineNumber&&h.positionColumn===l.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(h,l){return this.getDirection()===0?new c(this.startLineNumber,this.startColumn,h,l):new c(h,l,this.startLineNumber,this.startColumn)}getPosition(){return new E.Position(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new E.Position(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(h,l){return this.getDirection()===0?new c(h,l,this.endLineNumber,this.endColumn):new c(this.endLineNumber,this.endColumn,h,l)}static fromPositions(h,l=h){return new c(h.lineNumber,h.column,l.lineNumber,l.column)}static fromRange(h,l){return l===0?new c(h.startLineNumber,h.startColumn,h.endLineNumber,h.endColumn):new c(h.endLineNumber,h.endColumn,h.startLineNumber,h.startColumn)}static liftSelection(h){return new c(h.selectionStartLineNumber,h.selectionStartColumn,h.positionLineNumber,h.positionColumn)}static selectionsArrEqual(h,l){if(h&&!l||!h&&l)return!1;if(!h&&!l)return!0;if(h.length!==l.length)return!1;for(let f=0,A=h.length;f<A;f++)if(!this.selectionsEqual(h[f],l[f]))return!1;return!0}static isISelection(h){return h&&typeof h.selectionStartLineNumber=="number"&&typeof h.selectionStartColumn=="number"&&typeof h.positionLineNumber=="number"&&typeof h.positionColumn=="number"}static createWithDirection(h,l,f,A,R){return R===0?new c(h,l,f,A):new c(f,A,h,l)}}n.Selection=c}),Z(K[35],x([0,1,20]),function(B,n,E){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.getMapForWordSeparators=n.WordCharacterClassifier=n.WordCharacterClass=void 0;var t;(function(_){_[_.Regular=0]="Regular",_[_.Whitespace=1]="Whitespace",_[_.WordSeparator=2]="WordSeparator"})(t=n.WordCharacterClass||(n.WordCharacterClass={}));class D extends E.CharacterClassifier{constructor(h){super(0);for(let l=0,f=h.length;l<f;l++)this.set(h.charCodeAt(l),2);this.set(32,1),this.set(9,1)}}n.WordCharacterClassifier=D;function c(_){const h={};return l=>(h.hasOwnProperty(l)||(h[l]=_(l)),h[l])}n.getMapForWordSeparators=c(_=>new D(_))}),Z(K[21],x([0,1,14,7,15]),function(B,n,E,t,D){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.getWordAtText=n.setDefaultGetWordAtTextConfig=n.ensureValidWordDefinition=n.DEFAULT_WORD_REGEXP=n.USUAL_WORD_SEPARATORS=void 0,n.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function c(R=""){let p="(-?\\d*\\.\\d\\w*)|([^";for(const m of n.USUAL_WORD_SEPARATORS)R.indexOf(m)>=0||(p+="\\"+m);return p+="\\s]+)",new RegExp(p,"g")}n.DEFAULT_WORD_REGEXP=c();function _(R){let p=n.DEFAULT_WORD_REGEXP;if(R&&R instanceof RegExp)if(R.global)p=R;else{let m="g";R.ignoreCase&&(m+="i"),R.multiline&&(m+="m"),R.unicode&&(m+="u"),p=new RegExp(R.source,m)}return p.lastIndex=0,p}n.ensureValidWordDefinition=_;const h=new D.LinkedList;h.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function l(R){const p=h.unshift(R);return(0,t.toDisposable)(p)}n.setDefaultGetWordAtTextConfig=l;function f(R,p,m,e,C){if(C||(C=E.Iterable.first(h)),m.length>C.maxLen){let a=R-C.maxLen/2;return a<0?a=0:e+=a,m=m.substring(a,R+C.maxLen/2),f(R,p,m,e,C)}const F=Date.now(),y=R-1-e;let L=-1,s=null;for(let a=1;!(Date.now()-F>=C.timeBudget);a++){const i=y-C.windowSize*a;p.lastIndex=Math.max(0,i);const o=A(p,m,y,L);if(!o&&s||(s=o,i<=0))break;L=i}if(s){const a={word:s[0],startColumn:e+1+s.index,endColumn:e+1+s.index+s[0].length};return p.lastIndex=0,a}return null}n.getWordAtText=f;function A(R,p,m,e){let C;for(;C=R.exec(p);){const F=C.index||0;if(F<=m&&R.lastIndex>=m)return C;if(e>0&&F>e)return null}return null}}),Z(K[9],x([0,1]),function(B,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.OffsetRange=n.SequenceDiff=void 0;class E{constructor(c,_){this.seq1Range=c,this.seq2Range=_}reverse(){return new E(this.seq2Range,this.seq1Range)}toString(){return`${this.seq1Range} <-> ${this.seq2Range}`}}n.SequenceDiff=E;class t{constructor(c,_){this.start=c,this.endExclusive=_}get isEmpty(){return this.start===this.endExclusive}delta(c){return new t(this.start+c,this.endExclusive+c)}get length(){return this.endExclusive-this.start}toString(){return`[${this.start}, ${this.endExclusive})`}}n.OffsetRange=t}),Z(K[36],x([0,1,9]),function(B,n,E){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.shiftSequenceDiffs=n.joinSequenceDiffs=n.optimizeSequenceDiffs=void 0;function t(h,l,f){let A=f;return A=D(h,l,A),A=c(h,l,A),A}n.optimizeSequenceDiffs=t;function D(h,l,f){const A=[];f.length>0&&A.push(f[0]);for(let R=1;R<f.length;R++){const p=A[A.length-1],m=f[R];if(m.seq1Range.isEmpty){let e=!0;const C=m.seq1Range.start-p.seq1Range.endExclusive;for(let F=1;F<=C;F++)if(l.getElement(m.seq2Range.start-F)!==l.getElement(m.seq2Range.endExclusive-F)){e=!1;break}if(e){A[A.length-1]=new E.SequenceDiff(p.seq1Range,new E.OffsetRange(p.seq2Range.start,m.seq2Range.endExclusive-C));continue}}A.push(m)}return A}n.joinSequenceDiffs=D;function c(h,l,f){if(!h.getBoundaryScore||!l.getBoundaryScore)return f;for(let A=0;A<f.length;A++){const R=f[A];if(R.seq1Range.isEmpty){const p=A>0?f[A-1].seq2Range.endExclusive:-1,m=A+1<f.length?f[A+1].seq2Range.start:l.length;f[A]=_(R,h,l,m,p)}else if(R.seq2Range.isEmpty){const p=A>0?f[A-1].seq1Range.endExclusive:-1,m=A+1<f.length?f[A+1].seq1Range.start:h.length;f[A]=_(R.reverse(),l,h,m,p).reverse()}}return f}n.shiftSequenceDiffs=c;function _(h,l,f,A,R){let m=1;for(;h.seq2Range.start-m>R&&f.getElement(h.seq2Range.start-m)===f.getElement(h.seq2Range.endExclusive-m)&&m<20;)m++;m--;let e=0;for(;h.seq2Range.start+e<A&&f.getElement(h.seq2Range.start+e)===f.getElement(h.seq2Range.endExclusive+e)&&e<20;)e++;if(m===0&&e===0)return h;let C=0,F=-1;for(let y=-m;y<=e;y++){const L=h.seq2Range.start+y,s=h.seq2Range.endExclusive+y,a=h.seq1Range.start+y,i=l.getBoundaryScore(a)+f.getBoundaryScore(L)+f.getBoundaryScore(s);i>F&&(F=i,C=y)}return C!==0?new E.SequenceDiff(h.seq1Range.delta(C),h.seq2Range.delta(C)):h}}),Z(K[37],x([0,1,9]),function(B,n,E){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.MyersDiffAlgorithm=void 0;class t{compute(l,f){if(l.length===0)return[new E.SequenceDiff(new E.OffsetRange(0,0),new E.OffsetRange(0,f.length))];if(f.length===0)return[new E.SequenceDiff(new E.OffsetRange(0,l.length),new E.OffsetRange(0,0))];function A(s,a){for(;s<l.length&&a<f.length&&l.getElement(s)===f.getElement(a);)s++,a++;return s}let R=0;const p=new c;p.set(0,A(0,0));const m=new _;m.set(0,p.get(0)===0?null:new D(null,0,0,p.get(0)));let e=0;e:for(;;)for(R++,e=-R;e<=R;e+=2){const s=e===R?-1:p.get(e+1),a=e===-R?-1:p.get(e-1)+1,i=Math.min(Math.max(s,a),l.length),o=i-e,u=A(i,o);p.set(e,u);const d=i===s?m.get(e+1):m.get(e-1);if(m.set(e,u!==i?new D(d,i,o,u-i):d),p.get(e)===l.length&&p.get(e)-e===f.length)break e}let C=m.get(e);const F=[];let y=l.length,L=f.length;for(;;){const s=C?C.x+C.length:0,a=C?C.y+C.length:0;if((s!==y||a!==L)&&F.push(new E.SequenceDiff(new E.OffsetRange(s,y),new E.OffsetRange(a,L))),!C)break;y=C.x,L=C.y,C=C.prev}return F.reverse(),F}}n.MyersDiffAlgorithm=t;class D{constructor(l,f,A,R){this.prev=l,this.x=f,this.y=A,this.length=R}}class c{constructor(){this.a=new Int32Array(10),this.b=new Int32Array(10)}get(l){return l<0?(l=-l-1,this.b[l]):this.a[l]}set(l,f){if(l<0){if(l=-l-1,l>=this.b.length){const A=this.b;this.b=new Int32Array(A.length*2),this.b.set(A)}this.b[l]=f}else{if(l>=this.a.length){const A=this.a;this.a=new Int32Array(A.length*2),this.a.set(A)}this.a[l]=f}}}class _{constructor(){this.a=[],this.b=[]}get(l){return l<0?(l=-l-1,this.b[l]):this.a[l]}set(l,f){l<0?(l=-l-1,this.b[l]=f):this.a[l]=f}}}),Z(K[38],x([0,1]),function(B,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Array2D=void 0;class E{constructor(D,c){this.width=D,this.height=c,this.a=[],this.a=new Array(D*c)}get(D,c){return this.a[D+c*this.width]}set(D,c,_){this.a[D+c*this.width]=_}}n.Array2D=E}),Z(K[39],x([0,1,9,38]),function(B,n,E,t){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.DynamicProgrammingDiffing=void 0;class D{compute(_,h,l){const f=new t.Array2D(_.length,h.length),A=new t.Array2D(_.length,h.length),R=new t.Array2D(_.length,h.length);for(let L=0;L<_.length;L++)for(let s=0;s<h.length;s++){const a=L===0?0:f.get(L-1,s),i=s===0?0:f.get(L,s-1);let o;_.getElement(L)===h.getElement(s)?(L===0||s===0?o=0:o=f.get(L-1,s-1),L>0&&s>0&&A.get(L-1,s-1)===3&&(o+=.1),o+=l?l(L,s):1):o=-1;const u=Math.max(a,i,o);if(u===o){const d=L>0&&s>0?R.get(L-1,s-1):0;R.set(L,s,d+1),A.set(L,s,3)}else u===a?(R.set(L,s,0),A.set(L,s,1)):u===i&&(R.set(L,s,0),A.set(L,s,2));f.set(L,s,u)}const p=[];let m=_.length,e=h.length;function C(L,s){(L+1!==m||s+1!==e)&&p.push(new E.SequenceDiff(new E.OffsetRange(L+1,m),new E.OffsetRange(s+1,e))),m=L,e=s}let F=_.length-1,y=h.length-1;for(;F>=0&&y>=0;)A.get(F,y)===3?(C(F,y),F--,y--):A.get(F,y)===1?F--:y--;return C(-1,-1),p.reverse(),p}}n.DynamicProgrammingDiffing=D}),Z(K[22],x([0,1]),function(B,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.LineRange=n.RangeMapping=n.LineRangeMapping=void 0;class E{constructor(_,h,l){this.originalRange=_,this.modifiedRange=h,this.innerChanges=l}toString(){return`{${this.originalRange.toString()}->${this.modifiedRange.toString()}}`}}n.LineRangeMapping=E;class t{constructor(_,h){this.originalRange=_,this.modifiedRange=h}toString(){return`{${this.originalRange.toString()}->${this.modifiedRange.toString()}}`}}n.RangeMapping=t;class D{constructor(_,h){this.startLineNumber=_,this.endLineNumberExclusive=h}get isEmpty(){return this.startLineNumber===this.endLineNumberExclusive}delta(_){return new D(this.startLineNumber+_,this.endLineNumberExclusive+_)}get length(){return this.endLineNumberExclusive-this.startLineNumber}join(_){return new D(Math.min(this.startLineNumber,_.startLineNumber),Math.max(this.endLineNumberExclusive,_.endLineNumberExclusive))}toString(){return`[${this.startLineNumber},${this.endLineNumberExclusive})`}}n.LineRange=D}),Z(K[23],x([0,1,18,22,4,2,10]),function(B,n,E,t,D,c,_){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.DiffComputer=n.SmartLinesDiffComputer=void 0;const h=3;class l{computeDiff(a,i,o){const d=new C(a,i,{maxComputationTime:o.maxComputationTimeMs,shouldIgnoreTrimWhitespace:o.ignoreTrimWhitespace,shouldComputeCharChanges:!0,shouldMakePrettyDiff:!0,shouldPostProcessCharChanges:!0}).computeDiff(),g=[];let N=null;for(const b of d.changes){let w;b.originalEndLineNumber===0?w=new t.LineRange(b.originalStartLineNumber+1,b.originalStartLineNumber+1):w=new t.LineRange(b.originalStartLineNumber,b.originalEndLineNumber+1);let v;b.modifiedEndLineNumber===0?v=new t.LineRange(b.modifiedStartLineNumber+1,b.modifiedStartLineNumber+1):v=new t.LineRange(b.modifiedStartLineNumber,b.modifiedEndLineNumber+1);let M=new t.LineRangeMapping(w,v,b.charChanges?.map(I=>new t.RangeMapping(new c.Range(I.originalStartLineNumber,I.originalStartColumn,I.originalEndLineNumber,I.originalEndColumn),new c.Range(I.modifiedStartLineNumber,I.modifiedStartColumn,I.modifiedEndLineNumber,I.modifiedEndColumn))));N&&(N.modifiedRange.endLineNumberExclusive===M.modifiedRange.startLineNumber||N.originalRange.endLineNumberExclusive===M.originalRange.startLineNumber)&&(M=new t.LineRangeMapping(N.originalRange.join(M.originalRange),N.modifiedRange.join(M.modifiedRange),N.innerChanges&&M.innerChanges?N.innerChanges.concat(M.innerChanges):void 0),g.pop()),g.push(M),N=M}return(0,_.assertFn)(()=>(0,_.checkAdjacentItems)(g,(b,w)=>w.originalRange.startLineNumber-b.originalRange.endLineNumberExclusive===w.modifiedRange.startLineNumber-b.modifiedRange.endLineNumberExclusive&&b.originalRange.endLineNumberExclusive<w.originalRange.startLineNumber&&b.modifiedRange.endLineNumberExclusive<w.modifiedRange.startLineNumber)),{quitEarly:d.quitEarly,changes:g}}}n.SmartLinesDiffComputer=l;function f(s,a,i,o){return new E.LcsDiff(s,a,i).ComputeDiff(o)}class A{constructor(a){const i=[],o=[];for(let u=0,d=a.length;u<d;u++)i[u]=F(a[u],1),o[u]=y(a[u],1);this.lines=a,this.a=i,this.b=o}getElements(){const a=[];for(let i=0,o=this.lines.length;i<o;i++)a[i]=this.lines[i].substring(this.a[i]-1,this.b[i]-1);return a}getStrictElement(a){return this.lines[a]}getStartLineNumber(a){return a+1}getEndLineNumber(a){return a+1}createCharSequence(a,i,o){const u=[],d=[],g=[];let N=0;for(let b=i;b<=o;b++){const w=this.lines[b],v=a?this.a[b]:1,M=a?this.b[b]:w.length+1;for(let I=v;I<M;I++)u[N]=w.charCodeAt(I-1),d[N]=b+1,g[N]=I,N++;!a&&b<o&&(u[N]=10,d[N]=b+1,g[N]=w.length+1,N++)}return new R(u,d,g)}}class R{constructor(a,i,o){this.a=a,this.b=i,this.d=o}toString(){return"["+this.a.map((a,i)=>(a===10?"\\n":String.fromCharCode(a))+`-(${this.b[i]},${this.d[i]})`).join(", ")+"]"}e(a,i){if(a<0||a>=i.length)throw new Error("Illegal index")}getElements(){return this.a}getStartLineNumber(a){return a>0&&a===this.b.length?this.getEndLineNumber(a-1):(this.e(a,this.b),this.b[a])}getEndLineNumber(a){return a===-1?this.getStartLineNumber(a+1):(this.e(a,this.b),this.a[a]===10?this.b[a]+1:this.b[a])}getStartColumn(a){return a>0&&a===this.d.length?this.getEndColumn(a-1):(this.e(a,this.d),this.d[a])}getEndColumn(a){return a===-1?this.getStartColumn(a+1):(this.e(a,this.d),this.a[a]===10?1:this.d[a]+1)}}class p{constructor(a,i,o,u,d,g,N,b){this.originalStartLineNumber=a,this.originalStartColumn=i,this.originalEndLineNumber=o,this.originalEndColumn=u,this.modifiedStartLineNumber=d,this.modifiedStartColumn=g,this.modifiedEndLineNumber=N,this.modifiedEndColumn=b}static createFromDiffChange(a,i,o){const u=i.getStartLineNumber(a.originalStart),d=i.getStartColumn(a.originalStart),g=i.getEndLineNumber(a.originalStart+a.originalLength-1),N=i.getEndColumn(a.originalStart+a.originalLength-1),b=o.getStartLineNumber(a.modifiedStart),w=o.getStartColumn(a.modifiedStart),v=o.getEndLineNumber(a.modifiedStart+a.modifiedLength-1),M=o.getEndColumn(a.modifiedStart+a.modifiedLength-1);return new p(u,d,g,N,b,w,v,M)}}function m(s){if(s.length<=1)return s;const a=[s[0]];let i=a[0];for(let o=1,u=s.length;o<u;o++){const d=s[o],g=d.originalStart-(i.originalStart+i.originalLength),N=d.modifiedStart-(i.modifiedStart+i.modifiedLength);Math.min(g,N)<h?(i.originalLength=d.originalStart+d.originalLength-i.originalStart,i.modifiedLength=d.modifiedStart+d.modifiedLength-i.modifiedStart):(a.push(d),i=d)}return a}class e{constructor(a,i,o,u,d){this.originalStartLineNumber=a,this.originalEndLineNumber=i,this.modifiedStartLineNumber=o,this.modifiedEndLineNumber=u,this.charChanges=d}static createFromDiffResult(a,i,o,u,d,g,N){let b,w,v,M,I;if(i.originalLength===0?(b=o.getStartLineNumber(i.originalStart)-1,w=0):(b=o.getStartLineNumber(i.originalStart),w=o.getEndLineNumber(i.originalStart+i.originalLength-1)),i.modifiedLength===0?(v=u.getStartLineNumber(i.modifiedStart)-1,M=0):(v=u.getStartLineNumber(i.modifiedStart),M=u.getEndLineNumber(i.modifiedStart+i.modifiedLength-1)),g&&i.originalLength>0&&i.originalLength<20&&i.modifiedLength>0&&i.modifiedLength<20&&d()){const O=o.createCharSequence(a,i.originalStart,i.originalStart+i.originalLength-1),q=u.createCharSequence(a,i.modifiedStart,i.modifiedStart+i.modifiedLength-1);if(O.getElements().length>0&&q.getElements().length>0){let $=f(O,q,d,!0).changes;N&&($=m($)),I=[];for(let j=0,ne=$.length;j<ne;j++)I.push(p.createFromDiffChange($[j],O,q))}}return new e(b,w,v,M,I)}}class C{constructor(a,i,o){this.a=o.shouldComputeCharChanges,this.b=o.shouldPostProcessCharChanges,this.d=o.shouldIgnoreTrimWhitespace,this.e=o.shouldMakePrettyDiff,this.f=a,this.g=i,this.h=new A(a),this.j=new A(i),this.k=L(o.maxComputationTime),this.l=L(o.maxComputationTime===0?0:Math.min(o.maxComputationTime,5e3))}computeDiff(){if(this.h.lines.length===1&&this.h.lines[0].length===0)return this.j.lines.length===1&&this.j.lines[0].length===0?{quitEarly:!1,changes:[]}:{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:1,modifiedStartLineNumber:1,modifiedEndLineNumber:this.j.lines.length,charChanges:void 0}]};if(this.j.lines.length===1&&this.j.lines[0].length===0)return{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:this.h.lines.length,modifiedStartLineNumber:1,modifiedEndLineNumber:1,charChanges:void 0}]};const a=f(this.h,this.j,this.k,this.e),i=a.changes,o=a.quitEarly;if(this.d){const N=[];for(let b=0,w=i.length;b<w;b++)N.push(e.createFromDiffResult(this.d,i[b],this.h,this.j,this.l,this.a,this.b));return{quitEarly:o,changes:N}}const u=[];let d=0,g=0;for(let N=-1,b=i.length;N<b;N++){const w=N+1<b?i[N+1]:null,v=w?w.originalStart:this.f.length,M=w?w.modifiedStart:this.g.length;for(;d<v&&g<M;){const I=this.f[d],O=this.g[g];if(I!==O){{let q=F(I,1),$=F(O,1);for(;q>1&&$>1;){const j=I.charCodeAt(q-2),ne=O.charCodeAt($-2);if(j!==ne)break;q--,$--}(q>1||$>1)&&this.m(u,d+1,1,q,g+1,1,$)}{let q=y(I,1),$=y(O,1);const j=I.length+1,ne=O.length+1;for(;q<j&&$<ne;){const te=I.charCodeAt(q-1),Q=I.charCodeAt($-1);if(te!==Q)break;q++,$++}(q<j||$<ne)&&this.m(u,d+1,q,j,g+1,$,ne)}}d++,g++}w&&(u.push(e.createFromDiffResult(this.d,w,this.h,this.j,this.l,this.a,this.b)),d+=w.originalLength,g+=w.modifiedLength)}return{quitEarly:o,changes:u}}m(a,i,o,u,d,g,N){if(this.n(a,i,o,u,d,g,N))return;let b;this.a&&(b=[new p(i,o,i,u,d,g,d,N)]),a.push(new e(i,i,d,d,b))}n(a,i,o,u,d,g,N){const b=a.length;if(b===0)return!1;const w=a[b-1];return w.originalEndLineNumber===0||w.modifiedEndLineNumber===0?!1:w.originalEndLineNumber+1===i&&w.modifiedEndLineNumber+1===d?(w.originalEndLineNumber=i,w.modifiedEndLineNumber=d,this.a&&w.charChanges&&w.charChanges.push(new p(i,o,i,u,d,g,d,N)),!0):!1}}n.DiffComputer=C;function F(s,a){const i=D.firstNonWhitespaceIndex(s);return i===-1?a:i+1}function y(s,a){const i=D.lastNonWhitespaceIndex(s);return i===-1?a:i+2}function L(s){if(s===0)return()=>!0;const a=Date.now();return()=>Date.now()-a<s}}),Z(K[40],x([0,1,10,3,2,9,39,36,37,22]),function(B,n,E,t,D,c,_,h,l,f){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.LineSequence=n.lineRangeMappingFromRangeMappings=n.StandardLinesDiffComputer=void 0;class A{constructor(){this.b=new _.DynamicProgrammingDiffing,this.c=new l.MyersDiffAlgorithm}computeDiff(o,u,d){const g=new Map;function N(te){let Q=g.get(te);return Q===void 0&&(Q=g.size,g.set(te,Q)),Q}const b=o.map(te=>N(te.trim())),w=u.map(te=>N(te.trim())),v=new m(b,o),M=new m(w,u);let I=(()=>v.length+M.length<1500?this.b.compute(v,M,(te,Q)=>o[te]===u[Q]?u[Q].length===0?.1:1+Math.log(1+u[Q].length):.99):this.c.compute(v,M))();I=(0,h.optimizeSequenceDiffs)(v,M,I);const O=[],q=te=>{for(let Q=0;Q<te;Q++){const J=$+Q,r=j+Q;if(o[J]!==u[r]){const ve=this.f(o,u,new c.SequenceDiff(new c.OffsetRange(J,J+1),new c.OffsetRange(r,r+1)));for(const Ae of ve)O.push(Ae)}}};let $=0,j=0;for(const te of I){(0,E.assertFn)(()=>te.seq1Range.start-$===te.seq2Range.start-j);const Q=te.seq1Range.start-$;q(Q),$=te.seq1Range.endExclusive,j=te.seq2Range.endExclusive;const J=this.f(o,u,te);for(const r of J)O.push(r)}q(o.length-$);const ne=R(O);return{quitEarly:!1,changes:ne}}f(o,u,d){const g=new C(o,d.seq1Range),N=new C(u,d.seq2Range),b=g.length+N.length<500?this.b.compute(g,N):this.c.compute(g,N);return(0,h.optimizeSequenceDiffs)(g,N,b).map(M=>new f.RangeMapping(g.translateRange(M.seq1Range).delta(d.seq1Range.start),N.translateRange(M.seq2Range).delta(d.seq2Range.start)))}}n.StandardLinesDiffComputer=A;function R(i){const o=[];for(const u of p(i,(d,g)=>g.originalRange.startLineNumber-(d.originalRange.endLineNumber-(d.originalRange.endColumn>1?0:1))<=1||g.modifiedRange.startLineNumber-(d.modifiedRange.endLineNumber-(d.modifiedRange.endColumn>1?0:1))<=1)){const d=u[0],g=u[u.length-1];o.push(new f.LineRangeMapping(new f.LineRange(d.originalRange.startLineNumber,g.originalRange.endLineNumber+(g.originalRange.endColumn>1||g.modifiedRange.endColumn>1?1:0)),new f.LineRange(d.modifiedRange.startLineNumber,g.modifiedRange.endLineNumber+(g.originalRange.endColumn>1||g.modifiedRange.endColumn>1?1:0)),u))}return(0,E.assertFn)(()=>(0,E.checkAdjacentItems)(o,(u,d)=>d.originalRange.startLineNumber-u.originalRange.endLineNumberExclusive===d.modifiedRange.startLineNumber-u.modifiedRange.endLineNumberExclusive&&u.originalRange.endLineNumberExclusive<d.originalRange.startLineNumber&&u.modifiedRange.endLineNumberExclusive<d.modifiedRange.startLineNumber)),o}n.lineRangeMappingFromRangeMappings=R;function*p(i,o){let u,d;for(const g of i)d!==void 0&&o(d,g)?u.push(g):(u&&(yield u),u=[g]),d=g;u&&(yield u)}class m{constructor(o,u){this.b=o,this.c=u}getElement(o){return this.b[o]}get length(){return this.b.length}getBoundaryScore(o){const u=o===0?0:e(this.c[o-1]),d=o===this.c.length?0:e(this.c[o]);return 1e3-(u+d)}}n.LineSequence=m;function e(i){let o=0;for(;o<i.length&&(i.charCodeAt(o)===32||i.charCodeAt(o)===9);)o++;return o}class C{constructor(o,u){this.lines=o,this.lineRange=u;let d=0;this.c=new Int32Array(u.length);for(let N=u.start;N<u.endExclusive;N++)d+=o[N].length,this.c[N-u.start]=d+1,d++;this.b=new Int32Array(d);let g=0;for(let N=u.start;N<u.endExclusive;N++){const b=o[N];for(let w=0;w<b.length;w++)this.b[g+w]=b.charCodeAt(w);g+=b.length,N<o.length-1&&(this.b[g]=`
`.charCodeAt(0),g+=1)}}get text(){return[...this.b].map(o=>String.fromCharCode(o)).join("")}getElement(o){return this.b[o]}get length(){return this.b.length}getBoundaryScore(o){const u=s(o>0?this.b[o-1]:-1),d=s(o<this.b.length?this.b[o]:-1);if(u===6&&d===7)return 0;let g=0;return u!==d&&(g+=10,d===1&&(g+=1)),g+=L(u),g+=L(d),g}translateOffset(o){let u=0,d=this.c.length;for(;u<d;){const N=Math.floor((u+d)/2);this.c[N]>o?d=N:u=N+1}const g=u===0?0:this.c[u-1];return new t.Position(u+1,o-g+1)}translateRange(o){return D.Range.fromPositions(this.translateOffset(o.start),this.translateOffset(o.endExclusive))}}var F;(function(i){i[i.WordLower=0]="WordLower",i[i.WordUpper=1]="WordUpper",i[i.WordNumber=2]="WordNumber",i[i.End=3]="End",i[i.Other=4]="Other",i[i.Space=5]="Space",i[i.LineBreakCR=6]="LineBreakCR",i[i.LineBreakLF=7]="LineBreakLF"})(F||(F={}));const y={[0]:0,[1]:0,[2]:0,[3]:10,[4]:2,[5]:3,[6]:10,[7]:10};function L(i){return y[i]}function s(i){return i===10?7:i===13?6:a(i)?5:i>=97&&i<=122?0:i>=65&&i<=90?1:i>=48&&i<=57?2:i===-1?3:4}function a(i){return i===32||i===9}}),Z(K[41],x([0,1,23,40]),function(B,n,E,t){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.linesDiffComputers=void 0,n.linesDiffComputers={smart:new E.SmartLinesDiffComputer,experimental:new t.StandardLinesDiffComputer}}),Z(K[42],x([0,1,20]),function(B,n,E){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.computeLinks=n.LinkComputer=n.StateMachine=n.State=void 0;var t;(function(m){m[m.Invalid=0]="Invalid",m[m.Start=1]="Start",m[m.H=2]="H",m[m.HT=3]="HT",m[m.HTT=4]="HTT",m[m.HTTP=5]="HTTP",m[m.F=6]="F",m[m.FI=7]="FI",m[m.FIL=8]="FIL",m[m.BeforeColon=9]="BeforeColon",m[m.AfterColon=10]="AfterColon",m[m.AlmostThere=11]="AlmostThere",m[m.End=12]="End",m[m.Accept=13]="Accept",m[m.LastKnownState=14]="LastKnownState"})(t=n.State||(n.State={}));class D{constructor(e,C,F){const y=new Uint8Array(e*C);for(let L=0,s=e*C;L<s;L++)y[L]=F;this.a=y,this.rows=e,this.cols=C}get(e,C){return this.a[e*this.cols+C]}set(e,C,F){this.a[e*this.cols+C]=F}}class c{constructor(e){let C=0,F=0;for(let L=0,s=e.length;L<s;L++){const[a,i,o]=e[L];i>C&&(C=i),a>F&&(F=a),o>F&&(F=o)}C++,F++;const y=new D(F,C,0);for(let L=0,s=e.length;L<s;L++){const[a,i,o]=e[L];y.set(a,i,o)}this.a=y,this.b=C}nextState(e,C){return C<0||C>=this.b?0:this.a.get(e,C)}}n.StateMachine=c;let _=null;function h(){return _===null&&(_=new c([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),_}var l;(function(m){m[m.None=0]="None",m[m.ForceTermination=1]="ForceTermination",m[m.CannotEndIn=2]="CannotEndIn"})(l||(l={}));let f=null;function A(){if(f===null){f=new E.CharacterClassifier(0);const m=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let C=0;C<m.length;C++)f.set(m.charCodeAt(C),1);const e=".,;:";for(let C=0;C<e.length;C++)f.set(e.charCodeAt(C),2)}return f}class R{static a(e,C,F,y,L){let s=L-1;do{const a=C.charCodeAt(s);if(e.get(a)!==2)break;s--}while(s>y);if(y>0){const a=C.charCodeAt(y-1),i=C.charCodeAt(s);(a===40&&i===41||a===91&&i===93||a===123&&i===125)&&s--}return{range:{startLineNumber:F,startColumn:y+1,endLineNumber:F,endColumn:s+2},url:C.substring(y,s+1)}}static computeLinks(e,C=h()){const F=A(),y=[];for(let L=1,s=e.getLineCount();L<=s;L++){const a=e.getLineContent(L),i=a.length;let o=0,u=0,d=0,g=1,N=!1,b=!1,w=!1,v=!1;for(;o<i;){let M=!1;const I=a.charCodeAt(o);if(g===13){let O;switch(I){case 40:N=!0,O=0;break;case 41:O=N?0:1;break;case 91:w=!0,b=!0,O=0;break;case 93:w=!1,O=b?0:1;break;case 123:v=!0,O=0;break;case 125:O=v?0:1;break;case 39:case 34:case 96:d===I?O=1:d===39||d===34||d===96?O=0:O=1;break;case 42:O=d===42?1:0;break;case 124:O=d===124?1:0;break;case 32:O=w?0:1;break;default:O=F.get(I)}O===1&&(y.push(R.a(F,a,L,u,o)),M=!0)}else if(g===12){let O;I===91?(b=!0,O=0):O=F.get(I),O===1?M=!0:g=13}else g=C.nextState(g,I),g===0&&(M=!0);M&&(g=1,N=!1,b=!1,v=!1,u=o+1,d=I),o++}g===13&&y.push(R.a(F,a,L,u,i))}return y}}n.LinkComputer=R;function p(m){return!m||typeof m.getLineCount!="function"||typeof m.getLineContent!="function"?[]:R.computeLinks(m)}n.computeLinks=p}),Z(K[43],x([0,1]),function(B,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.BasicInplaceReplace=void 0;class E{constructor(){this.c=[["true","false"],["True","False"],["Private","Public","Friend","ReadOnly","Partial","Protected","WriteOnly"],["public","protected","private"]]}navigateValueSet(D,c,_,h,l){if(D&&c){const f=this.a(c,l);if(f)return{range:D,value:f}}if(_&&h){const f=this.a(h,l);if(f)return{range:_,value:f}}return null}a(D,c){const _=this.b(D,c);return _!==null?_:this.d(D,c)}b(D,c){const _=Math.pow(10,D.length-(D.lastIndexOf(".")+1));let h=Number(D);const l=parseFloat(D);return!isNaN(h)&&!isNaN(l)&&h===l?h===0&&!c?null:(h=Math.floor(h*_),h+=c?_:-_,String(h/_)):null}d(D,c){return this.e(this.c,D,c)}e(D,c,_){let h=null;for(let l=0,f=D.length;h===null&&l<f;l++)h=this.f(D[l],c,_);return h}f(D,c,_){let h=D.indexOf(c);return h>=0?(h+=_?1:-1,h<0?h=D.length-1:h%=D.length,D[h]):null}}n.BasicInplaceReplace=E,E.INSTANCE=new E}),Z(K[44],x([0,1,11]),function(B,n,E){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.shouldSynchronizeModel=n.ApplyEditsResult=n.SearchData=n.ValidAnnotatedEditOperation=n.ModelConstants=n.PositionAffinity=n.isITextSnapshot=n.TrackedRangeStickiness=n.FindMatch=n.TextModelResolvedOptions=n.EndOfLineSequence=n.DefaultEndOfLine=n.EndOfLinePreference=n.InjectedTextCursorStops=n.MinimapPosition=n.OverviewRulerLane=void 0;var t;(function(s){s[s.Left=1]="Left",s[s.Center=2]="Center",s[s.Right=4]="Right",s[s.Full=7]="Full"})(t=n.OverviewRulerLane||(n.OverviewRulerLane={}));var D;(function(s){s[s.Inline=1]="Inline",s[s.Gutter=2]="Gutter"})(D=n.MinimapPosition||(n.MinimapPosition={}));var c;(function(s){s[s.Both=0]="Both",s[s.Right=1]="Right",s[s.Left=2]="Left",s[s.None=3]="None"})(c=n.InjectedTextCursorStops||(n.InjectedTextCursorStops={}));var _;(function(s){s[s.TextDefined=0]="TextDefined",s[s.LF=1]="LF",s[s.CRLF=2]="CRLF"})(_=n.EndOfLinePreference||(n.EndOfLinePreference={}));var h;(function(s){s[s.LF=1]="LF",s[s.CRLF=2]="CRLF"})(h=n.DefaultEndOfLine||(n.DefaultEndOfLine={}));var l;(function(s){s[s.LF=0]="LF",s[s.CRLF=1]="CRLF"})(l=n.EndOfLineSequence||(n.EndOfLineSequence={}));class f{constructor(a){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,a.tabSize|0),this.indentSize=Math.max(1,a.indentSize|0),this.insertSpaces=Boolean(a.insertSpaces),this.defaultEOL=a.defaultEOL|0,this.trimAutoWhitespace=Boolean(a.trimAutoWhitespace),this.bracketPairColorizationOptions=a.bracketPairColorizationOptions}equals(a){return this.tabSize===a.tabSize&&this.indentSize===a.indentSize&&this.insertSpaces===a.insertSpaces&&this.defaultEOL===a.defaultEOL&&this.trimAutoWhitespace===a.trimAutoWhitespace&&(0,E.equals)(this.bracketPairColorizationOptions,a.bracketPairColorizationOptions)}createChangeEvent(a){return{tabSize:this.tabSize!==a.tabSize,indentSize:this.indentSize!==a.indentSize,insertSpaces:this.insertSpaces!==a.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==a.trimAutoWhitespace}}}n.TextModelResolvedOptions=f;class A{constructor(a,i){this._findMatchBrand=void 0,this.range=a,this.matches=i}}n.FindMatch=A;var R;(function(s){s[s.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",s[s.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",s[s.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",s[s.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(R=n.TrackedRangeStickiness||(n.TrackedRangeStickiness={}));function p(s){return s&&typeof s.read=="function"}n.isITextSnapshot=p;var m;(function(s){s[s.Left=0]="Left",s[s.Right=1]="Right",s[s.None=2]="None",s[s.LeftOfInjectedText=3]="LeftOfInjectedText",s[s.RightOfInjectedText=4]="RightOfInjectedText"})(m=n.PositionAffinity||(n.PositionAffinity={}));var e;(function(s){s[s.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(e=n.ModelConstants||(n.ModelConstants={}));class C{constructor(a,i,o,u,d,g){this.identifier=a,this.range=i,this.text=o,this.forceMoveMarkers=u,this.isAutoWhitespaceEdit=d,this._isTracked=g}}n.ValidAnnotatedEditOperation=C;class F{constructor(a,i,o){this.regex=a,this.wordSeparators=i,this.simpleSearch=o}}n.SearchData=F;class y{constructor(a,i,o){this.reverseEdits=a,this.changes=i,this.trimAutoWhitespaceLineNumbers=o}}n.ApplyEditsResult=y;function L(s){return!s.isTooLargeForSyncing()&&!s.isForSimpleWidget}n.shouldSynchronizeModel=L}),Z(K[45],x([0,1,26,19]),function(B,n,E,t){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.PrefixSumIndexOfResult=n.ConstantTimePrefixSumComputer=n.PrefixSumComputer=void 0;class D{constructor(l){this.a=l,this.b=new Uint32Array(l.length),this.c=new Int32Array(1),this.c[0]=-1}getCount(){return this.a.length}insertValues(l,f){l=(0,t.toUint32)(l);const A=this.a,R=this.b,p=f.length;return p===0?!1:(this.a=new Uint32Array(A.length+p),this.a.set(A.subarray(0,l),0),this.a.set(A.subarray(l),l+p),this.a.set(f,l),l-1<this.c[0]&&(this.c[0]=l-1),this.b=new Uint32Array(this.a.length),this.c[0]>=0&&this.b.set(R.subarray(0,this.c[0]+1)),!0)}setValue(l,f){return l=(0,t.toUint32)(l),f=(0,t.toUint32)(f),this.a[l]===f?!1:(this.a[l]=f,l-1<this.c[0]&&(this.c[0]=l-1),!0)}removeValues(l,f){l=(0,t.toUint32)(l),f=(0,t.toUint32)(f);const A=this.a,R=this.b;if(l>=A.length)return!1;const p=A.length-l;return f>=p&&(f=p),f===0?!1:(this.a=new Uint32Array(A.length-f),this.a.set(A.subarray(0,l),0),this.a.set(A.subarray(l+f),l),this.b=new Uint32Array(this.a.length),l-1<this.c[0]&&(this.c[0]=l-1),this.c[0]>=0&&this.b.set(R.subarray(0,this.c[0]+1)),!0)}getTotalSum(){return this.a.length===0?0:this.d(this.a.length-1)}getPrefixSum(l){return l<0?0:(l=(0,t.toUint32)(l),this.d(l))}d(l){if(l<=this.c[0])return this.b[l];let f=this.c[0]+1;f===0&&(this.b[0]=this.a[0],f++),l>=this.a.length&&(l=this.a.length-1);for(let A=f;A<=l;A++)this.b[A]=this.b[A-1]+this.a[A];return this.c[0]=Math.max(this.c[0],l),this.b[l]}getIndexOf(l){l=Math.floor(l),this.getTotalSum();let f=0,A=this.a.length-1,R=0,p=0,m=0;for(;f<=A;)if(R=f+(A-f)/2|0,p=this.b[R],m=p-this.a[R],l<m)A=R-1;else if(l>=p)f=R+1;else break;return new _(R,l-m)}}n.PrefixSumComputer=D;class c{constructor(l){this.a=l,this.b=!1,this.c=-1,this.d=[],this.e=[]}getTotalSum(){return this.g(),this.e.length}getPrefixSum(l){return this.g(),l===0?0:this.d[l-1]}getIndexOf(l){this.g();const f=this.e[l],A=f>0?this.d[f-1]:0;return new _(f,l-A)}removeValues(l,f){this.a.splice(l,f),this.f(l)}insertValues(l,f){this.a=(0,E.arrayInsert)(this.a,l,f),this.f(l)}f(l){this.b=!1,this.c=Math.min(this.c,l-1)}g(){if(!this.b){for(let l=this.c+1,f=this.a.length;l<f;l++){const A=this.a[l],R=l>0?this.d[l-1]:0;this.d[l]=R+A;for(let p=0;p<A;p++)this.e[R+p]=l}this.d.length=this.a.length,this.e.length=this.d[this.d.length-1],this.b=!0,this.c=this.a.length-1}}setValue(l,f){this.a[l]!==f&&(this.a[l]=f,this.f(l))}}n.ConstantTimePrefixSumComputer=c;class _{constructor(l,f){this.index=l,this.remainder=f,this._prefixSumIndexOfResultBrand=void 0,this.index=l,this.remainder=f}}n.PrefixSumIndexOfResult=_}),Z(K[46],x([0,1,4,3,45]),function(B,n,E,t,D){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.MirrorTextModel=void 0;class c{constructor(h,l,f,A){this.c=h,this.d=l,this.f=f,this.g=A,this.h=null,this.j=null}dispose(){this.d.length=0}get version(){return this.g}getText(){return this.j===null&&(this.j=this.d.join(this.f)),this.j}onEvents(h){h.eol&&h.eol!==this.f&&(this.f=h.eol,this.h=null);const l=h.changes;for(const f of l)this.n(f.range),this.o(new t.Position(f.range.startLineNumber,f.range.startColumn),f.text);this.g=h.versionId,this.j=null}k(){if(!this.h){const h=this.f.length,l=this.d.length,f=new Uint32Array(l);for(let A=0;A<l;A++)f[A]=this.d[A].length+h;this.h=new D.PrefixSumComputer(f)}}l(h,l){this.d[h]=l,this.h&&this.h.setValue(h,this.d[h].length+this.f.length)}n(h){if(h.startLineNumber===h.endLineNumber){if(h.startColumn===h.endColumn)return;this.l(h.startLineNumber-1,this.d[h.startLineNumber-1].substring(0,h.startColumn-1)+this.d[h.startLineNumber-1].substring(h.endColumn-1));return}this.l(h.startLineNumber-1,this.d[h.startLineNumber-1].substring(0,h.startColumn-1)+this.d[h.endLineNumber-1].substring(h.endColumn-1)),this.d.splice(h.startLineNumber,h.endLineNumber-h.startLineNumber),this.h&&this.h.removeValues(h.startLineNumber,h.endLineNumber-h.startLineNumber)}o(h,l){if(l.length===0)return;const f=(0,E.splitLines)(l);if(f.length===1){this.l(h.lineNumber-1,this.d[h.lineNumber-1].substring(0,h.column-1)+f[0]+this.d[h.lineNumber-1].substring(h.column-1));return}f[f.length-1]+=this.d[h.lineNumber-1].substring(h.column-1),this.l(h.lineNumber-1,this.d[h.lineNumber-1].substring(0,h.column-1)+f[0]);const A=new Uint32Array(f.length-1);for(let R=1;R<f.length;R++)this.d.splice(h.lineNumber+R-1,0,f[R]),A[R-1]=f[R].length+this.f.length;this.h&&this.h.insertValues(h.lineNumber,A)}}n.MirrorTextModel=c}),Z(K[47],x([0,1,4,35,3,2,44]),function(B,n,E,t,D,c,_){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Searcher=n.isValidMatch=n.TextModelSearch=n.createFindMatch=n.isMultilineRegexSource=n.SearchParams=void 0;const h=999;class l{constructor(L,s,a,i){this.searchString=L,this.isRegex=s,this.matchCase=a,this.wordSeparators=i}parseSearchRequest(){if(this.searchString==="")return null;let L;this.isRegex?L=f(this.searchString):L=this.searchString.indexOf(`
`)>=0;let s=null;try{s=E.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:L,global:!0,unicode:!0})}catch{return null}if(!s)return null;let a=!this.isRegex&&!L;return a&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(a=this.matchCase),new _.SearchData(s,this.wordSeparators?(0,t.getMapForWordSeparators)(this.wordSeparators):null,a?this.searchString:null)}}n.SearchParams=l;function f(y){if(!y||y.length===0)return!1;for(let L=0,s=y.length;L<s;L++){const a=y.charCodeAt(L);if(a===10)return!0;if(a===92){if(L++,L>=s)break;const i=y.charCodeAt(L);if(i===110||i===114||i===87)return!0}}return!1}n.isMultilineRegexSource=f;function A(y,L,s){if(!s)return new _.FindMatch(y,null);const a=[];for(let i=0,o=L.length;i<o;i++)a[i]=L[i];return new _.FindMatch(y,a)}n.createFindMatch=A;class R{constructor(L){const s=[];let a=0;for(let i=0,o=L.length;i<o;i++)L.charCodeAt(i)===10&&(s[a++]=i);this.a=s}findLineFeedCountBeforeOffset(L){const s=this.a;let a=0,i=s.length-1;if(i===-1||L<=s[0])return 0;for(;a<i;){const o=a+((i-a)/2>>0);s[o]>=L?i=o-1:s[o+1]>=L?(a=o,i=o):a=o+1}return a+1}}class p{static findMatches(L,s,a,i,o){const u=s.parseSearchRequest();return u?u.regex.multiline?this.b(L,a,new F(u.wordSeparators,u.regex),i,o):this.c(L,a,u,i,o):[]}static a(L,s,a,i,o,u){let d,g=0;i?(g=i.findLineFeedCountBeforeOffset(o),d=s+o+g):d=s+o;let N;if(i){const M=i.findLineFeedCountBeforeOffset(o+u.length)-g;N=d+u.length+M}else N=d+u.length;const b=L.getPositionAt(d),w=L.getPositionAt(N);return new c.Range(b.lineNumber,b.column,w.lineNumber,w.column)}static b(L,s,a,i,o){const u=L.getOffsetAt(s.getStartPosition()),d=L.getValueInRange(s,1),g=L.getEOL()===`\r
`?new R(d):null,N=[];let b=0,w;for(a.reset(0);w=a.next(d);)if(N[b++]=A(this.a(L,u,d,g,w.index,w[0]),w,i),b>=o)return N;return N}static c(L,s,a,i,o){const u=[];let d=0;if(s.startLineNumber===s.endLineNumber){const N=L.getLineContent(s.startLineNumber).substring(s.startColumn-1,s.endColumn-1);return d=this.d(a,N,s.startLineNumber,s.startColumn-1,d,u,i,o),u}const g=L.getLineContent(s.startLineNumber).substring(s.startColumn-1);d=this.d(a,g,s.startLineNumber,s.startColumn-1,d,u,i,o);for(let N=s.startLineNumber+1;N<s.endLineNumber&&d<o;N++)d=this.d(a,L.getLineContent(N),N,0,d,u,i,o);if(d<o){const N=L.getLineContent(s.endLineNumber).substring(0,s.endColumn-1);d=this.d(a,N,s.endLineNumber,0,d,u,i,o)}return u}static d(L,s,a,i,o,u,d,g){const N=L.wordSeparators;if(!d&&L.simpleSearch){const v=L.simpleSearch,M=v.length,I=s.length;let O=-M;for(;(O=s.indexOf(v,O+M))!==-1;)if((!N||C(N,s,I,O,M))&&(u[o++]=new _.FindMatch(new c.Range(a,O+1+i,a,O+1+M+i),null),o>=g))return o;return o}const b=new F(L.wordSeparators,L.regex);let w;b.reset(0);do if(w=b.next(s),w&&(u[o++]=A(new c.Range(a,w.index+1+i,a,w.index+1+w[0].length+i),w,d),o>=g))return o;while(w);return o}static findNextMatch(L,s,a,i){const o=s.parseSearchRequest();if(!o)return null;const u=new F(o.wordSeparators,o.regex);return o.regex.multiline?this.e(L,a,u,i):this.f(L,a,u,i)}static e(L,s,a,i){const o=new D.Position(s.lineNumber,1),u=L.getOffsetAt(o),d=L.getLineCount(),g=L.getValueInRange(new c.Range(o.lineNumber,o.column,d,L.getLineMaxColumn(d)),1),N=L.getEOL()===`\r
`?new R(g):null;a.reset(s.column-1);const b=a.next(g);return b?A(this.a(L,u,g,N,b.index,b[0]),b,i):s.lineNumber!==1||s.column!==1?this.e(L,new D.Position(1,1),a,i):null}static f(L,s,a,i){const o=L.getLineCount(),u=s.lineNumber,d=L.getLineContent(u),g=this.g(a,d,u,s.column,i);if(g)return g;for(let N=1;N<=o;N++){const b=(u+N-1)%o,w=L.getLineContent(b+1),v=this.g(a,w,b+1,1,i);if(v)return v}return null}static g(L,s,a,i,o){L.reset(i-1);const u=L.next(s);return u?A(new c.Range(a,u.index+1,a,u.index+1+u[0].length),u,o):null}static findPreviousMatch(L,s,a,i){const o=s.parseSearchRequest();if(!o)return null;const u=new F(o.wordSeparators,o.regex);return o.regex.multiline?this.h(L,a,u,i):this.j(L,a,u,i)}static h(L,s,a,i){const o=this.b(L,new c.Range(1,1,s.lineNumber,s.column),a,i,10*h);if(o.length>0)return o[o.length-1];const u=L.getLineCount();return s.lineNumber!==u||s.column!==L.getLineMaxColumn(u)?this.h(L,new D.Position(u,L.getLineMaxColumn(u)),a,i):null}static j(L,s,a,i){const o=L.getLineCount(),u=s.lineNumber,d=L.getLineContent(u).substring(0,s.column-1),g=this.k(a,d,u,i);if(g)return g;for(let N=1;N<=o;N++){const b=(o+u-N-1)%o,w=L.getLineContent(b+1),v=this.k(a,w,b+1,i);if(v)return v}return null}static k(L,s,a,i){let o=null,u;for(L.reset(0);u=L.next(s);)o=A(new c.Range(a,u.index+1,a,u.index+1+u[0].length),u,i);return o}}n.TextModelSearch=p;function m(y,L,s,a,i){if(a===0)return!0;const o=L.charCodeAt(a-1);if(y.get(o)!==0||o===13||o===10)return!0;if(i>0){const u=L.charCodeAt(a);if(y.get(u)!==0)return!0}return!1}function e(y,L,s,a,i){if(a+i===s)return!0;const o=L.charCodeAt(a+i);if(y.get(o)!==0||o===13||o===10)return!0;if(i>0){const u=L.charCodeAt(a+i-1);if(y.get(u)!==0)return!0}return!1}function C(y,L,s,a,i){return m(y,L,s,a,i)&&e(y,L,s,a,i)}n.isValidMatch=C;class F{constructor(L,s){this._wordSeparators=L,this.a=s,this.b=-1,this.c=0}reset(L){this.a.lastIndex=L,this.b=-1,this.c=0}next(L){const s=L.length;let a;do{if(this.b+this.c===s||(a=this.a.exec(L),!a))return null;const i=a.index,o=a[0].length;if(i===this.b&&o===this.c){if(o===0){E.getNextCodePoint(L,s,this.a.lastIndex)>65535?this.a.lastIndex+=2:this.a.lastIndex+=1;continue}return null}if(this.b=i,this.c=o,!this._wordSeparators||C(this._wordSeparators,L,s,i,o))return a}while(a);return null}}n.Searcher=F}),Z(K[48],x([0,1,2,47,4,10,21]),function(B,n,E,t,D,c,_){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.UnicodeHighlighterReasonKind=n.UnicodeTextModelHighlighter=void 0;class h{static computeUnicodeHighlights(e,C,F){const y=F?F.startLineNumber:1,L=F?F.endLineNumber:e.getLineCount(),s=new A(C),a=s.getCandidateCodePoints();let i;a==="allNonBasicAscii"?i=new RegExp("[^\\t\\n\\r\\x20-\\x7E]","g"):i=new RegExp(`${l(Array.from(a))}`,"g");const o=new t.Searcher(null,i),u=[];let d=!1,g,N=0,b=0,w=0;e:for(let v=y,M=L;v<=M;v++){const I=e.getLineContent(v),O=I.length;o.reset(0);do if(g=o.next(I),g){let q=g.index,$=g.index+g[0].length;if(q>0){const Q=I.charCodeAt(q-1);D.isHighSurrogate(Q)&&q--}if($+1<O){const Q=I.charCodeAt($-1);D.isHighSurrogate(Q)&&$++}const j=I.substring(q,$),ne=(0,_.getWordAtText)(q+1,_.DEFAULT_WORD_REGEXP,I,0),te=s.shouldHighlightNonBasicASCII(j,ne?ne.word:null);if(te!==0){te===3?N++:te===2?b++:te===1?w++:(0,c.assertNever)(te);const Q=1e3;if(u.length>=Q){d=!0;break e}u.push(new E.Range(v,q+1,v,$+1))}}while(g)}return{ranges:u,hasMore:d,ambiguousCharacterCount:N,invisibleCharacterCount:b,nonBasicAsciiCharacterCount:w}}static computeUnicodeHighlightReason(e,C){const F=new A(C);switch(F.shouldHighlightNonBasicASCII(e,null)){case 0:return null;case 2:return{kind:1};case 3:{const L=e.codePointAt(0),s=F.ambiguousCharacters.getPrimaryConfusable(L),a=D.AmbiguousCharacters.getLocales().filter(i=>!D.AmbiguousCharacters.getInstance(new Set([...C.allowedLocales,i])).isAmbiguous(L));return{kind:0,confusableWith:String.fromCodePoint(s),notAmbiguousInLocales:a}}case 1:return{kind:2}}}}n.UnicodeTextModelHighlighter=h;function l(m,e){return`[${D.escapeRegExpCharacters(m.map(F=>String.fromCodePoint(F)).join(""))}]`}var f;(function(m){m[m.Ambiguous=0]="Ambiguous",m[m.Invisible=1]="Invisible",m[m.NonBasicAscii=2]="NonBasicAscii"})(f=n.UnicodeHighlighterReasonKind||(n.UnicodeHighlighterReasonKind={}));class A{constructor(e){this.b=e,this.a=new Set(e.allowedCodePoints),this.ambiguousCharacters=D.AmbiguousCharacters.getInstance(new Set(e.allowedLocales))}getCandidateCodePoints(){if(this.b.nonBasicASCII)return"allNonBasicAscii";const e=new Set;if(this.b.invisibleCharacters)for(const C of D.InvisibleCharacters.codePoints)R(String.fromCodePoint(C))||e.add(C);if(this.b.ambiguousCharacters)for(const C of this.ambiguousCharacters.getConfusableCodePoints())e.add(C);for(const C of this.a)e.delete(C);return e}shouldHighlightNonBasicASCII(e,C){const F=e.codePointAt(0);if(this.a.has(F))return 0;if(this.b.nonBasicASCII)return 1;let y=!1,L=!1;if(C)for(const s of C){const a=s.codePointAt(0),i=D.isBasicASCII(s);y=y||i,!i&&!this.ambiguousCharacters.isAmbiguous(a)&&!D.InvisibleCharacters.isInvisibleCharacter(a)&&(L=!0)}return!y&&L?0:this.b.invisibleCharacters&&!R(e)&&D.InvisibleCharacters.isInvisibleCharacter(F)?2:this.b.ambiguousCharacters&&this.ambiguousCharacters.isAmbiguous(F)?3:0}}function R(m){return m===" "||m===`
`||m==="	"}var p;(function(m){m[m.None=0]="None",m[m.NonBasicASCII=1]="NonBasicASCII",m[m.Invisible=2]="Invisible",m[m.Ambiguous=3]="Ambiguous"})(p||(p={}))}),Z(K[49],x([0,1]),function(B,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.WrappingIndent=n.TrackedRangeStickiness=n.TextEditorCursorStyle=n.TextEditorCursorBlinkingStyle=n.SymbolTag=n.SymbolKind=n.SignatureHelpTriggerKind=n.SelectionDirection=n.ScrollbarVisibility=n.ScrollType=n.RenderMinimap=n.RenderLineNumbersType=n.PositionAffinity=n.OverviewRulerLane=n.OverlayWidgetPositionPreference=n.MouseTargetType=n.MinimapPosition=n.MarkerTag=n.MarkerSeverity=n.KeyCode=n.InlineCompletionTriggerKind=n.InlayHintKind=n.InjectedTextCursorStops=n.IndentAction=n.EndOfLineSequence=n.EndOfLinePreference=n.EditorOption=n.EditorAutoIndentStrategy=n.DocumentHighlightKind=n.DefaultEndOfLine=n.CursorChangeReason=n.ContentWidgetPositionPreference=n.CompletionTriggerKind=n.CompletionItemTag=n.CompletionItemKind=n.CompletionItemInsertTextRule=n.CodeActionTriggerType=n.AccessibilitySupport=void 0;var E;(function(r){r[r.Unknown=0]="Unknown",r[r.Disabled=1]="Disabled",r[r.Enabled=2]="Enabled"})(E=n.AccessibilitySupport||(n.AccessibilitySupport={}));var t;(function(r){r[r.Invoke=1]="Invoke",r[r.Auto=2]="Auto"})(t=n.CodeActionTriggerType||(n.CodeActionTriggerType={}));var D;(function(r){r[r.KeepWhitespace=1]="KeepWhitespace",r[r.InsertAsSnippet=4]="InsertAsSnippet"})(D=n.CompletionItemInsertTextRule||(n.CompletionItemInsertTextRule={}));var c;(function(r){r[r.Method=0]="Method",r[r.Function=1]="Function",r[r.Constructor=2]="Constructor",r[r.Field=3]="Field",r[r.Variable=4]="Variable",r[r.Class=5]="Class",r[r.Struct=6]="Struct",r[r.Interface=7]="Interface",r[r.Module=8]="Module",r[r.Property=9]="Property",r[r.Event=10]="Event",r[r.Operator=11]="Operator",r[r.Unit=12]="Unit",r[r.Value=13]="Value",r[r.Constant=14]="Constant",r[r.Enum=15]="Enum",r[r.EnumMember=16]="EnumMember",r[r.Keyword=17]="Keyword",r[r.Text=18]="Text",r[r.Color=19]="Color",r[r.File=20]="File",r[r.Reference=21]="Reference",r[r.Customcolor=22]="Customcolor",r[r.Folder=23]="Folder",r[r.TypeParameter=24]="TypeParameter",r[r.User=25]="User",r[r.Issue=26]="Issue",r[r.Snippet=27]="Snippet"})(c=n.CompletionItemKind||(n.CompletionItemKind={}));var _;(function(r){r[r.Deprecated=1]="Deprecated"})(_=n.CompletionItemTag||(n.CompletionItemTag={}));var h;(function(r){r[r.Invoke=0]="Invoke",r[r.TriggerCharacter=1]="TriggerCharacter",r[r.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(h=n.CompletionTriggerKind||(n.CompletionTriggerKind={}));var l;(function(r){r[r.EXACT=0]="EXACT",r[r.ABOVE=1]="ABOVE",r[r.BELOW=2]="BELOW"})(l=n.ContentWidgetPositionPreference||(n.ContentWidgetPositionPreference={}));var f;(function(r){r[r.NotSet=0]="NotSet",r[r.ContentFlush=1]="ContentFlush",r[r.RecoverFromMarkers=2]="RecoverFromMarkers",r[r.Explicit=3]="Explicit",r[r.Paste=4]="Paste",r[r.Undo=5]="Undo",r[r.Redo=6]="Redo"})(f=n.CursorChangeReason||(n.CursorChangeReason={}));var A;(function(r){r[r.LF=1]="LF",r[r.CRLF=2]="CRLF"})(A=n.DefaultEndOfLine||(n.DefaultEndOfLine={}));var R;(function(r){r[r.Text=0]="Text",r[r.Read=1]="Read",r[r.Write=2]="Write"})(R=n.DocumentHighlightKind||(n.DocumentHighlightKind={}));var p;(function(r){r[r.None=0]="None",r[r.Keep=1]="Keep",r[r.Brackets=2]="Brackets",r[r.Advanced=3]="Advanced",r[r.Full=4]="Full"})(p=n.EditorAutoIndentStrategy||(n.EditorAutoIndentStrategy={}));var m;(function(r){r[r.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",r[r.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",r[r.accessibilitySupport=2]="accessibilitySupport",r[r.accessibilityPageSize=3]="accessibilityPageSize",r[r.ariaLabel=4]="ariaLabel",r[r.autoClosingBrackets=5]="autoClosingBrackets",r[r.autoClosingDelete=6]="autoClosingDelete",r[r.autoClosingOvertype=7]="autoClosingOvertype",r[r.autoClosingQuotes=8]="autoClosingQuotes",r[r.autoIndent=9]="autoIndent",r[r.automaticLayout=10]="automaticLayout",r[r.autoSurround=11]="autoSurround",r[r.bracketPairColorization=12]="bracketPairColorization",r[r.guides=13]="guides",r[r.codeLens=14]="codeLens",r[r.codeLensFontFamily=15]="codeLensFontFamily",r[r.codeLensFontSize=16]="codeLensFontSize",r[r.colorDecorators=17]="colorDecorators",r[r.columnSelection=18]="columnSelection",r[r.comments=19]="comments",r[r.contextmenu=20]="contextmenu",r[r.copyWithSyntaxHighlighting=21]="copyWithSyntaxHighlighting",r[r.cursorBlinking=22]="cursorBlinking",r[r.cursorSmoothCaretAnimation=23]="cursorSmoothCaretAnimation",r[r.cursorStyle=24]="cursorStyle",r[r.cursorSurroundingLines=25]="cursorSurroundingLines",r[r.cursorSurroundingLinesStyle=26]="cursorSurroundingLinesStyle",r[r.cursorWidth=27]="cursorWidth",r[r.disableLayerHinting=28]="disableLayerHinting",r[r.disableMonospaceOptimizations=29]="disableMonospaceOptimizations",r[r.domReadOnly=30]="domReadOnly",r[r.dragAndDrop=31]="dragAndDrop",r[r.dropIntoEditor=32]="dropIntoEditor",r[r.emptySelectionClipboard=33]="emptySelectionClipboard",r[r.extraEditorClassName=34]="extraEditorClassName",r[r.fastScrollSensitivity=35]="fastScrollSensitivity",r[r.find=36]="find",r[r.fixedOverflowWidgets=37]="fixedOverflowWidgets",r[r.folding=38]="folding",r[r.foldingStrategy=39]="foldingStrategy",r[r.foldingHighlight=40]="foldingHighlight",r[r.foldingImportsByDefault=41]="foldingImportsByDefault",r[r.foldingMaximumRegions=42]="foldingMaximumRegions",r[r.unfoldOnClickAfterEndOfLine=43]="unfoldOnClickAfterEndOfLine",r[r.fontFamily=44]="fontFamily",r[r.fontInfo=45]="fontInfo",r[r.fontLigatures=46]="fontLigatures",r[r.fontSize=47]="fontSize",r[r.fontWeight=48]="fontWeight",r[r.fontVariations=49]="fontVariations",r[r.formatOnPaste=50]="formatOnPaste",r[r.formatOnType=51]="formatOnType",r[r.glyphMargin=52]="glyphMargin",r[r.gotoLocation=53]="gotoLocation",r[r.hideCursorInOverviewRuler=54]="hideCursorInOverviewRuler",r[r.hover=55]="hover",r[r.inDiffEditor=56]="inDiffEditor",r[r.inlineSuggest=57]="inlineSuggest",r[r.letterSpacing=58]="letterSpacing",r[r.lightbulb=59]="lightbulb",r[r.lineDecorationsWidth=60]="lineDecorationsWidth",r[r.lineHeight=61]="lineHeight",r[r.lineNumbers=62]="lineNumbers",r[r.lineNumbersMinChars=63]="lineNumbersMinChars",r[r.linkedEditing=64]="linkedEditing",r[r.links=65]="links",r[r.matchBrackets=66]="matchBrackets",r[r.minimap=67]="minimap",r[r.mouseStyle=68]="mouseStyle",r[r.mouseWheelScrollSensitivity=69]="mouseWheelScrollSensitivity",r[r.mouseWheelZoom=70]="mouseWheelZoom",r[r.multiCursorMergeOverlapping=71]="multiCursorMergeOverlapping",r[r.multiCursorModifier=72]="multiCursorModifier",r[r.multiCursorPaste=73]="multiCursorPaste",r[r.multiCursorLimit=74]="multiCursorLimit",r[r.occurrencesHighlight=75]="occurrencesHighlight",r[r.overviewRulerBorder=76]="overviewRulerBorder",r[r.overviewRulerLanes=77]="overviewRulerLanes",r[r.padding=78]="padding",r[r.parameterHints=79]="parameterHints",r[r.peekWidgetDefaultFocus=80]="peekWidgetDefaultFocus",r[r.definitionLinkOpensInPeek=81]="definitionLinkOpensInPeek",r[r.quickSuggestions=82]="quickSuggestions",r[r.quickSuggestionsDelay=83]="quickSuggestionsDelay",r[r.readOnly=84]="readOnly",r[r.renameOnType=85]="renameOnType",r[r.renderControlCharacters=86]="renderControlCharacters",r[r.renderFinalNewline=87]="renderFinalNewline",r[r.renderLineHighlight=88]="renderLineHighlight",r[r.renderLineHighlightOnlyWhenFocus=89]="renderLineHighlightOnlyWhenFocus",r[r.renderValidationDecorations=90]="renderValidationDecorations",r[r.renderWhitespace=91]="renderWhitespace",r[r.revealHorizontalRightPadding=92]="revealHorizontalRightPadding",r[r.roundedSelection=93]="roundedSelection",r[r.rulers=94]="rulers",r[r.scrollbar=95]="scrollbar",r[r.scrollBeyondLastColumn=96]="scrollBeyondLastColumn",r[r.scrollBeyondLastLine=97]="scrollBeyondLastLine",r[r.scrollPredominantAxis=98]="scrollPredominantAxis",r[r.selectionClipboard=99]="selectionClipboard",r[r.selectionHighlight=100]="selectionHighlight",r[r.selectOnLineNumbers=101]="selectOnLineNumbers",r[r.showFoldingControls=102]="showFoldingControls",r[r.showUnused=103]="showUnused",r[r.snippetSuggestions=104]="snippetSuggestions",r[r.smartSelect=105]="smartSelect",r[r.smoothScrolling=106]="smoothScrolling",r[r.stickyScroll=107]="stickyScroll",r[r.stickyTabStops=108]="stickyTabStops",r[r.stopRenderingLineAfter=109]="stopRenderingLineAfter",r[r.suggest=110]="suggest",r[r.suggestFontSize=111]="suggestFontSize",r[r.suggestLineHeight=112]="suggestLineHeight",r[r.suggestOnTriggerCharacters=113]="suggestOnTriggerCharacters",r[r.suggestSelection=114]="suggestSelection",r[r.tabCompletion=115]="tabCompletion",r[r.tabIndex=116]="tabIndex",r[r.unicodeHighlighting=117]="unicodeHighlighting",r[r.unusualLineTerminators=118]="unusualLineTerminators",r[r.useShadowDOM=119]="useShadowDOM",r[r.useTabStops=120]="useTabStops",r[r.wordBreak=121]="wordBreak",r[r.wordSeparators=122]="wordSeparators",r[r.wordWrap=123]="wordWrap",r[r.wordWrapBreakAfterCharacters=124]="wordWrapBreakAfterCharacters",r[r.wordWrapBreakBeforeCharacters=125]="wordWrapBreakBeforeCharacters",r[r.wordWrapColumn=126]="wordWrapColumn",r[r.wordWrapOverride1=127]="wordWrapOverride1",r[r.wordWrapOverride2=128]="wordWrapOverride2",r[r.wrappingIndent=129]="wrappingIndent",r[r.wrappingStrategy=130]="wrappingStrategy",r[r.showDeprecated=131]="showDeprecated",r[r.inlayHints=132]="inlayHints",r[r.editorClassName=133]="editorClassName",r[r.pixelRatio=134]="pixelRatio",r[r.tabFocusMode=135]="tabFocusMode",r[r.layoutInfo=136]="layoutInfo",r[r.wrappingInfo=137]="wrappingInfo"})(m=n.EditorOption||(n.EditorOption={}));var e;(function(r){r[r.TextDefined=0]="TextDefined",r[r.LF=1]="LF",r[r.CRLF=2]="CRLF"})(e=n.EndOfLinePreference||(n.EndOfLinePreference={}));var C;(function(r){r[r.LF=0]="LF",r[r.CRLF=1]="CRLF"})(C=n.EndOfLineSequence||(n.EndOfLineSequence={}));var F;(function(r){r[r.None=0]="None",r[r.Indent=1]="Indent",r[r.IndentOutdent=2]="IndentOutdent",r[r.Outdent=3]="Outdent"})(F=n.IndentAction||(n.IndentAction={}));var y;(function(r){r[r.Both=0]="Both",r[r.Right=1]="Right",r[r.Left=2]="Left",r[r.None=3]="None"})(y=n.InjectedTextCursorStops||(n.InjectedTextCursorStops={}));var L;(function(r){r[r.Type=1]="Type",r[r.Parameter=2]="Parameter"})(L=n.InlayHintKind||(n.InlayHintKind={}));var s;(function(r){r[r.Automatic=0]="Automatic",r[r.Explicit=1]="Explicit"})(s=n.InlineCompletionTriggerKind||(n.InlineCompletionTriggerKind={}));var a;(function(r){r[r.DependsOnKbLayout=-1]="DependsOnKbLayout",r[r.Unknown=0]="Unknown",r[r.Backspace=1]="Backspace",r[r.Tab=2]="Tab",r[r.Enter=3]="Enter",r[r.Shift=4]="Shift",r[r.Ctrl=5]="Ctrl",r[r.Alt=6]="Alt",r[r.PauseBreak=7]="PauseBreak",r[r.CapsLock=8]="CapsLock",r[r.Escape=9]="Escape",r[r.Space=10]="Space",r[r.PageUp=11]="PageUp",r[r.PageDown=12]="PageDown",r[r.End=13]="End",r[r.Home=14]="Home",r[r.LeftArrow=15]="LeftArrow",r[r.UpArrow=16]="UpArrow",r[r.RightArrow=17]="RightArrow",r[r.DownArrow=18]="DownArrow",r[r.Insert=19]="Insert",r[r.Delete=20]="Delete",r[r.Digit0=21]="Digit0",r[r.Digit1=22]="Digit1",r[r.Digit2=23]="Digit2",r[r.Digit3=24]="Digit3",r[r.Digit4=25]="Digit4",r[r.Digit5=26]="Digit5",r[r.Digit6=27]="Digit6",r[r.Digit7=28]="Digit7",r[r.Digit8=29]="Digit8",r[r.Digit9=30]="Digit9",r[r.KeyA=31]="KeyA",r[r.KeyB=32]="KeyB",r[r.KeyC=33]="KeyC",r[r.KeyD=34]="KeyD",r[r.KeyE=35]="KeyE",r[r.KeyF=36]="KeyF",r[r.KeyG=37]="KeyG",r[r.KeyH=38]="KeyH",r[r.KeyI=39]="KeyI",r[r.KeyJ=40]="KeyJ",r[r.KeyK=41]="KeyK",r[r.KeyL=42]="KeyL",r[r.KeyM=43]="KeyM",r[r.KeyN=44]="KeyN",r[r.KeyO=45]="KeyO",r[r.KeyP=46]="KeyP",r[r.KeyQ=47]="KeyQ",r[r.KeyR=48]="KeyR",r[r.KeyS=49]="KeyS",r[r.KeyT=50]="KeyT",r[r.KeyU=51]="KeyU",r[r.KeyV=52]="KeyV",r[r.KeyW=53]="KeyW",r[r.KeyX=54]="KeyX",r[r.KeyY=55]="KeyY",r[r.KeyZ=56]="KeyZ",r[r.Meta=57]="Meta",r[r.ContextMenu=58]="ContextMenu",r[r.F1=59]="F1",r[r.F2=60]="F2",r[r.F3=61]="F3",r[r.F4=62]="F4",r[r.F5=63]="F5",r[r.F6=64]="F6",r[r.F7=65]="F7",r[r.F8=66]="F8",r[r.F9=67]="F9",r[r.F10=68]="F10",r[r.F11=69]="F11",r[r.F12=70]="F12",r[r.F13=71]="F13",r[r.F14=72]="F14",r[r.F15=73]="F15",r[r.F16=74]="F16",r[r.F17=75]="F17",r[r.F18=76]="F18",r[r.F19=77]="F19",r[r.NumLock=78]="NumLock",r[r.ScrollLock=79]="ScrollLock",r[r.Semicolon=80]="Semicolon",r[r.Equal=81]="Equal",r[r.Comma=82]="Comma",r[r.Minus=83]="Minus",r[r.Period=84]="Period",r[r.Slash=85]="Slash",r[r.Backquote=86]="Backquote",r[r.BracketLeft=87]="BracketLeft",r[r.Backslash=88]="Backslash",r[r.BracketRight=89]="BracketRight",r[r.Quote=90]="Quote",r[r.OEM_8=91]="OEM_8",r[r.IntlBackslash=92]="IntlBackslash",r[r.Numpad0=93]="Numpad0",r[r.Numpad1=94]="Numpad1",r[r.Numpad2=95]="Numpad2",r[r.Numpad3=96]="Numpad3",r[r.Numpad4=97]="Numpad4",r[r.Numpad5=98]="Numpad5",r[r.Numpad6=99]="Numpad6",r[r.Numpad7=100]="Numpad7",r[r.Numpad8=101]="Numpad8",r[r.Numpad9=102]="Numpad9",r[r.NumpadMultiply=103]="NumpadMultiply",r[r.NumpadAdd=104]="NumpadAdd",r[r.NUMPAD_SEPARATOR=105]="NUMPAD_SEPARATOR",r[r.NumpadSubtract=106]="NumpadSubtract",r[r.NumpadDecimal=107]="NumpadDecimal",r[r.NumpadDivide=108]="NumpadDivide",r[r.KEY_IN_COMPOSITION=109]="KEY_IN_COMPOSITION",r[r.ABNT_C1=110]="ABNT_C1",r[r.ABNT_C2=111]="ABNT_C2",r[r.AudioVolumeMute=112]="AudioVolumeMute",r[r.AudioVolumeUp=113]="AudioVolumeUp",r[r.AudioVolumeDown=114]="AudioVolumeDown",r[r.BrowserSearch=115]="BrowserSearch",r[r.BrowserHome=116]="BrowserHome",r[r.BrowserBack=117]="BrowserBack",r[r.BrowserForward=118]="BrowserForward",r[r.MediaTrackNext=119]="MediaTrackNext",r[r.MediaTrackPrevious=120]="MediaTrackPrevious",r[r.MediaStop=121]="MediaStop",r[r.MediaPlayPause=122]="MediaPlayPause",r[r.LaunchMediaPlayer=123]="LaunchMediaPlayer",r[r.LaunchMail=124]="LaunchMail",r[r.LaunchApp2=125]="LaunchApp2",r[r.Clear=126]="Clear",r[r.MAX_VALUE=127]="MAX_VALUE"})(a=n.KeyCode||(n.KeyCode={}));var i;(function(r){r[r.Hint=1]="Hint",r[r.Info=2]="Info",r[r.Warning=4]="Warning",r[r.Error=8]="Error"})(i=n.MarkerSeverity||(n.MarkerSeverity={}));var o;(function(r){r[r.Unnecessary=1]="Unnecessary",r[r.Deprecated=2]="Deprecated"})(o=n.MarkerTag||(n.MarkerTag={}));var u;(function(r){r[r.Inline=1]="Inline",r[r.Gutter=2]="Gutter"})(u=n.MinimapPosition||(n.MinimapPosition={}));var d;(function(r){r[r.UNKNOWN=0]="UNKNOWN",r[r.TEXTAREA=1]="TEXTAREA",r[r.GUTTER_GLYPH_MARGIN=2]="GUTTER_GLYPH_MARGIN",r[r.GUTTER_LINE_NUMBERS=3]="GUTTER_LINE_NUMBERS",r[r.GUTTER_LINE_DECORATIONS=4]="GUTTER_LINE_DECORATIONS",r[r.GUTTER_VIEW_ZONE=5]="GUTTER_VIEW_ZONE",r[r.CONTENT_TEXT=6]="CONTENT_TEXT",r[r.CONTENT_EMPTY=7]="CONTENT_EMPTY",r[r.CONTENT_VIEW_ZONE=8]="CONTENT_VIEW_ZONE",r[r.CONTENT_WIDGET=9]="CONTENT_WIDGET",r[r.OVERVIEW_RULER=10]="OVERVIEW_RULER",r[r.SCROLLBAR=11]="SCROLLBAR",r[r.OVERLAY_WIDGET=12]="OVERLAY_WIDGET",r[r.OUTSIDE_EDITOR=13]="OUTSIDE_EDITOR"})(d=n.MouseTargetType||(n.MouseTargetType={}));var g;(function(r){r[r.TOP_RIGHT_CORNER=0]="TOP_RIGHT_CORNER",r[r.BOTTOM_RIGHT_CORNER=1]="BOTTOM_RIGHT_CORNER",r[r.TOP_CENTER=2]="TOP_CENTER"})(g=n.OverlayWidgetPositionPreference||(n.OverlayWidgetPositionPreference={}));var N;(function(r){r[r.Left=1]="Left",r[r.Center=2]="Center",r[r.Right=4]="Right",r[r.Full=7]="Full"})(N=n.OverviewRulerLane||(n.OverviewRulerLane={}));var b;(function(r){r[r.Left=0]="Left",r[r.Right=1]="Right",r[r.None=2]="None",r[r.LeftOfInjectedText=3]="LeftOfInjectedText",r[r.RightOfInjectedText=4]="RightOfInjectedText"})(b=n.PositionAffinity||(n.PositionAffinity={}));var w;(function(r){r[r.Off=0]="Off",r[r.On=1]="On",r[r.Relative=2]="Relative",r[r.Interval=3]="Interval",r[r.Custom=4]="Custom"})(w=n.RenderLineNumbersType||(n.RenderLineNumbersType={}));var v;(function(r){r[r.None=0]="None",r[r.Text=1]="Text",r[r.Blocks=2]="Blocks"})(v=n.RenderMinimap||(n.RenderMinimap={}));var M;(function(r){r[r.Smooth=0]="Smooth",r[r.Immediate=1]="Immediate"})(M=n.ScrollType||(n.ScrollType={}));var I;(function(r){r[r.Auto=1]="Auto",r[r.Hidden=2]="Hidden",r[r.Visible=3]="Visible"})(I=n.ScrollbarVisibility||(n.ScrollbarVisibility={}));var O;(function(r){r[r.LTR=0]="LTR",r[r.RTL=1]="RTL"})(O=n.SelectionDirection||(n.SelectionDirection={}));var q;(function(r){r[r.Invoke=1]="Invoke",r[r.TriggerCharacter=2]="TriggerCharacter",r[r.ContentChange=3]="ContentChange"})(q=n.SignatureHelpTriggerKind||(n.SignatureHelpTriggerKind={}));var $;(function(r){r[r.File=0]="File",r[r.Module=1]="Module",r[r.Namespace=2]="Namespace",r[r.Package=3]="Package",r[r.Class=4]="Class",r[r.Method=5]="Method",r[r.Property=6]="Property",r[r.Field=7]="Field",r[r.Constructor=8]="Constructor",r[r.Enum=9]="Enum",r[r.Interface=10]="Interface",r[r.Function=11]="Function",r[r.Variable=12]="Variable",r[r.Constant=13]="Constant",r[r.String=14]="String",r[r.Number=15]="Number",r[r.Boolean=16]="Boolean",r[r.Array=17]="Array",r[r.Object=18]="Object",r[r.Key=19]="Key",r[r.Null=20]="Null",r[r.EnumMember=21]="EnumMember",r[r.Struct=22]="Struct",r[r.Event=23]="Event",r[r.Operator=24]="Operator",r[r.TypeParameter=25]="TypeParameter"})($=n.SymbolKind||(n.SymbolKind={}));var j;(function(r){r[r.Deprecated=1]="Deprecated"})(j=n.SymbolTag||(n.SymbolTag={}));var ne;(function(r){r[r.Hidden=0]="Hidden",r[r.Blink=1]="Blink",r[r.Smooth=2]="Smooth",r[r.Phase=3]="Phase",r[r.Expand=4]="Expand",r[r.Solid=5]="Solid"})(ne=n.TextEditorCursorBlinkingStyle||(n.TextEditorCursorBlinkingStyle={}));var te;(function(r){r[r.Line=1]="Line",r[r.Block=2]="Block",r[r.Underline=3]="Underline",r[r.LineThin=4]="LineThin",r[r.BlockOutline=5]="BlockOutline",r[r.UnderlineThin=6]="UnderlineThin"})(te=n.TextEditorCursorStyle||(n.TextEditorCursorStyle={}));var Q;(function(r){r[r.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",r[r.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",r[r.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",r[r.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(Q=n.TrackedRangeStickiness||(n.TrackedRangeStickiness={}));var J;(function(r){r[r.None=0]="None",r[r.Same=1]="Same",r[r.Indent=2]="Indent",r[r.DeepIndent=3]="DeepIndent"})(J=n.WrappingIndent||(n.WrappingIndent={}))}),Z(K[50],x([0,1,8,7]),function(B,n,E,t){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.TokenizationRegistry=void 0;class D{constructor(){this.a=new Map,this.b=new Map,this.c=new E.Emitter,this.onDidChange=this.c.event,this.d=null}fire(h){this.c.fire({changedLanguages:h,changedColorMap:!1})}register(h,l){return this.a.set(h,l),this.fire([h]),(0,t.toDisposable)(()=>{this.a.get(h)===l&&(this.a.delete(h),this.fire([h]))})}registerFactory(h,l){this.b.get(h)?.dispose();const f=new c(this,h,l);return this.b.set(h,f),(0,t.toDisposable)(()=>{const A=this.b.get(h);!A||A!==f||(this.b.delete(h),A.dispose())})}async getOrCreate(h){const l=this.get(h);if(l)return l;const f=this.b.get(h);return!f||f.isResolved?null:(await f.resolve(),this.get(h))}get(h){return this.a.get(h)||null}isResolved(h){if(this.get(h))return!0;const f=this.b.get(h);return!!(!f||f.isResolved)}setColorMap(h){this.d=h,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>2?this.d[2]:null}}n.TokenizationRegistry=D;class c extends t.Disposable{get isResolved(){return this.c}constructor(h,l,f){super(),this.f=h,this.g=l,this.h=f,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.i()),this.b}async i(){const h=await Promise.resolve(this.h.createTokenizationSupport());this.c=!0,h&&!this.a&&this.B(this.f.register(this.g,h))}}}),Z(K[51],x([0,1,24,12,2,50]),function(B,n,E,t,D,c){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.ExternalUriOpenerPriority=n.TokenizationRegistry=n.InlayHintKind=n.CommentMode=n.CommentThreadState=n.CommentThreadCollapsibleState=n.Command=n.FoldingRangeKind=n.SymbolKinds=n.SymbolTag=n.SymbolKind=n.isLocationLink=n.DocumentHighlightKind=n.SignatureHelpTriggerKind=n.CodeActionTriggerType=n.InlineCompletionTriggerKind=n.CompletionTriggerKind=n.CompletionItemInsertTextRule=n.CompletionItemTag=n.CompletionItemKinds=n.CompletionItemKind=n.EncodedTokenizationResult=n.TokenizationResult=n.Token=void 0;class _{constructor(M,I,O){this._tokenBrand=void 0,this.offset=M,this.type=I,this.language=O}toString(){return"("+this.offset+", "+this.type+")"}}n.Token=_;class h{constructor(M,I){this._tokenizationResultBrand=void 0,this.tokens=M,this.endState=I}}n.TokenizationResult=h;class l{constructor(M,I){this._encodedTokenizationResultBrand=void 0,this.tokens=M,this.endState=I}}n.EncodedTokenizationResult=l;var f;(function(v){v[v.Method=0]="Method",v[v.Function=1]="Function",v[v.Constructor=2]="Constructor",v[v.Field=3]="Field",v[v.Variable=4]="Variable",v[v.Class=5]="Class",v[v.Struct=6]="Struct",v[v.Interface=7]="Interface",v[v.Module=8]="Module",v[v.Property=9]="Property",v[v.Event=10]="Event",v[v.Operator=11]="Operator",v[v.Unit=12]="Unit",v[v.Value=13]="Value",v[v.Constant=14]="Constant",v[v.Enum=15]="Enum",v[v.EnumMember=16]="EnumMember",v[v.Keyword=17]="Keyword",v[v.Text=18]="Text",v[v.Color=19]="Color",v[v.File=20]="File",v[v.Reference=21]="Reference",v[v.Customcolor=22]="Customcolor",v[v.Folder=23]="Folder",v[v.TypeParameter=24]="TypeParameter",v[v.User=25]="User",v[v.Issue=26]="Issue",v[v.Snippet=27]="Snippet"})(f=n.CompletionItemKind||(n.CompletionItemKind={}));var A;(function(v){const M=new Map;M.set(0,E.Codicon.symbolMethod),M.set(1,E.Codicon.symbolFunction),M.set(2,E.Codicon.symbolConstructor),M.set(3,E.Codicon.symbolField),M.set(4,E.Codicon.symbolVariable),M.set(5,E.Codicon.symbolClass),M.set(6,E.Codicon.symbolStruct),M.set(7,E.Codicon.symbolInterface),M.set(8,E.Codicon.symbolModule),M.set(9,E.Codicon.symbolProperty),M.set(10,E.Codicon.symbolEvent),M.set(11,E.Codicon.symbolOperator),M.set(12,E.Codicon.symbolUnit),M.set(13,E.Codicon.symbolValue),M.set(15,E.Codicon.symbolEnum),M.set(14,E.Codicon.symbolConstant),M.set(15,E.Codicon.symbolEnum),M.set(16,E.Codicon.symbolEnumMember),M.set(17,E.Codicon.symbolKeyword),M.set(27,E.Codicon.symbolSnippet),M.set(18,E.Codicon.symbolText),M.set(19,E.Codicon.symbolColor),M.set(20,E.Codicon.symbolFile),M.set(21,E.Codicon.symbolReference),M.set(22,E.Codicon.symbolCustomColor),M.set(23,E.Codicon.symbolFolder),M.set(24,E.Codicon.symbolTypeParameter),M.set(25,E.Codicon.account),M.set(26,E.Codicon.issues);function I($){let j=M.get($);return j||(console.info("No codicon found for CompletionItemKind "+$),j=E.Codicon.symbolProperty),j}v.toIcon=I;const O=new Map;O.set("method",0),O.set("function",1),O.set("constructor",2),O.set("field",3),O.set("variable",4),O.set("class",5),O.set("struct",6),O.set("interface",7),O.set("module",8),O.set("property",9),O.set("event",10),O.set("operator",11),O.set("unit",12),O.set("value",13),O.set("constant",14),O.set("enum",15),O.set("enum-member",16),O.set("enumMember",16),O.set("keyword",17),O.set("snippet",27),O.set("text",18),O.set("color",19),O.set("file",20),O.set("reference",21),O.set("customcolor",22),O.set("folder",23),O.set("type-parameter",24),O.set("typeParameter",24),O.set("account",25),O.set("issue",26);function q($,j){let ne=O.get($);return typeof ne>"u"&&!j&&(ne=9),ne}v.fromString=q})(A=n.CompletionItemKinds||(n.CompletionItemKinds={}));var R;(function(v){v[v.Deprecated=1]="Deprecated"})(R=n.CompletionItemTag||(n.CompletionItemTag={}));var p;(function(v){v[v.KeepWhitespace=1]="KeepWhitespace",v[v.InsertAsSnippet=4]="InsertAsSnippet"})(p=n.CompletionItemInsertTextRule||(n.CompletionItemInsertTextRule={}));var m;(function(v){v[v.Invoke=0]="Invoke",v[v.TriggerCharacter=1]="TriggerCharacter",v[v.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(m=n.CompletionTriggerKind||(n.CompletionTriggerKind={}));var e;(function(v){v[v.Automatic=0]="Automatic",v[v.Explicit=1]="Explicit"})(e=n.InlineCompletionTriggerKind||(n.InlineCompletionTriggerKind={}));var C;(function(v){v[v.Invoke=1]="Invoke",v[v.Auto=2]="Auto"})(C=n.CodeActionTriggerType||(n.CodeActionTriggerType={}));var F;(function(v){v[v.Invoke=1]="Invoke",v[v.TriggerCharacter=2]="TriggerCharacter",v[v.ContentChange=3]="ContentChange"})(F=n.SignatureHelpTriggerKind||(n.SignatureHelpTriggerKind={}));var y;(function(v){v[v.Text=0]="Text",v[v.Read=1]="Read",v[v.Write=2]="Write"})(y=n.DocumentHighlightKind||(n.DocumentHighlightKind={}));function L(v){return v&&t.URI.isUri(v.uri)&&D.Range.isIRange(v.range)&&(D.Range.isIRange(v.originSelectionRange)||D.Range.isIRange(v.targetSelectionRange))}n.isLocationLink=L;var s;(function(v){v[v.File=0]="File",v[v.Module=1]="Module",v[v.Namespace=2]="Namespace",v[v.Package=3]="Package",v[v.Class=4]="Class",v[v.Method=5]="Method",v[v.Property=6]="Property",v[v.Field=7]="Field",v[v.Constructor=8]="Constructor",v[v.Enum=9]="Enum",v[v.Interface=10]="Interface",v[v.Function=11]="Function",v[v.Variable=12]="Variable",v[v.Constant=13]="Constant",v[v.String=14]="String",v[v.Number=15]="Number",v[v.Boolean=16]="Boolean",v[v.Array=17]="Array",v[v.Object=18]="Object",v[v.Key=19]="Key",v[v.Null=20]="Null",v[v.EnumMember=21]="EnumMember",v[v.Struct=22]="Struct",v[v.Event=23]="Event",v[v.Operator=24]="Operator",v[v.TypeParameter=25]="TypeParameter"})(s=n.SymbolKind||(n.SymbolKind={}));var a;(function(v){v[v.Deprecated=1]="Deprecated"})(a=n.SymbolTag||(n.SymbolTag={}));var i;(function(v){const M=new Map;M.set(0,E.Codicon.symbolFile),M.set(1,E.Codicon.symbolModule),M.set(2,E.Codicon.symbolNamespace),M.set(3,E.Codicon.symbolPackage),M.set(4,E.Codicon.symbolClass),M.set(5,E.Codicon.symbolMethod),M.set(6,E.Codicon.symbolProperty),M.set(7,E.Codicon.symbolField),M.set(8,E.Codicon.symbolConstructor),M.set(9,E.Codicon.symbolEnum),M.set(10,E.Codicon.symbolInterface),M.set(11,E.Codicon.symbolFunction),M.set(12,E.Codicon.symbolVariable),M.set(13,E.Codicon.symbolConstant),M.set(14,E.Codicon.symbolString),M.set(15,E.Codicon.symbolNumber),M.set(16,E.Codicon.symbolBoolean),M.set(17,E.Codicon.symbolArray),M.set(18,E.Codicon.symbolObject),M.set(19,E.Codicon.symbolKey),M.set(20,E.Codicon.symbolNull),M.set(21,E.Codicon.symbolEnumMember),M.set(22,E.Codicon.symbolStruct),M.set(23,E.Codicon.symbolEvent),M.set(24,E.Codicon.symbolOperator),M.set(25,E.Codicon.symbolTypeParameter);function I(O){let q=M.get(O);return q||(console.info("No codicon found for SymbolKind "+O),q=E.Codicon.symbolProperty),q}v.toIcon=I})(i=n.SymbolKinds||(n.SymbolKinds={}));class o{constructor(M){this.value=M}}n.FoldingRangeKind=o,o.Comment=new o("comment"),o.Imports=new o("imports"),o.Region=new o("region");var u;(function(v){function M(I){return!I||typeof I!="object"?!1:typeof I.id=="string"&&typeof I.title=="string"}v.is=M})(u=n.Command||(n.Command={}));var d;(function(v){v[v.Collapsed=0]="Collapsed",v[v.Expanded=1]="Expanded"})(d=n.CommentThreadCollapsibleState||(n.CommentThreadCollapsibleState={}));var g;(function(v){v[v.Unresolved=0]="Unresolved",v[v.Resolved=1]="Resolved"})(g=n.CommentThreadState||(n.CommentThreadState={}));var N;(function(v){v[v.Editing=0]="Editing",v[v.Preview=1]="Preview"})(N=n.CommentMode||(n.CommentMode={}));var b;(function(v){v[v.Type=1]="Type",v[v.Parameter=2]="Parameter"})(b=n.InlayHintKind||(n.InlayHintKind={})),n.TokenizationRegistry=new c.TokenizationRegistry;var w;(function(v){v[v.None=0]="None",v[v.Option=1]="Option",v[v.Default=2]="Default",v[v.Preferred=3]="Preferred"})(w=n.ExternalUriOpenerPriority||(n.ExternalUriOpenerPriority={}))}),Z(K[52],x([0,1,17,8,27,12,3,2,34,51,49]),function(B,n,E,t,D,c,_,h,l,f,A){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.createMonacoBaseAPI=n.KeyMod=void 0;class R{static chord(e,C){return(0,D.KeyChord)(e,C)}}n.KeyMod=R,R.CtrlCmd=2048,R.Shift=1024,R.Alt=512,R.WinCtrl=256;function p(){return{editor:void 0,languages:void 0,CancellationTokenSource:E.CancellationTokenSource,Emitter:t.Emitter,KeyCode:A.KeyCode,KeyMod:R,Position:_.Position,Range:h.Range,Selection:l.Selection,SelectionDirection:A.SelectionDirection,MarkerSeverity:A.MarkerSeverity,MarkerTag:A.MarkerTag,Uri:c.URI,Token:f.Token}}n.createMonacoBaseAPI=p}),Z(K[55],x([0,1,18,5,12,3,2,46,21,42,43,52,16,48,23,41,11]),function(B,n,E,t,D,c,_,h,l,f,A,R,p,m,e,C,F){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.create=n.EditorSimpleWorker=void 0;class y extends h.MirrorTextModel{get uri(){return this.c}get eol(){return this.f}getValue(){return this.getText()}getLinesContent(){return this.d.slice(0)}getLineCount(){return this.d.length}getLineContent(i){return this.d[i-1]}getWordAtPosition(i,o){const u=(0,l.getWordAtText)(i.column,(0,l.ensureValidWordDefinition)(o),this.d[i.lineNumber-1],0);return u?new _.Range(i.lineNumber,u.startColumn,i.lineNumber,u.endColumn):null}getWordUntilPosition(i,o){const u=this.getWordAtPosition(i,o);return u?{word:this.d[i.lineNumber-1].substring(u.startColumn-1,i.column-1),startColumn:u.startColumn,endColumn:i.column}:{word:"",startColumn:i.column,endColumn:i.column}}words(i){const o=this.d,u=this.p.bind(this);let d=0,g="",N=0,b=[];return{*[Symbol.iterator](){for(;;)if(N<b.length){const w=g.substring(b[N].start,b[N].end);N+=1,yield w}else if(d<o.length)g=o[d],b=u(g,i),N=0,d+=1;else break}}}getLineWords(i,o){const u=this.d[i-1],d=this.p(u,o),g=[];for(const N of d)g.push({word:u.substring(N.start,N.end),startColumn:N.start+1,endColumn:N.end+1});return g}p(i,o){const u=[];let d;for(o.lastIndex=0;(d=o.exec(i))&&d[0].length!==0;)u.push({start:d.index,end:d.index+d[0].length});return u}getValueInRange(i){if(i=this.q(i),i.startLineNumber===i.endLineNumber)return this.d[i.startLineNumber-1].substring(i.startColumn-1,i.endColumn-1);const o=this.f,u=i.startLineNumber-1,d=i.endLineNumber-1,g=[];g.push(this.d[u].substring(i.startColumn-1));for(let N=u+1;N<d;N++)g.push(this.d[N]);return g.push(this.d[d].substring(0,i.endColumn-1)),g.join(o)}offsetAt(i){return i=this.r(i),this.k(),this.h.getPrefixSum(i.lineNumber-2)+(i.column-1)}positionAt(i){i=Math.floor(i),i=Math.max(0,i),this.k();const o=this.h.getIndexOf(i),u=this.d[o.index].length;return{lineNumber:1+o.index,column:1+Math.min(o.remainder,u)}}q(i){const o=this.r({lineNumber:i.startLineNumber,column:i.startColumn}),u=this.r({lineNumber:i.endLineNumber,column:i.endColumn});return o.lineNumber!==i.startLineNumber||o.column!==i.startColumn||u.lineNumber!==i.endLineNumber||u.column!==i.endColumn?{startLineNumber:o.lineNumber,startColumn:o.column,endLineNumber:u.lineNumber,endColumn:u.column}:i}r(i){if(!c.Position.isIPosition(i))throw new Error("bad position");let{lineNumber:o,column:u}=i,d=!1;if(o<1)o=1,u=1,d=!0;else if(o>this.d.length)o=this.d.length,u=this.d[o-1].length+1,d=!0;else{const g=this.d[o-1].length+1;u<1?(u=1,d=!0):u>g&&(u=g,d=!0)}return d?{lineNumber:o,column:u}:i}}class L{constructor(i,o){this.c=i,this.d=Object.create(null),this.f=o,this.g=null}dispose(){this.d=Object.create(null)}h(i){return this.d[i]}j(){const i=[];return Object.keys(this.d).forEach(o=>i.push(this.d[o])),i}acceptNewModel(i){this.d[i.url]=new y(D.URI.parse(i.url),i.lines,i.EOL,i.versionId)}acceptModelChanged(i,o){if(!this.d[i])return;this.d[i].onEvents(o)}acceptRemovedModel(i){!this.d[i]||delete this.d[i]}async computeUnicodeHighlights(i,o,u){const d=this.h(i);return d?m.UnicodeTextModelHighlighter.computeUnicodeHighlights(d,o,u):{ranges:[],hasMore:!1,ambiguousCharacterCount:0,invisibleCharacterCount:0,nonBasicAsciiCharacterCount:0}}async computeDiff(i,o,u,d){const g=this.h(i),N=this.h(o);return!g||!N?null:L.k(g,N,u,d)}static k(i,o,u,d){const g=d==="experimental"?C.linesDiffComputers.experimental:C.linesDiffComputers.smart,N=i.getLinesContent(),b=o.getLinesContent(),w=g.computeDiff(N,b,u);return{identical:w.changes.length>0?!1:this.l(i,o),quitEarly:w.quitEarly,changes:w.changes.map(M=>[M.originalRange.startLineNumber,M.originalRange.endLineNumberExclusive,M.modifiedRange.startLineNumber,M.modifiedRange.endLineNumberExclusive,M.innerChanges?.map(I=>[I.originalRange.startLineNumber,I.originalRange.startColumn,I.originalRange.endLineNumber,I.originalRange.endColumn,I.modifiedRange.startLineNumber,I.modifiedRange.startColumn,I.modifiedRange.endLineNumber,I.modifiedRange.endColumn])])}}static l(i,o){const u=i.getLineCount(),d=o.getLineCount();if(u!==d)return!1;for(let g=1;g<=u;g++){const N=i.getLineContent(g),b=o.getLineContent(g);if(N!==b)return!1}return!0}async computeDirtyDiff(i,o,u){const d=this.h(i),g=this.h(o);if(!d||!g)return null;const N=d.getLinesContent(),b=g.getLinesContent();return new e.DiffComputer(N,b,{shouldComputeCharChanges:!1,shouldPostProcessCharChanges:!1,shouldIgnoreTrimWhitespace:u,shouldMakePrettyDiff:!0,maxComputationTime:1e3}).computeDiff().changes}async computeMoreMinimalEdits(i,o){const u=this.h(i);if(!u)return o;const d=[];let g;o=o.slice(0).sort((N,b)=>{if(N.range&&b.range)return _.Range.compareRangesUsingStarts(N.range,b.range);const w=N.range?0:1,v=b.range?0:1;return w-v});for(let{range:N,text:b,eol:w}of o){if(typeof w=="number"&&(g=w),_.Range.isEmpty(N)&&!b)continue;const v=u.getValueInRange(N);if(b=b.replace(/\r\n|\n|\r/g,u.eol),v===b)continue;if(Math.max(b.length,v.length)>L.n){d.push({range:N,text:b});continue}const M=(0,E.stringDiff)(v,b,!1),I=u.offsetAt(_.Range.lift(N).getStartPosition());for(const O of M){const q=u.positionAt(I+O.originalStart),$=u.positionAt(I+O.originalStart+O.originalLength),j={text:b.substr(O.modifiedStart,O.modifiedLength),range:{startLineNumber:q.lineNumber,startColumn:q.column,endLineNumber:$.lineNumber,endColumn:$.column}};u.getValueInRange(j.range)!==j.text&&d.push(j)}}return typeof g=="number"&&d.push({eol:g,text:"",range:{startLineNumber:0,startColumn:0,endLineNumber:0,endColumn:0}}),d}async computeLinks(i){const o=this.h(i);return o?(0,f.computeLinks)(o):null}async textualSuggest(i,o,u,d){const g=new p.StopWatch(!0),N=new RegExp(u,d),b=new Set;e:for(const w of i){const v=this.h(w);if(!!v){for(const M of v.words(N))if(!(M===o||!isNaN(Number(M)))&&(b.add(M),b.size>L.o))break e}}return{words:Array.from(b),duration:g.elapsed()}}async computeWordRanges(i,o,u,d){const g=this.h(i);if(!g)return Object.create(null);const N=new RegExp(u,d),b=Object.create(null);for(let w=o.startLineNumber;w<o.endLineNumber;w++){const v=g.getLineWords(w,N);for(const M of v){if(!isNaN(Number(M.word)))continue;let I=b[M.word];I||(I=[],b[M.word]=I),I.push({startLineNumber:w,startColumn:M.startColumn,endLineNumber:w,endColumn:M.endColumn})}}return b}async navigateValueSet(i,o,u,d,g){const N=this.h(i);if(!N)return null;const b=new RegExp(d,g);o.startColumn===o.endColumn&&(o={startLineNumber:o.startLineNumber,startColumn:o.startColumn,endLineNumber:o.endLineNumber,endColumn:o.endColumn+1});const w=N.getValueInRange(o),v=N.getWordAtPosition({lineNumber:o.startLineNumber,column:o.startColumn},b);if(!v)return null;const M=N.getValueInRange(v);return A.BasicInplaceReplace.INSTANCE.navigateValueSet(o,w,v,M,u)}loadForeignModule(i,o,u){const d=(b,w)=>this.c.fhr(b,w),N={host:(0,F.createProxyObject)(u,d),getMirrorModels:()=>this.j()};return this.f?(this.g=this.f(N,o),Promise.resolve((0,F.getAllMethodNames)(this.g))):new Promise((b,w)=>{B([i],v=>{this.g=v.create(N,o),b((0,F.getAllMethodNames)(this.g))},w)})}fmr(i,o){if(!this.g||typeof this.g[i]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+i));try{return Promise.resolve(this.g[i].apply(this.g,o))}catch(u){return Promise.reject(u)}}}n.EditorSimpleWorker=L,L.n=1e5,L.o=1e4;function s(a){return new L(a,null)}n.create=s,typeof importScripts=="function"&&(t.globals.monaco=(0,R.createMonacoBaseAPI)())})}).call(this);

//# sourceMappingURL=workerMain.js.map
